/*
 *  AppDefs.cc
 */

#include "my_be.h"
#include <AppDefs.h>


static VALUE
rb_B_HAND_CURSOR()
{
  int len;
  VALUE vresult;

  len = B_HAND_CURSOR[0] * B_HAND_CURSOR[0]; // 16x16
  len *= B_HAND_CURSOR[1];                   // color depth
  len *= 2;                                  // mask data
  len = (len / 8) + 4;                       // bit to byte +4
  vresult = rb_str_new(reinterpret_cast<const char *>(B_HAND_CURSOR), len);
  return vresult;
}


static VALUE
rb_B_I_BEAM_CURSOR()
{
  int len;
  VALUE vresult;

  len = B_I_BEAM_CURSOR[0] * B_I_BEAM_CURSOR[0]; // 16x16
  len *= B_I_BEAM_CURSOR[1];                     // color depth
  len *= 2;                                      // mask data
  len = (len / 8) + 4;                           // bit to byte +4
  vresult = rb_str_new(reinterpret_cast<const char *>(B_I_BEAM_CURSOR), len);
  return vresult;
}


static VALUE
rb_B_CURSOR_SYSTEM_DEFAULT()
{
  VALUE vresult;
  vresult = ((B_CURSOR_SYSTEM_DEFAULT)
                ? Data_Wrap_Struct(cCursor, 0, 0,
                                   const_cast<BCursor *>(B_CURSOR_SYSTEM_DEFAULT))
                : Qnil);
  return vresult;
}


static VALUE
rb_B_CURSOR_I_BEAM()
{
  VALUE vresult;
  vresult = ((B_CURSOR_I_BEAM)
                ? Data_Wrap_Struct(cCursor, 0, 0,
                                   const_cast<BCursor *>(B_CURSOR_I_BEAM))
                : Qnil);
  return vresult;
}


void
Init_AppDefs()
{
  rb_define_const(mBe, "HAND_CURSOR", rb_B_HAND_CURSOR());
  rb_define_const(mBe, "I_BEAM_CURSOR", rb_B_I_BEAM_CURSOR());

  rb_define_const(mBe, "CURSOR_SYSTEM_DEFAULT", rb_B_CURSOR_SYSTEM_DEFAULT());
  rb_define_const(mBe, "CURSOR_I_BEAM", rb_B_CURSOR_I_BEAM());

  rb_define_const(mBe, "ABOUT_REQUESTED", ULONG2NUM(B_ABOUT_REQUESTED));
  rb_define_const(mBe, "WINDOW_ACTIVATED", ULONG2NUM(B_WINDOW_ACTIVATED));
  rb_define_const(mBe, "APP_ACTIVATED", ULONG2NUM(B_APP_ACTIVATED));
  rb_define_const(mBe, "ARGV_RECEIVED", ULONG2NUM(B_ARGV_RECEIVED));
  rb_define_const(mBe, "QUIT_REQUESTED", ULONG2NUM(B_QUIT_REQUESTED));
  rb_define_const(mBe, "CANCEL", ULONG2NUM(B_CANCEL));
  rb_define_const(mBe, "KEY_DOWN", ULONG2NUM(B_KEY_DOWN));
  rb_define_const(mBe, "KEY_UP", ULONG2NUM(B_KEY_UP));
  rb_define_const(mBe, "UNMAPPED_KEY_DOWN", ULONG2NUM(B_UNMAPPED_KEY_DOWN));
  rb_define_const(mBe, "UNMAPPED_KEY_UP", ULONG2NUM(B_UNMAPPED_KEY_UP));
  rb_define_const(mBe, "MODIFIERS_CHANGED", ULONG2NUM(B_MODIFIERS_CHANGED));
  rb_define_const(mBe, "MINIMIZE", ULONG2NUM(B_MINIMIZE));
  rb_define_const(mBe, "MOUSE_DOWN", ULONG2NUM(B_MOUSE_DOWN));
  rb_define_const(mBe, "MOUSE_MOVED", ULONG2NUM(B_MOUSE_MOVED));
  rb_define_const(mBe, "MOUSE_ENTER_EXIT", ULONG2NUM(B_MOUSE_ENTER_EXIT));
  rb_define_const(mBe, "MOUSE_UP", ULONG2NUM(B_MOUSE_UP));
  rb_define_const(mBe, "MOUSE_WHEEL_CHANGED", ULONG2NUM(B_MOUSE_WHEEL_CHANGED));
  rb_define_const(mBe, "OPEN_IN_WORKSPACE", ULONG2NUM(B_OPEN_IN_WORKSPACE));
  rb_define_const(mBe, "PRINTER_CHANGED", ULONG2NUM(B_PRINTER_CHANGED));
  rb_define_const(mBe, "PULSE", ULONG2NUM(B_PULSE));
  rb_define_const(mBe, "READY_TO_RUN", ULONG2NUM(B_READY_TO_RUN));
  rb_define_const(mBe, "REFS_RECEIVED", ULONG2NUM(B_REFS_RECEIVED));
  rb_define_const(mBe, "RELEASE_OVERLAY_LOCK", ULONG2NUM(B_RELEASE_OVERLAY_LOCK));
  rb_define_const(mBe, "ACQUIRE_OVERLAY_LOCK", ULONG2NUM(B_ACQUIRE_OVERLAY_LOCK));
  rb_define_const(mBe, "SCREEN_CHANGED", ULONG2NUM(B_SCREEN_CHANGED));
  rb_define_const(mBe, "VALUE_CHANGED", ULONG2NUM(B_VALUE_CHANGED));
  rb_define_const(mBe, "VIEW_MOVED", ULONG2NUM(B_VIEW_MOVED));
  rb_define_const(mBe, "VIEW_RESIZED", ULONG2NUM(B_VIEW_RESIZED));
  rb_define_const(mBe, "WINDOW_MOVED", ULONG2NUM(B_WINDOW_MOVED));
  rb_define_const(mBe, "WINDOW_RESIZED", ULONG2NUM(B_WINDOW_RESIZED));
  rb_define_const(mBe, "WORKSPACES_CHANGED", ULONG2NUM(B_WORKSPACES_CHANGED));
  rb_define_const(mBe, "WORKSPACE_ACTIVATED", ULONG2NUM(B_WORKSPACE_ACTIVATED));
  rb_define_const(mBe, "ZOOM", ULONG2NUM(B_ZOOM));

  rb_define_const(mBe, "SET_PROPERTY", ULONG2NUM(B_SET_PROPERTY));
  rb_define_const(mBe, "GET_PROPERTY", ULONG2NUM(B_GET_PROPERTY));
  rb_define_const(mBe, "CREATE_PROPERTY", ULONG2NUM(B_CREATE_PROPERTY));
  rb_define_const(mBe, "DELETE_PROPERTY", ULONG2NUM(B_DELETE_PROPERTY));
  rb_define_const(mBe, "COUNT_PROPERTIES", ULONG2NUM(B_COUNT_PROPERTIES));
  rb_define_const(mBe, "EXECUTE_PROPERTY", ULONG2NUM(B_EXECUTE_PROPERTY));
  rb_define_const(mBe, "GET_SUPPORTED_SUITES", ULONG2NUM(B_GET_SUPPORTED_SUITES));
  rb_define_const(mBe, "UNDO", ULONG2NUM(B_UNDO));
  rb_define_const(mBe, "CUT", ULONG2NUM(B_CUT));
  rb_define_const(mBe, "COPY", ULONG2NUM(B_COPY));
  rb_define_const(mBe, "PASTE", ULONG2NUM(B_PASTE));
  rb_define_const(mBe, "SELECT_ALL", ULONG2NUM(B_SELECT_ALL));
  rb_define_const(mBe, "SAVE_REQUESTED", ULONG2NUM(B_SAVE_REQUESTED));
  rb_define_const(mBe, "MESSAGE_NOT_UNDERSTOOD", ULONG2NUM(B_MESSAGE_NOT_UNDERSTOOD));
  rb_define_const(mBe, "NO_REPLY", ULONG2NUM(B_NO_REPLY));
  rb_define_const(mBe, "REPLY", ULONG2NUM(B_REPLY));
  rb_define_const(mBe, "SIMPLE_DATA", ULONG2NUM(B_SIMPLE_DATA));
  rb_define_const(mBe, "MIME_DATA", ULONG2NUM(B_MIME_DATA));
  rb_define_const(mBe, "ARCHIVED_OBJECT", ULONG2NUM(B_ARCHIVED_OBJECT));
  rb_define_const(mBe, "UPDATE_STATUS_BAR", ULONG2NUM(B_UPDATE_STATUS_BAR));
  rb_define_const(mBe, "RESET_STATUS_BAR", ULONG2NUM(B_RESET_STATUS_BAR));
  rb_define_const(mBe, "NODE_MONITOR", ULONG2NUM(B_NODE_MONITOR));
  rb_define_const(mBe, "QUERY_UPDATE", ULONG2NUM(B_QUERY_UPDATE));
  rb_define_const(mBe, "ENDORSABLE", ULONG2NUM(B_ENDORSABLE));
  rb_define_const(mBe, "COPY_TARGET", ULONG2NUM(B_COPY_TARGET));
  rb_define_const(mBe, "MOVE_TARGET", ULONG2NUM(B_MOVE_TARGET));
  rb_define_const(mBe, "TRASH_TARGET", ULONG2NUM(B_TRASH_TARGET));
  rb_define_const(mBe, "LINK_TARGET", ULONG2NUM(B_LINK_TARGET));
  rb_define_const(mBe, "INPUT_DEVICES_CHANGED", ULONG2NUM(B_INPUT_DEVICES_CHANGED));
  rb_define_const(mBe, "INPUT_METHOD_EVENT", ULONG2NUM(B_INPUT_METHOD_EVENT));
  rb_define_const(mBe, "WINDOW_MOVE_TO", ULONG2NUM(B_WINDOW_MOVE_TO));
  rb_define_const(mBe, "WINDOW_MOVE_BY", ULONG2NUM(B_WINDOW_MOVE_BY));
  rb_define_const(mBe, "SILENT_RELAUNCH", ULONG2NUM(B_SILENT_RELAUNCH));
  rb_define_const(mBe, "OBSERVER_NOTICE_CHANGE", ULONG2NUM(B_OBSERVER_NOTICE_CHANGE));
  rb_define_const(mBe, "CONTROL_INVOKED", ULONG2NUM(B_CONTROL_INVOKED));
  rb_define_const(mBe, "CONTROL_MODIFIED", ULONG2NUM(B_CONTROL_MODIFIED));
}
