/*
 *  Beep.cc
 */

#include <Beep.h>
#include "my_be.h"


static VALUE
rb_beep(VALUE self)
{
  status_t result;

  result = beep();
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}

static VALUE
rb_system_beep(VALUE self, VALUE varg1)
{
  char *arg1;
  status_t result;

  arg1 = STR2CSTR(varg1);
  result = system_beep(arg1);
/* -- ?
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
*/
  return Qnil;
}


static VALUE
rb_add_system_beep_event(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  status_t result;

  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        char *arg1;

        arg1 = STR2CSTR(varg1);
        result = add_system_beep_event(arg1);
      }
      break;

    case 2:
      {
        char *arg1;
        uint32 arg2;

        arg1 = STR2CSTR(varg1);
        arg2 = NUM2LONG(varg2);
        result = add_system_beep_event(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_add_system_beep_event");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


void
Init_Beep()
{
  rb_define_module_function(mBe, "beep", RUBY_METHOD_FUNC(rb_beep), 0);
  rb_define_module_function(mBe, "system_beep", RUBY_METHOD_FUNC(rb_system_beep), 1);
  rb_define_module_function(mBe, "add_system_beep_event", RUBY_METHOD_FUNC(rb_add_system_beep_event), -1);
}
