/*
 *  Button.cc
 */

#include "rbButton.h"
#include "my_be.h"


VALUE cButton;


void
delete_button(BButton *arg0)
{
  delete arg0;
}


static VALUE
rb_button_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_button);
  return vresult;
}


static VALUE
rb_button_initialize(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3, varg4, varg5, varg6;
  Button *result;

  Data_To_Null(self, BButton);

  if (argc > 1) {
    switch (rb_scan_args(argc, argv, "42", &varg1, &varg2, &varg3, &varg4, &varg5, &varg6)) {
      case 4:
        {
          BRect *arg1;
          char *arg2, *arg3;
          BMessage *arg4;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          arg3 = STR2CSTR(varg3);
          Get_BInstance(Message, varg4, arg4);
          result = new Button(*arg1, arg2, arg3, new BMessage(*arg4));
        }
        break;

      case 5:
        {
          BRect *arg1;
          char *arg2, *arg3;
          BMessage *arg4;
          uint32 arg5;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          arg3 = STR2CSTR(varg3);
          Get_BInstance(Message, varg4, arg4);
          arg5 = NUM2ULONG(varg5);
          result = new Button(*arg1, arg2, arg3, new BMessage(*arg4), arg5);
        }
        break;

      case 6:
        {
          BRect *arg1;
          char *arg2, *arg3;
          BMessage *arg4;
          uint32 arg5, arg6;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          arg3 = STR2CSTR(varg3);
          Get_BInstance(Message, varg4, arg4);
          arg5 = NUM2ULONG(varg5);
          arg6 = NUM2ULONG(varg6);
          result = new Button(*arg1, arg2, arg3, new BMessage(*arg4), arg5, arg6);
        }
        break;

      default:
        rb_bug("rb_button_initialize");
    }
  }
  else {
    BMessage *arg1;

    rb_scan_args(argc, argv, "1", &varg1);
    Get_BInstance(Message, varg1, arg1);
    result = new Button(arg1);
  }
  DATA_PTR(self) = result;
  result->myself = self;
  return self;
}


static VALUE
rb_button_Draw(VALUE self, VALUE varg1)
{
  BButton *arg0;
  BRect *arg1;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Rect, varg1, arg1);
  arg0->BButton::Draw(*arg1);
  return Qnil;
}


static VALUE
rb_button_MouseDown(VALUE self, VALUE varg1)
{
  BButton *arg0;
  BPoint *arg1;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->BButton::MouseDown(*arg1);
  return Qnil;
}


static VALUE
rb_button_AttachedToWindow(VALUE self)
{
  BButton *arg0;

  Get_BInstance(Button, self, arg0);
  arg0->BButton::AttachedToWindow();
  return Qnil;
}


static VALUE
rb_button_KeyDown(VALUE self, VALUE varg1)
{
  BButton *arg0;
  char *arg1;
  int arg2 = 0;

  Get_BInstance(Button, self, arg0);
  arg1 = rb_str2cstr(varg1, &arg2);
  arg0->BButton::KeyDown(arg1, arg2);
  return Qnil;
}



static VALUE
rb_button_MakeDefault(VALUE self, VALUE varg1)
{
  BButton *arg0;
  bool arg1;

  Get_BInstance(Button, self, arg0);
  arg1 = RTEST(varg1);
  arg0->BButton::MakeDefault(arg1);
  return Qnil;
}


static VALUE
rb_button_SetLabel(VALUE self, VALUE varg1)
{
  BButton *arg0;
  char *arg1;

  Get_BInstance(Button, self, arg0);
  arg1 = STR2CSTR(varg1);
  arg0->BButton::SetLabel(arg1);
  return Qnil;
}


static VALUE
rb_button_IsDefault(VALUE self)
{
  BButton *arg0;
  bool result;
  VALUE vresult;

  Get_BInstance(Button, self, arg0);
  result = arg0->IsDefault();
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_button_MessageReceived(VALUE self, VALUE varg1)
{
  BButton *arg0;
  BMessage *arg1;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  arg0->BButton::MessageReceived(arg1);
  return Qnil;
}


static VALUE
rb_button_WindowActivated(VALUE self, VALUE varg1)
{
  BButton *arg0;
  bool arg1;

  Get_BInstance(Button, self, arg0);
  arg1 = RTEST(varg1);
  arg0->BButton::WindowActivated(arg1);
  return Qnil;
}


static VALUE
rb_button_MouseUp(VALUE self, VALUE varg1)
{
  BButton *arg0;
  BPoint *arg1;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->BButton::MouseUp(*arg1);
  return Qnil;
}


static VALUE
rb_button_MouseMoved(VALUE self, VALUE varg1, VALUE varg2, VALUE varg3)
{
  BButton *arg0;
  BPoint *arg1;
  uint32 arg2;
  BMessage *arg3 = NULL;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg2 = NUM2ULONG(varg2);
  if (!NIL_P(varg3)) {
    Get_BInstance(Message, varg3, arg3);
  }
  arg0->BButton::MouseMoved(*arg1, arg2, arg3);
  return Qnil;
}


static VALUE
rb_button_DetachedFromWindow(VALUE self)
{
  BButton *arg0;

  Get_BInstance(Button, self, arg0);
  arg0->BButton::DetachedFromWindow();
  return Qnil;
}


static VALUE
rb_button_SetValue(VALUE self, VALUE varg1)
{
  BButton *arg0;
  int32 arg1;

  Get_BInstance(Button, self, arg0);
  arg1 = NUM2LONG(varg1);
  arg0->BButton::SetValue(arg1);
  return Qnil;
}


static VALUE
rb_button_GetPreferredSize(int argc, VALUE *argv, VALUE self)
{
  BButton *arg0;
  float arg1 = 0.0, arg2 = 0.0;
  VALUE vresult;

  Get_BInstance(Button, self, arg0);
  arg0->BButton::GetPreferredSize(&arg1, &arg2);
  vresult = rb_ary_new3(2, rb_float_new(arg1), rb_float_new(arg2));
  return vresult;
}


static VALUE
rb_button_ResizeToPreferred(VALUE self)
{
  BButton *arg0;

  Get_BInstance(Button, self, arg0);
  arg0->BButton::ResizeToPreferred();
  return Qnil;
}


static VALUE
rb_button_Invoke(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1;
  BButton *arg0;
  status_t result;

  Get_BInstance(Button, self, arg0);
  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      result = arg0->BButton::Invoke();
      break;

    case 1:
      {
        BMessage *arg1;

        Get_BInstance(Message, varg1, arg1);
        result = arg0->BButton::Invoke(arg1);
      }
      break;

    default:
      rb_bug("rb_button_Invoke");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_button_FrameMoved(VALUE self, VALUE varg1)
{
  BButton *arg0;
  BPoint *arg1;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->BButton::FrameMoved(*arg1);
  return Qnil;
}


static VALUE
rb_button_FrameResized(VALUE self, VALUE varg1, VALUE varg2)
{
  BButton *arg0;
  float arg1, arg2;

  Get_BInstance(Button, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg2 = NUM2DBL(varg2);
  arg0->BButton::FrameResized(arg1,arg2);
  return Qnil;
}


static VALUE
rb_button_MakeFocus(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1;
  BButton *arg0;

  Get_BInstance(Button, self, arg0);
  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      arg0->BButton::MakeFocus();
      break;

    case 1:
      {
        bool arg1;

        arg1 = RTEST(varg1);
        arg0->BButton::MakeFocus(arg1);
      }
      break;

    default:
      rb_bug("rb_button_MakeFocus");
  }
  return Qnil;
}


static VALUE
rb_button_AllAttached(VALUE self)
{
  BButton *arg0;

  Get_BInstance(Button, self, arg0);
  arg0->BButton::AllAttached();
  return Qnil;
}


static VALUE
rb_button_AllDetached(VALUE self)
{
  BButton *arg0;

  Get_BInstance(Button, self, arg0);
  arg0->BButton::AllDetached();
  return Qnil;
}


static VALUE
rb_button_ResolveSpecifier(VALUE self, VALUE varg1, VALUE varg2, VALUE varg3, VALUE varg4, VALUE varg5)
{
  BButton *arg0;
  BMessage *arg1,  *arg3;
  int32 arg2, arg4;
  char *arg5;
  BHandler *result;
  VALUE vresult;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  arg2 = NUM2LONG(varg2);
  Get_BInstance(Message, varg3, arg3);
  arg4 = NUM2LONG(varg4);
  arg5 = STR2CSTR(varg5);

  result = arg0->BButton::ResolveSpecifier(arg1, arg2, arg3, arg4, arg5);
  vresult = ((result) ? Data_Wrap_Struct(cHandler, 0, 0, result):Qnil);
  return vresult;
}


static VALUE
rb_button_GetSupportedSuites(VALUE self, VALUE varg1)
{
  BButton *arg0;
  BMessage *arg1;
  status_t result;
  VALUE vresult;

  Get_BInstance(Button, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  result = arg0->BButton::GetSupportedSuites(arg1);
  vresult = LONG2NUM(result);
  return vresult;
}


void
Init_Button()
{
  cButton = rb_define_class_under(mBe, "Button", cControl);
  rb_define_singleton_method(cButton, "new", RUBY_METHOD_FUNC(rb_button_s_new), -1);
  rb_define_method(cButton, "initialize", RUBY_METHOD_FUNC(rb_button_initialize), -1);

  rb_define_method(cButton, "Draw", RUBY_METHOD_FUNC(rb_button_Draw), 1);
  rb_define_method(cButton, "MouseDown", RUBY_METHOD_FUNC(rb_button_MouseDown), 1);
  rb_define_method(cButton, "AttachedToWindow", RUBY_METHOD_FUNC(rb_button_AttachedToWindow), 0);
  rb_define_method(cButton, "KeyDown", RUBY_METHOD_FUNC(rb_button_KeyDown), 1);
  rb_define_method(cButton, "MakeDefault", RUBY_METHOD_FUNC(rb_button_MakeDefault), 1);
  rb_define_method(cButton, "SetLabel", RUBY_METHOD_FUNC(rb_button_SetLabel), 1);
  rb_define_method(cButton, "IsDefault", RUBY_METHOD_FUNC(rb_button_IsDefault), 0);

  rb_define_method(cButton, "MessageReceived", RUBY_METHOD_FUNC(rb_button_MessageReceived), 1);
  rb_define_method(cButton, "WindowActivated", RUBY_METHOD_FUNC(rb_button_WindowActivated), 1);
  rb_define_method(cButton, "MouseUp", RUBY_METHOD_FUNC(rb_button_MouseUp), 1);
  rb_define_method(cButton, "MouseMoved", RUBY_METHOD_FUNC(rb_button_MouseMoved), 3);
  rb_define_method(cButton, "DetachedFromWindow", RUBY_METHOD_FUNC(rb_button_DetachedFromWindow), 0);
  rb_define_method(cButton, "SetValue", RUBY_METHOD_FUNC(rb_button_SetValue), 1);
  rb_define_method(cButton, "GetPreferredSize", RUBY_METHOD_FUNC(rb_button_GetPreferredSize), -1);
  rb_define_method(cButton, "ResizeToPreferred", RUBY_METHOD_FUNC(rb_button_ResizeToPreferred), 0);
  rb_define_method(cButton, "Invoke", RUBY_METHOD_FUNC(rb_button_Invoke), -1);
  rb_define_method(cButton, "FrameMoved", RUBY_METHOD_FUNC(rb_button_FrameMoved), 1);
  rb_define_method(cButton, "FrameResized", RUBY_METHOD_FUNC(rb_button_FrameResized), 2);

  rb_define_method(cButton, "MakeFocus", RUBY_METHOD_FUNC(rb_button_MakeFocus), -1);
  rb_define_method(cButton, "AllAttached", RUBY_METHOD_FUNC(rb_button_AllAttached), 0);
  rb_define_method(cButton, "AllDetached", RUBY_METHOD_FUNC(rb_button_AllDetached), 0);
  rb_define_method(cButton, "ResolveSpecifier", RUBY_METHOD_FUNC(rb_button_ResolveSpecifier), 5);
  rb_define_method(cButton, "GetSupportedSuites", RUBY_METHOD_FUNC(rb_button_GetSupportedSuites), 1);
}
