/*
 *  E-mail.cc
 */

#include <E-mail.h>
#include "my_be.h"


VALUE cMailMessage;


void
delete_mailmessage(BMailMessage *arg0)
{
  delete arg0;
}


static VALUE
rb_mailmessage_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_mailmessage);
  return vresult;
}


static VALUE
rb_mailmessage_initialize(VALUE self)
{
  BMailMessage *result;

  Data_To_Null(self, BMailMessage);
  result = my_create_be_obj<BMailMessage>();
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_mailmessage_AddContent(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3;
  BMailMessage *arg0;
  status_t result;

  Get_BInstance(MailMessage, self, arg0);
  switch (rb_scan_args(argc, argv, "12", &varg1, &varg2, &varg3)) {
    case 1:
      {
        char *arg1;
        int arg2 = 0;

        arg1 = rb_str2cstr(varg1, &arg2);
        result = arg0->AddContent(arg1, arg2);
      }
      break;

    case 2:
      if (STRING_P(varg2)) {
        char *arg1, *arg3;
        int arg2 = 0;

        arg1 = rb_str2cstr(varg1, &arg2);
        arg3 = STR2CSTR(varg2);
        result = arg0->AddContent(arg1, arg2, arg3);
      }
      else {
        char *arg1;
        int arg2 = 0;
        uint32 arg3;

        arg1 = rb_str2cstr(varg1, &arg2);
        arg3 = NUM2ULONG(varg2);
        result = arg0->AddContent(arg1, arg2, arg3);
      }
      break;

    case 3:
      if (STRING_P(varg2)) {
        char *arg1, *arg3;
        int arg2 = 0;
        bool arg4;

        arg1 = rb_str2cstr(varg1, &arg2);
        arg3 = STR2CSTR(varg2);
        arg4 = RTEST(varg3);
        result = arg0->AddContent(arg1, arg2, arg3, arg4);
      }
      else {
        char *arg1;
        int arg2 = 0;
        uint32 arg3;
        bool arg4;

        arg1 = rb_str2cstr(varg1, &arg2);
        arg3 = NUM2ULONG(varg2);
        arg4 = RTEST(varg3);
        result = arg0->AddContent(arg1, arg2, arg3, arg4);
      }
      break;

    default:
      rb_bug("rb_mailmessage_AddContent");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_mailmessage_AddEnclosure(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3;
  BMailMessage *arg0;
  status_t result;

  Get_BInstance(MailMessage, self, arg0);
  switch (rb_scan_args(argc, argv, "12", &varg1, &varg2, &varg3)) {
    case 1:
      if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
        entry_ref *arg1;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        result = arg0->AddEnclosure(arg1);
      }
      else {
        char *arg1;

        arg1 = STR2CSTR(varg1);
        result = arg0->AddEnclosure(arg1);
      }
      break;

    case 2:
      if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
        entry_ref *arg1;
        bool arg2;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg2 = RTEST(varg2);
        result = arg0->AddEnclosure(arg1, arg2);
      }
      else if (STRING_P(varg2)) {
        char *arg1, *arg2;
        int arg3 = 0;

        arg1 = STR2CSTR(varg1);
        arg2 = rb_str2cstr(varg2, &arg3);
        result = arg0->AddEnclosure(arg1, arg2, arg3);
      }
      else {
        char *arg1;
        bool arg2;

        arg1 = STR2CSTR(varg1);
        arg2 = RTEST(varg2);
        result = arg0->AddEnclosure(arg1, arg2);
      }
      break;

    case 3:
      {
        char *arg1, *arg2;
        int arg3 = 0;
        bool arg4;

        arg1 = STR2CSTR(varg1);
        arg2 = rb_str2cstr(varg2, &arg3);
        arg4 = RTEST(varg3);
        result = arg0->AddEnclosure(arg1, arg2, arg3, arg4);
      }
      break;

    default:
      rb_bug("rb_mailmessage_AddEnclosure");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_mailmessage_AddHeaderField(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3, varg4;
  BMailMessage *arg0;
  status_t result;

  Get_BInstance(MailMessage, self, arg0);
  switch (rb_scan_args(argc, argv, "22", &varg1, &varg2, &varg3, &varg4)) {
    case 2:
      {
        char *arg1, *arg2;

        arg1 = STR2CSTR(varg1);
        arg2 = STR2CSTR(varg2);
        result = arg0->AddHeaderField(arg1, arg2);
      }
      break;

    case 3:
      if (STRING_P(varg1)) {
        char *arg1, *arg2;
        bool arg3;

        arg1 = STR2CSTR(varg1);
        arg2 = STR2CSTR(varg2);
        arg3 = RTEST(varg3);
        result = arg0->AddHeaderField(arg1, arg2, arg3);
      }
      else {
        uint32 arg1;
        char *arg2, *arg3;

        arg1 = NUM2ULONG(varg1);
        arg2 = STR2CSTR(varg2);
        arg3 = STR2CSTR(varg3);
        result = arg0->AddHeaderField(arg1, arg2, arg3);
      }
      break;

    case 4:
      {
        uint32 arg1;
        char *arg2, *arg3;
        bool arg4;

        arg1 = NUM2ULONG(varg1);
        arg2 = STR2CSTR(varg2);
        arg3 = STR2CSTR(varg3);
        arg4 = RTEST(varg4);
        result = arg0->AddHeaderField(arg1, arg2, arg3, arg4);
      }
      break;

    default:
      rb_bug("rb_mailmessage_AddHeaderField");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_mailmessage_Send(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  BMailMessage *arg0;
  status_t result;

  Get_BInstance(MailMessage, self, arg0);
  switch (rb_scan_args(argc, argv, "02", &varg1, &varg2)) {
    case 0:
      result = arg0->Send();
      break;

    case 1:
      {
        bool arg1;

        arg1 = RTEST(varg1);
        result = arg0->Send(arg1);
      }
      break;

    case 2:
      {
        bool arg1, arg2;

        arg1 = RTEST(varg1);
        arg2 = RTEST(varg2);
        result = arg0->Send(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_mailmessage_Send");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_count_pop_accounts(VALUE self)
{
  int32 result;
  VALUE vresult;

  result = count_pop_accounts();
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
my_mail_pop_account2hash(mail_pop_account &acc)
{
  VALUE vresult = rb_hash_new();
  rb_hash_aset(vresult, rb_str_new2("pop_name"),     rb_str_new2(acc.pop_name));
  rb_hash_aset(vresult, rb_str_new2("pop_password"), rb_str_new2(acc.pop_password));
  rb_hash_aset(vresult, rb_str_new2("pop_host"),     rb_str_new2(acc.pop_host));
  rb_hash_aset(vresult, rb_str_new2("real_name"),    rb_str_new2(acc.real_name));
  rb_hash_aset(vresult, rb_str_new2("reply_to"),     rb_str_new2(acc.reply_to));
  rb_hash_aset(vresult, rb_str_new2("days"),         LONG2NUM(acc.days));
  rb_hash_aset(vresult, rb_str_new2("interval"),     LONG2NUM(acc.interval));
  rb_hash_aset(vresult, rb_str_new2("begin_time"),   LONG2NUM(acc.begin_time));
  rb_hash_aset(vresult, rb_str_new2("end_time"),     LONG2NUM(acc.end_time));
  return vresult;
}


static VALUE
rb_get_pop_account(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1;
  mail_pop_account arg1;
  status_t result;
  VALUE vresult;

  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      result = get_pop_account(&arg1);
      break;

    case 1:
      {
        int32 arg2;

        arg2 = NUM2LONG(varg1);
        result = get_pop_account(&arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_get_pop_account");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = my_mail_pop_account2hash(arg1);
  return vresult;
}


static mail_pop_account
my_hash2mail_pop_account(VALUE hash)
{
  mail_pop_account acc;
  char *pop_acc;
  int len = 0;

  Check_Type(hash, T_HASH);

  pop_acc = rb_str2cstr(rb_hash_aref(hash, rb_str_new2("pop_name")), &len);
  if (len >= B_MAX_USER_NAME_LENGTH) {
    len = B_MAX_USER_NAME_LENGTH - 1;
  }
  memcpy(acc.pop_name, pop_acc, len);
  acc.pop_name[len] = '\0';

  pop_acc = rb_str2cstr(rb_hash_aref(hash, rb_str_new2("pop_password")), &len);
  if (len >= B_MAX_USER_NAME_LENGTH) {
    len = B_MAX_USER_NAME_LENGTH - 1;
  }
  memcpy(acc.pop_password, pop_acc, len);
  acc.pop_password[len] = '\0';

  pop_acc = rb_str2cstr(rb_hash_aref(hash, rb_str_new2("pop_host")), &len);
  if (len >= B_MAX_HOST_NAME_LENGTH) {
    len = B_MAX_HOST_NAME_LENGTH - 1;
  }
  memcpy(acc.pop_host, pop_acc, len);
  acc.pop_host[len] = '\0';

  pop_acc = rb_str2cstr(rb_hash_aref(hash, rb_str_new2("real_name")), &len);
  if (len >= 128) {
    len = 128 - 1;
  }
  memcpy(acc.real_name, pop_acc, len);
  acc.real_name[len] = '\0';

  pop_acc = rb_str2cstr(rb_hash_aref(hash, rb_str_new2("reply_to")), &len);
  if (len >= 128) {
    len = 128 - 1;
  }
  memcpy(acc.reply_to, pop_acc, len);
  acc.reply_to[len] = '\0';

  acc.days       = NUM2LONG(rb_hash_aref(hash, rb_str_new2("days")));
  acc.interval   = NUM2LONG(rb_hash_aref(hash, rb_str_new2("interval")));
  acc.begin_time = NUM2LONG(rb_hash_aref(hash, rb_str_new2("begin_time")));
  acc.end_time   = NUM2LONG(rb_hash_aref(hash, rb_str_new2("end_time")));

  return acc;
}


static VALUE
rb_set_pop_account(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3;
  mail_pop_account arg1;
  status_t result;

  switch (rb_scan_args(argc, argv, "12", &varg1, &varg2, &varg3)) {
    case 1:
      arg1 = my_hash2mail_pop_account(varg1);
      result = set_pop_account(&arg1);
      break;

    case 2:
      {
        int32 arg2;

        arg1 = my_hash2mail_pop_account(varg1);
        arg2 = NUM2LONG(varg2);

        result = set_pop_account(&arg1, arg2);
      }
      break;

    case 3:
      {
        int32 arg2;
        bool arg3;

        arg1 = my_hash2mail_pop_account(varg1);
        arg2 = NUM2LONG(varg2);
        arg3 = RTEST(varg3);

        result = set_pop_account(&arg1, arg2, arg3);
      }
      break;

    default:
      rb_bug("rb_set_pop_account");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_get_smtp_host(VALUE self)
{
  char arg1[B_MAX_HOST_NAME_LENGTH];
  status_t result;
  VALUE vresult;

  result = get_smtp_host(arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = rb_str_new2(arg1);
  return vresult;
}


static VALUE
rb_set_smtp_host(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  status_t result;

  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        char *arg1;

        arg1 = STR2CSTR(varg1);
        result = set_smtp_host(arg1);
      }
      break;

    case 2:
      {
        char *arg1;
        bool arg2;

        arg1 = STR2CSTR(varg1);
        arg2 = RTEST(varg2);
        result = set_smtp_host(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_set_smtp_host");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
my_mail_notification2hash(mail_notification &ntn)
{
  VALUE vresult = rb_hash_new();
  rb_hash_aset(vresult, rb_str_new2("alert"), (ntn.alert ? Qtrue:Qfalse));
  rb_hash_aset(vresult, rb_str_new2("beep"),  (ntn.beep ? Qtrue:Qfalse));
  return vresult;
}


static VALUE
rb_get_mail_notification(VALUE self)
{
  mail_notification arg1;
  status_t result;
  VALUE vresult;

  result = get_mail_notification(&arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = my_mail_notification2hash(arg1);
  return vresult;
}


static mail_notification
my_hash2mail_notification(VALUE hash)
{
  mail_notification ntn;

  Check_Type(hash, T_HASH);

  ntn.alert = RTEST(rb_hash_aref(hash, rb_str_new2("alert")));
  ntn.beep  = RTEST(rb_hash_aref(hash, rb_str_new2("beep")));

  return ntn;
}


static VALUE
rb_set_mail_notification(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  status_t result;

  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        mail_notification arg1;

        arg1 = my_hash2mail_notification(varg1);
        result = set_mail_notification(&arg1);
      }
      break;

    case 2:
      {
        mail_notification arg1;
        bool arg2;

        arg1 = my_hash2mail_notification(varg1);
        arg2 = RTEST(varg2);
        result = set_mail_notification(&arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_set_mail_notification");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_check_for_mail(int argc, VALUE *argv, VALUE self)
{
  int32 arg1 = 0;
  status_t result;
  VALUE vresult;

  result = check_for_mail(&arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = LONG2NUM(arg1);
  return vresult;
}


static VALUE
rb_send_queued_mail(VALUE self)
{
  status_t result;

  result = send_queued_mail();
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_forward_mail(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3;
  status_t result;

  switch (rb_scan_args(argc, argv, "21", &varg1, &varg2, &varg3)) {
    case 2:
      {
        entry_ref *arg1;
        char *arg2;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg2 = STR2CSTR(varg2);

        result = forward_mail(arg1, arg2);
      }
      break;

    case 3:
      {
        entry_ref *arg1;
        char *arg2;
        bool arg3;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg2 = STR2CSTR(varg2);
        arg3 = RTEST(varg3);
        result = forward_mail(arg1, arg2, arg3);
      }
      break;

    default:
      rb_bug("rb_forward_mail");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_decode_base64(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  ssize_t result;
  VALUE vresult;

  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        char *arg1, *out;
        off_t arg2 = 0;

        arg1 = rb_str2cstr(varg1, reinterpret_cast<int *>(&arg2));
        out = ALLOCA_N(char, arg2);

        result = decode_base64(out, arg1, arg2);
        vresult = rb_str_new(out, result);
      }
      break;

    case 2:
      {
        char *arg1, *out;
        off_t arg2 = 0;
        bool arg3;

        arg1 = rb_str2cstr(varg1, reinterpret_cast<int *>(&arg2));
        out = ALLOCA_N(char, arg2);
        arg3 = STR2CSTR(varg2);

        result = decode_base64(out, arg1, arg2, arg3);
        vresult = rb_str_new(out, result);
      }
      break;

    default:
      rb_bug("rb_decode_base64");
  }
  return vresult;
}


static VALUE
rb_encode_base64(VALUE self, VALUE varg1)
{
  ssize_t result;
  VALUE vresult;

  char *arg1, *out;
  off_t arg2 = 0;

  arg1 = rb_str2cstr(varg1, reinterpret_cast<int *>(&arg2));
  out = ALLOCA_N(char, arg2);

  result = encode_base64(out, arg1, arg2);
  vresult = rb_str_new(out, result);

  return vresult;
}


void
Init_E_mail()
{
  cMailMessage = rb_define_class_under(mBe, "MailMessage", rb_cObject);
  rb_define_singleton_method(cMailMessage, "new", RUBY_METHOD_FUNC(rb_mailmessage_s_new), -1);
  rb_define_method(cMailMessage, "initialize", RUBY_METHOD_FUNC(rb_mailmessage_initialize), 0);

  rb_define_method(cMailMessage, "AddContent", RUBY_METHOD_FUNC(rb_mailmessage_AddContent), -1);
  rb_define_method(cMailMessage, "AddEnclosure", RUBY_METHOD_FUNC(rb_mailmessage_AddEnclosure), -1);
  rb_define_method(cMailMessage, "AddHeaderField", RUBY_METHOD_FUNC(rb_mailmessage_AddHeaderField), -1);
  rb_define_method(cMailMessage, "Send", RUBY_METHOD_FUNC(rb_mailmessage_Send), -1);

  rb_define_module_function(mBe, "count_pop_accounts", RUBY_METHOD_FUNC(rb_count_pop_accounts), 0);
  rb_define_module_function(mBe, "get_pop_account", RUBY_METHOD_FUNC(rb_get_pop_account), -1);
  rb_define_module_function(mBe, "set_pop_account", RUBY_METHOD_FUNC(rb_set_pop_account), -1);
  rb_define_module_function(mBe, "get_smtp_host", RUBY_METHOD_FUNC(rb_get_smtp_host), 0);
  rb_define_module_function(mBe, "set_smtp_host", RUBY_METHOD_FUNC(rb_set_smtp_host), -1);
  rb_define_module_function(mBe, "get_mail_notification", RUBY_METHOD_FUNC(rb_get_mail_notification), 0);
  rb_define_module_function(mBe, "set_mail_notification", RUBY_METHOD_FUNC(rb_set_mail_notification), -1);

  rb_define_module_function(mBe, "check_for_mail", RUBY_METHOD_FUNC(rb_check_for_mail), 0);
  rb_define_module_function(mBe, "send_queued_mail", RUBY_METHOD_FUNC(rb_send_queued_mail), 0);
  rb_define_module_function(mBe, "forward_mail", RUBY_METHOD_FUNC(rb_forward_mail), -1);
  rb_define_module_function(mBe, "decode_base64", RUBY_METHOD_FUNC(rb_decode_base64), -1);
  rb_define_module_function(mBe, "encode_base64", RUBY_METHOD_FUNC(rb_encode_base64), 1);


  rb_define_const(mBe, "MAIL_ATTR_NAME", rb_str_new2(B_MAIL_ATTR_NAME));
  rb_define_const(mBe, "MAIL_ATTR_STATUS", rb_str_new2(B_MAIL_ATTR_STATUS));
  rb_define_const(mBe, "MAIL_ATTR_PRIORITY", rb_str_new2(B_MAIL_ATTR_PRIORITY));
  rb_define_const(mBe, "MAIL_ATTR_TO", rb_str_new2(B_MAIL_ATTR_TO));
  rb_define_const(mBe, "MAIL_ATTR_CC", rb_str_new2(B_MAIL_ATTR_CC));
  rb_define_const(mBe, "MAIL_ATTR_FROM", rb_str_new2(B_MAIL_ATTR_FROM));
  rb_define_const(mBe, "MAIL_ATTR_SUBJECT", rb_str_new2(B_MAIL_ATTR_SUBJECT));
  rb_define_const(mBe, "MAIL_ATTR_REPLY", rb_str_new2(B_MAIL_ATTR_REPLY));
  rb_define_const(mBe, "MAIL_ATTR_WHEN", rb_str_new2(B_MAIL_ATTR_WHEN));
  rb_define_const(mBe, "MAIL_ATTR_FLAGS", rb_str_new2(B_MAIL_ATTR_FLAGS));
  rb_define_const(mBe, "MAIL_ATTR_RECIPIENTS", rb_str_new2(B_MAIL_ATTR_RECIPIENTS));
  rb_define_const(mBe, "MAIL_ATTR_MIME", rb_str_new2(B_MAIL_ATTR_MIME));
  rb_define_const(mBe, "MAIL_ATTR_HEADER", rb_str_new2(B_MAIL_ATTR_HEADER));
  rb_define_const(mBe, "MAIL_ATTR_CONTENT", rb_str_new2(B_MAIL_ATTR_CONTENT));

  rb_define_const(mBe, "MAIL_PENDING", ULONG2NUM(B_MAIL_PENDING));
  rb_define_const(mBe, "MAIL_SENT", ULONG2NUM(B_MAIL_SENT));
  rb_define_const(mBe, "MAIL_SAVE", ULONG2NUM(B_MAIL_SAVE));

  rb_define_const(mBe, "MAIL_TYPE", rb_str_new2(B_MAIL_TYPE));

  rb_define_const(mBe, "CHECK_NEVER", ULONG2NUM(B_CHECK_NEVER));
  rb_define_const(mBe, "CHECK_WEEKDAYS", ULONG2NUM(B_CHECK_WEEKDAYS));
  rb_define_const(mBe, "CHECK_DAILY", ULONG2NUM(B_CHECK_DAILY));
  rb_define_const(mBe, "CHECK_CONTINUOUSLY", ULONG2NUM(B_CHECK_CONTINUOUSLY));
  rb_define_const(mBe, "CHECK_CONTINUOSLY", ULONG2NUM(B_CHECK_CONTINUOSLY));

  rb_define_const(mBe, "MAX_USER_NAME_LENGTH", ULONG2NUM(B_MAX_USER_NAME_LENGTH));
  rb_define_const(mBe, "MAX_HOST_NAME_LENGTH", ULONG2NUM(B_MAX_HOST_NAME_LENGTH));

  rb_define_const(mBe, "MAIL_TO", rb_str_new2(B_MAIL_TO));
  rb_define_const(mBe, "MAIL_CC", rb_str_new2(B_MAIL_CC));
  rb_define_const(mBe, "MAIL_BCC", rb_str_new2(B_MAIL_BCC));
  rb_define_const(mBe, "MAIL_FROM", rb_str_new2(B_MAIL_FROM));
  rb_define_const(mBe, "MAIL_DATE", rb_str_new2(B_MAIL_DATE));
  rb_define_const(mBe, "MAIL_REPLY", rb_str_new2(B_MAIL_REPLY));
  rb_define_const(mBe, "MAIL_SUBJECT", rb_str_new2(B_MAIL_SUBJECT));
  rb_define_const(mBe, "MAIL_PRIORITY", rb_str_new2(B_MAIL_PRIORITY));
}
