/*
 *  Flattenable.cc
 */

#include <Flattenable.h>
#include "my_be.h"


VALUE cFlattenable;


void
delete_flattenable(BFlattenable *arg0)
{
  delete arg0;
}


static VALUE
rb_flattenable_IsFixedSize(VALUE self)
{
  BFlattenable *arg0;
  bool result;
  VALUE vresult;

  Get_BInstance(Flattenable, self, arg0);
  result = arg0->IsFixedSize();
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_flattenable_TypeCode(VALUE self)
{
  BFlattenable *arg0;
  type_code result;
  VALUE vresult;

  Get_BInstance(Flattenable, self, arg0);
  result = arg0->TypeCode();
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_flattenable_FlattenedSize(VALUE self)
{
  BFlattenable *arg0;
  ssize_t result;
  VALUE vresult;

  Get_BInstance(Flattenable, self, arg0);
  result = arg0->FlattenedSize();
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
rb_flattenable_Flatten(VALUE self)
{
  BFlattenable *arg0;
  char *arg1;
  ssize_t arg2;
  status_t result;
  VALUE vresult;

  Get_BInstance(Flattenable, self, arg0);

  arg2 = arg0->FlattenedSize();
  arg1 = ALLOCA_N(char, arg2);

  result = arg0->Flatten(arg1, arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = rb_str_new(arg1, arg2);
  return vresult;
}


static VALUE
rb_flattenable_AllowsTypeCode(VALUE self, VALUE varg1)
{
  BFlattenable *arg0;
  type_code arg1;
  bool result;
  VALUE vresult;

  Get_BInstance(Flattenable, self, arg0);
  arg1 = NUM2ULONG(varg1);
  result = arg0->AllowsTypeCode(arg1);
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_flattenable_Unflatten(VALUE self, VALUE varg1, VALUE varg2)
{
  BFlattenable *arg0;
  type_code arg1;
  char *arg2;
  int arg3 = 0;
  status_t result;

  Get_BInstance(Flattenable, self, arg0);

  arg1 = NUM2ULONG(varg1);
  arg2 = rb_str2cstr(varg2, &arg3);

  result = arg0->Unflatten(arg1, arg2, arg3);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


void
Init_Flattenable()
{
  cFlattenable = rb_define_class_under(mBe, "Flattenable", rb_cObject);
  rb_undef_method(CLASS_OF(cFlattenable), "new");

  rb_define_method(cFlattenable, "IsFixedSize", RUBY_METHOD_FUNC(rb_flattenable_IsFixedSize), 0);
  rb_define_method(cFlattenable, "TypeCode", RUBY_METHOD_FUNC(rb_flattenable_TypeCode), 0);
  rb_define_method(cFlattenable, "FlattenedSize", RUBY_METHOD_FUNC(rb_flattenable_FlattenedSize), 0);
  rb_define_method(cFlattenable, "Flatten", RUBY_METHOD_FUNC(rb_flattenable_Flatten), 0);
  rb_define_method(cFlattenable, "AllowsTypeCode", RUBY_METHOD_FUNC(rb_flattenable_AllowsTypeCode), 1);
  rb_define_method(cFlattenable, "Unflatten", RUBY_METHOD_FUNC(rb_flattenable_Unflatten), 2);
}
