/*
 *  Font.cc
 */

#include <Font.h>
#include "my_be.h"


VALUE cFont;
VALUE my_plain_font; // $be_plain_font
VALUE my_bold_font;  // $be_bold_font
VALUE my_fixed_font; // $be_fixed_font


void
delete_font(BFont *arg0)
{
  delete arg0;
}


static VALUE
rb_font_PrintToStream(VALUE self)
{
  BFont *arg0;

  Get_BInstance(Font, self, arg0);
  arg0->PrintToStream();
  return Qnil;
}

void
Init_Font()
{
  rb_global_variable(&my_plain_font);
  rb_global_variable(&my_bold_font);
  rb_global_variable(&my_fixed_font);
  rb_define_readonly_variable("$be_plain_font", &my_plain_font);
  rb_define_readonly_variable("$be_bold_font",  &my_bold_font);
  rb_define_readonly_variable("$be_fixed_font", &my_fixed_font);

  my_plain_font = Qnil;
  my_bold_font  = Qnil;
  my_fixed_font = Qnil;

  cFont = rb_define_class_under(mBe, "Font", rb_cObject);
  rb_define_method(cFont, "PrintToStream", RUBY_METHOD_FUNC(rb_font_PrintToStream), 0);

  rb_define_const(mBe, "FONT_FAMILY_LENGTH", ULONG2NUM(B_FONT_FAMILY_LENGTH));
  rb_define_const(mBe, "FONT_STYLE_LENGTH", ULONG2NUM(B_FONT_STYLE_LENGTH));

  rb_define_const(mBe, "CHAR_SPACING", ULONG2NUM(B_CHAR_SPACING));
  rb_define_const(mBe, "STRING_SPACING", ULONG2NUM(B_STRING_SPACING));
  rb_define_const(mBe, "BITMAP_SPACING", ULONG2NUM(B_BITMAP_SPACING));
  rb_define_const(mBe, "FIXED_SPACING", ULONG2NUM(B_FIXED_SPACING));

  rb_define_const(mBe, "FONT_LEFT_TO_RIGHT", ULONG2NUM(B_FONT_LEFT_TO_RIGHT));
  rb_define_const(mBe, "FONT_RIGHT_TO_LEFT", ULONG2NUM(B_FONT_RIGHT_TO_LEFT));

  rb_define_const(mBe, "DISABLE_ANTIALIASING", ULONG2NUM(B_DISABLE_ANTIALIASING));
  rb_define_const(mBe, "FORCE_ANTIALIASING", ULONG2NUM(B_FORCE_ANTIALIASING));

  rb_define_const(mBe, "TRUNCATE_END", ULONG2NUM(B_TRUNCATE_END));
  rb_define_const(mBe, "TRUNCATE_BEGINNING", ULONG2NUM(B_TRUNCATE_BEGINNING));
  rb_define_const(mBe, "TRUNCATE_MIDDLE", ULONG2NUM(B_TRUNCATE_MIDDLE));
  rb_define_const(mBe, "TRUNCATE_SMART", ULONG2NUM(B_TRUNCATE_SMART));

  rb_define_const(mBe, "UNICODE_UTF8", ULONG2NUM(B_UNICODE_UTF8));
  rb_define_const(mBe, "ISO_8859_1", ULONG2NUM(B_ISO_8859_1));
  rb_define_const(mBe, "ISO_8859_2", ULONG2NUM(B_ISO_8859_2));
  rb_define_const(mBe, "ISO_8859_3", ULONG2NUM(B_ISO_8859_3));
  rb_define_const(mBe, "ISO_8859_4", ULONG2NUM(B_ISO_8859_4));
  rb_define_const(mBe, "ISO_8859_5", ULONG2NUM(B_ISO_8859_5));
  rb_define_const(mBe, "ISO_8859_6", ULONG2NUM(B_ISO_8859_6));
  rb_define_const(mBe, "ISO_8859_7", ULONG2NUM(B_ISO_8859_7));
  rb_define_const(mBe, "ISO_8859_8", ULONG2NUM(B_ISO_8859_8));
  rb_define_const(mBe, "ISO_8859_9", ULONG2NUM(B_ISO_8859_9));
  rb_define_const(mBe, "ISO_8859_10", ULONG2NUM(B_ISO_8859_10));
  rb_define_const(mBe, "MACINTOSH_ROMAN", ULONG2NUM(B_MACINTOSH_ROMAN));

  rb_define_const(mBe, "SCREEN_FONT_CACHE", ULONG2NUM(B_SCREEN_FONT_CACHE));
  rb_define_const(mBe, "PRINTING_FONT_CACHE", ULONG2NUM(B_PRINTING_FONT_CACHE));
  rb_define_const(mBe, "DEFAULT_CACHE_SETTING", ULONG2NUM(B_DEFAULT_CACHE_SETTING));
  rb_define_const(mBe, "APP_CACHE_SETTING", ULONG2NUM(B_APP_CACHE_SETTING));

  rb_define_const(mBe, "HAS_TUNED_FONT", ULONG2NUM(B_HAS_TUNED_FONT));
  rb_define_const(mBe, "IS_FIXED", ULONG2NUM(B_IS_FIXED));

  rb_define_const(mBe, "ITALIC_FACE", ULONG2NUM(B_ITALIC_FACE));
  rb_define_const(mBe, "UNDERSCORE_FACE", ULONG2NUM(B_UNDERSCORE_FACE));
  rb_define_const(mBe, "NEGATIVE_FACE", ULONG2NUM(B_NEGATIVE_FACE));
  rb_define_const(mBe, "OUTLINED_FACE", ULONG2NUM(B_OUTLINED_FACE));
  rb_define_const(mBe, "STRIKEOUT_FACE", ULONG2NUM(B_STRIKEOUT_FACE));
  rb_define_const(mBe, "BOLD_FACE", ULONG2NUM(B_BOLD_FACE));
  rb_define_const(mBe, "REGULAR_FACE", ULONG2NUM(B_REGULAR_FACE));

  rb_define_const(mBe, "SCREEN_METRIC", ULONG2NUM(B_SCREEN_METRIC));
  rb_define_const(mBe, "PRINTING_METRIC", ULONG2NUM(B_PRINTING_METRIC));

  rb_define_const(mBe, "TRUETYPE_WINDOWS", ULONG2NUM(B_TRUETYPE_WINDOWS));
  rb_define_const(mBe, "POSTSCRIPT_TYPE1_WINDOWS", ULONG2NUM(B_POSTSCRIPT_TYPE1_WINDOWS));
}
