/*
 *  GraphicsDefs.cc
 */

#include <GraphicsDefs.h>
#include "my_be.h"


void
Init_GraphicsDefs()
{
  rb_define_const(mBe, "TRANSPARENT_MAGIC_CMAP8", UCHR2FIX(B_TRANSPARENT_MAGIC_CMAP8));
  rb_define_const(mBe, "TRANSPARENT_MAGIC_RGBA15", ULONG2NUM(B_TRANSPARENT_MAGIC_RGBA15));
  rb_define_const(mBe, "TRANSPARENT_MAGIC_RGBA15_BIG", ULONG2NUM(B_TRANSPARENT_MAGIC_RGBA15_BIG));
  rb_define_const(mBe, "TRANSPARENT_MAGIC_RGBA32", ULONG2NUM(B_TRANSPARENT_MAGIC_RGBA32));
  rb_define_const(mBe, "TRANSPARENT_MAGIC_RGBA32_BIG", ULONG2NUM(B_TRANSPARENT_MAGIC_RGBA32_BIG));

  rb_define_const(mBe, "TRANSPARENT_8_BIT", UCHR2FIX(B_TRANSPARENT_8_BIT));

  rb_define_const(mBe, "NO_COLOR_SPACE", ULONG2NUM(B_NO_COLOR_SPACE));

  rb_define_const(mBe, "RGB32", ULONG2NUM(B_RGB32));
  rb_define_const(mBe, "RGBA32", ULONG2NUM(B_RGBA32));
  rb_define_const(mBe, "RGB24", ULONG2NUM(B_RGB24));
  rb_define_const(mBe, "RGB16", ULONG2NUM(B_RGB16));
  rb_define_const(mBe, "RGB15", ULONG2NUM(B_RGB15));
  rb_define_const(mBe, "RGBA15", ULONG2NUM(B_RGBA15));
  rb_define_const(mBe, "CMAP8", ULONG2NUM(B_CMAP8));
  rb_define_const(mBe, "GRAY8", ULONG2NUM(B_GRAY8));
  rb_define_const(mBe, "GRAY1", ULONG2NUM(B_GRAY1));

  rb_define_const(mBe, "RGB32_BIG", ULONG2NUM(B_RGB32_BIG));
  rb_define_const(mBe, "RGBA32_BIG", ULONG2NUM(B_RGBA32_BIG));
  rb_define_const(mBe, "RGB24_BIG", ULONG2NUM(B_RGB24_BIG));
  rb_define_const(mBe, "RGB16_BIG", ULONG2NUM(B_RGB16_BIG));
  rb_define_const(mBe, "RGB15_BIG", ULONG2NUM(B_RGB15_BIG));
  rb_define_const(mBe, "RGBA15_BIG", ULONG2NUM(B_RGBA15_BIG));

  rb_define_const(mBe, "RGB32_LITTLE", ULONG2NUM(B_RGB32_LITTLE));
  rb_define_const(mBe, "RGBA32_LITTLE", ULONG2NUM(B_RGBA32_LITTLE));
  rb_define_const(mBe, "RGB24_LITTLE", ULONG2NUM(B_RGB24_LITTLE));
  rb_define_const(mBe, "RGB16_LITTLE", ULONG2NUM(B_RGB16_LITTLE));
  rb_define_const(mBe, "RGB15_LITTLE", ULONG2NUM(B_RGB15_LITTLE));
  rb_define_const(mBe, "RGBA15_LITTLE", ULONG2NUM(B_RGBA15_LITTLE));

  rb_define_const(mBe, "YCbCr422", ULONG2NUM(B_YCbCr422));
  rb_define_const(mBe, "YCbCr411", ULONG2NUM(B_YCbCr411));
  rb_define_const(mBe, "YCbCr444", ULONG2NUM(B_YCbCr444));
  rb_define_const(mBe, "YCbCr420", ULONG2NUM(B_YCbCr420));

  rb_define_const(mBe, "YUV422", ULONG2NUM(B_YUV422));
  rb_define_const(mBe, "YUV411", ULONG2NUM(B_YUV411));
  rb_define_const(mBe, "YUV444", ULONG2NUM(B_YUV444));
  rb_define_const(mBe, "YUV420", ULONG2NUM(B_YUV420));
  rb_define_const(mBe, "YUV9", ULONG2NUM(B_YUV9));
  rb_define_const(mBe, "YUV12", ULONG2NUM(B_YUV12));

  rb_define_const(mBe, "UVL24", ULONG2NUM(B_UVL24));
  rb_define_const(mBe, "UVL32", ULONG2NUM(B_UVL32));
  rb_define_const(mBe, "UVLA32", ULONG2NUM(B_UVLA32));

  rb_define_const(mBe, "LAB24", ULONG2NUM(B_LAB24));
  rb_define_const(mBe, "LAB32", ULONG2NUM(B_LAB32));
  rb_define_const(mBe, "LABA32", ULONG2NUM(B_LABA32));

  rb_define_const(mBe, "HSI24", ULONG2NUM(B_HSI24));
  rb_define_const(mBe, "HSI32", ULONG2NUM(B_HSI32));
  rb_define_const(mBe, "HSIA32", ULONG2NUM(B_HSIA32));

  rb_define_const(mBe, "HSV24", ULONG2NUM(B_HSV24));
  rb_define_const(mBe, "HSV32", ULONG2NUM(B_HSV32));
  rb_define_const(mBe, "HSVA32", ULONG2NUM(B_HSVA32));

  rb_define_const(mBe, "HLS24", ULONG2NUM(B_HLS24));
  rb_define_const(mBe, "HLS32", ULONG2NUM(B_HLS32));
  rb_define_const(mBe, "HLSA32", ULONG2NUM(B_HLSA32));

  rb_define_const(mBe, "CMY24", ULONG2NUM(B_CMY24));
  rb_define_const(mBe, "CMY32", ULONG2NUM(B_CMY32));
  rb_define_const(mBe, "CMYA32", ULONG2NUM(B_CMYA32));
  rb_define_const(mBe, "CMYK32", ULONG2NUM(B_CMYK32));

  rb_define_const(mBe, "MONOCHROME_1_BIT", ULONG2NUM(B_MONOCHROME_1_BIT));
  rb_define_const(mBe, "GRAYSCALE_8_BIT", ULONG2NUM(B_GRAYSCALE_8_BIT));
  rb_define_const(mBe, "COLOR_8_BIT", ULONG2NUM(B_COLOR_8_BIT));
  rb_define_const(mBe, "RGB_32_BIT", ULONG2NUM(B_RGB_32_BIT));
  rb_define_const(mBe, "RGB_16_BIT", ULONG2NUM(B_RGB_16_BIT));
  rb_define_const(mBe, "BIG_RGB_32_BIT", ULONG2NUM(B_BIG_RGB_32_BIT));
  rb_define_const(mBe, "BIG_RGB_16_BIT", ULONG2NUM(B_BIG_RGB_16_BIT));

  rb_define_const(mBe, "VIEWS_SUPPORT_DRAW_BITMAP", ULONG2NUM(B_VIEWS_SUPPORT_DRAW_BITMAP));
  rb_define_const(mBe, "BITMAPS_SUPPORT_ATTACHED_VIEWS", ULONG2NUM(B_BITMAPS_SUPPORT_ATTACHED_VIEWS));

  rb_define_const(mBe, "BUFFER_TOP_TO_BOTTOM", ULONG2NUM(B_BUFFER_TOP_TO_BOTTOM));
  rb_define_const(mBe, "BUFFER_BOTTOM_TO_TOP", ULONG2NUM(B_BUFFER_BOTTOM_TO_TOP));

  rb_define_const(mBe, "BUFFER_NONINTERLEAVED", ULONG2NUM(B_BUFFER_NONINTERLEAVED));

  rb_define_const(mBe, "OP_COPY", ULONG2NUM(B_OP_COPY));
  rb_define_const(mBe, "OP_OVER", ULONG2NUM(B_OP_OVER));
  rb_define_const(mBe, "OP_ERASE", ULONG2NUM(B_OP_ERASE));
  rb_define_const(mBe, "OP_INVERT", ULONG2NUM(B_OP_INVERT));
  rb_define_const(mBe, "OP_ADD", ULONG2NUM(B_OP_ADD));
  rb_define_const(mBe, "OP_SUBTRACT", ULONG2NUM(B_OP_SUBTRACT));
  rb_define_const(mBe, "OP_BLEND", ULONG2NUM(B_OP_BLEND));
  rb_define_const(mBe, "OP_MIN", ULONG2NUM(B_OP_MIN));
  rb_define_const(mBe, "OP_MAX", ULONG2NUM(B_OP_MAX));
  rb_define_const(mBe, "OP_SELECT", ULONG2NUM(B_OP_SELECT));
  rb_define_const(mBe, "OP_ALPHA", ULONG2NUM(B_OP_ALPHA));

  rb_define_const(mBe, "PIXEL_ALPHA", ULONG2NUM(B_PIXEL_ALPHA));
  rb_define_const(mBe, "CONSTANT_ALPHA", ULONG2NUM(B_CONSTANT_ALPHA));

  rb_define_const(mBe, "ALPHA_OVERLAY", ULONG2NUM(B_ALPHA_OVERLAY));
  rb_define_const(mBe, "ALPHA_COMPOSITE", ULONG2NUM(B_ALPHA_COMPOSITE));

  rb_define_const(mBe, "BIT_8_640x480", ULONG2NUM(B_8_BIT_640x480));
  rb_define_const(mBe, "BIT_8_800x600", ULONG2NUM(B_8_BIT_800x600));
  rb_define_const(mBe, "BIT_8_1024x768", ULONG2NUM(B_8_BIT_1024x768));
  rb_define_const(mBe, "BIT_8_1280x1024", ULONG2NUM(B_8_BIT_1280x1024));
  rb_define_const(mBe, "BIT_8_1600x1200", ULONG2NUM(B_8_BIT_1600x1200));
  rb_define_const(mBe, "BIT_16_640x480", ULONG2NUM(B_16_BIT_640x480));
  rb_define_const(mBe, "BIT_16_800x600", ULONG2NUM(B_16_BIT_800x600));
  rb_define_const(mBe, "BIT_16_1024x768", ULONG2NUM(B_16_BIT_1024x768));
  rb_define_const(mBe, "BIT_16_1280x1024", ULONG2NUM(B_16_BIT_1280x1024));
  rb_define_const(mBe, "BIT_16_1600x1200", ULONG2NUM(B_16_BIT_1600x1200));
  rb_define_const(mBe, "BIT_32_640x480", ULONG2NUM(B_32_BIT_640x480));
  rb_define_const(mBe, "BIT_32_800x600", ULONG2NUM(B_32_BIT_800x600));
  rb_define_const(mBe, "BIT_32_1024x768", ULONG2NUM(B_32_BIT_1024x768));
  rb_define_const(mBe, "BIT_32_1280x1024", ULONG2NUM(B_32_BIT_1280x1024));
  rb_define_const(mBe, "BIT_32_1600x1200", ULONG2NUM(B_32_BIT_1600x1200));
  rb_define_const(mBe, "BIT_8_1152x900", ULONG2NUM(B_8_BIT_1152x900));
  rb_define_const(mBe, "BIT_16_1152x900", ULONG2NUM(B_16_BIT_1152x900));
  rb_define_const(mBe, "BIT_32_1152x900", ULONG2NUM(B_32_BIT_1152x900));
  rb_define_const(mBe, "BIT_15_640x480", ULONG2NUM(B_15_BIT_640x480));
  rb_define_const(mBe, "BIT_15_800x600", ULONG2NUM(B_15_BIT_800x600));
  rb_define_const(mBe, "BIT_15_1024x768", ULONG2NUM(B_15_BIT_1024x768));
  rb_define_const(mBe, "BIT_15_1280x1024", ULONG2NUM(B_15_BIT_1280x1024));
  rb_define_const(mBe, "BIT_15_1600x1200", ULONG2NUM(B_15_BIT_1600x1200));
  rb_define_const(mBe, "BIT_15_1152x900", ULONG2NUM(B_15_BIT_1152x900));
  rb_define_const(mBe, "FAKE_DEVICE", ULONG2NUM(B_FAKE_DEVICE));
  rb_define_const(mBe, "BIT_8_640x400", ULONG2NUM(B_8_BIT_640x400));
}
