/*
 *  MediaDefs.cc
 */

#include <MediaDefs.h>
#include "my_be.h"


void
Init_MediaDefs()
{
  rb_define_const(mBe, "MEDIA_NAME_LENGTH", ULONG2NUM(B_MEDIA_NAME_LENGTH));

  rb_define_const(mBe, "MEDIA_SYSTEM_FAILURE", ULONG2NUM(B_MEDIA_SYSTEM_FAILURE));
  rb_define_const(mBe, "MEDIA_BAD_NODE", ULONG2NUM(B_MEDIA_BAD_NODE));
  rb_define_const(mBe, "MEDIA_NODE_BUSY", ULONG2NUM(B_MEDIA_NODE_BUSY));
  rb_define_const(mBe, "MEDIA_BAD_FORMAT", ULONG2NUM(B_MEDIA_BAD_FORMAT));
  rb_define_const(mBe, "MEDIA_BAD_BUFFER", ULONG2NUM(B_MEDIA_BAD_BUFFER));
  rb_define_const(mBe, "MEDIA_TOO_MANY_NODES", ULONG2NUM(B_MEDIA_TOO_MANY_NODES));
  rb_define_const(mBe, "MEDIA_TOO_MANY_BUFFERS", ULONG2NUM(B_MEDIA_TOO_MANY_BUFFERS));
  rb_define_const(mBe, "MEDIA_NODE_ALREADY_EXISTS", ULONG2NUM(B_MEDIA_NODE_ALREADY_EXISTS));
  rb_define_const(mBe, "MEDIA_BUFFER_ALREADY_EXISTS", ULONG2NUM(B_MEDIA_BUFFER_ALREADY_EXISTS));
  rb_define_const(mBe, "MEDIA_CANNOT_SEEK", ULONG2NUM(B_MEDIA_CANNOT_SEEK));
  rb_define_const(mBe, "MEDIA_CANNOT_CHANGE_RUN_MODE", ULONG2NUM(B_MEDIA_CANNOT_CHANGE_RUN_MODE));
  rb_define_const(mBe, "MEDIA_APP_ALREADY_REGISTERED", ULONG2NUM(B_MEDIA_APP_ALREADY_REGISTERED));
  rb_define_const(mBe, "MEDIA_APP_NOT_REGISTERED", ULONG2NUM(B_MEDIA_APP_NOT_REGISTERED));
  rb_define_const(mBe, "MEDIA_CANNOT_RECLAIM_BUFFERS", ULONG2NUM(B_MEDIA_CANNOT_RECLAIM_BUFFERS));
  rb_define_const(mBe, "MEDIA_BUFFERS_NOT_RECLAIMED", ULONG2NUM(B_MEDIA_BUFFERS_NOT_RECLAIMED));
  rb_define_const(mBe, "MEDIA_TIME_SOURCE_STOPPED", ULONG2NUM(B_MEDIA_TIME_SOURCE_STOPPED));
  rb_define_const(mBe, "MEDIA_TIME_SOURCE_BUSY", ULONG2NUM(B_MEDIA_TIME_SOURCE_BUSY));
  rb_define_const(mBe, "MEDIA_BAD_SOURCE", ULONG2NUM(B_MEDIA_BAD_SOURCE));
  rb_define_const(mBe, "MEDIA_BAD_DESTINATION", ULONG2NUM(B_MEDIA_BAD_DESTINATION));
  rb_define_const(mBe, "MEDIA_ALREADY_CONNECTED", ULONG2NUM(B_MEDIA_ALREADY_CONNECTED));
  rb_define_const(mBe, "MEDIA_NOT_CONNECTED", ULONG2NUM(B_MEDIA_NOT_CONNECTED));
  rb_define_const(mBe, "MEDIA_BAD_CLIP_FORMAT", ULONG2NUM(B_MEDIA_BAD_CLIP_FORMAT));
  rb_define_const(mBe, "MEDIA_ADDON_FAILED", ULONG2NUM(B_MEDIA_ADDON_FAILED));
  rb_define_const(mBe, "MEDIA_ADDON_DISABLED", ULONG2NUM(B_MEDIA_ADDON_DISABLED));
  rb_define_const(mBe, "MEDIA_CHANGE_IN_PROGRESS", ULONG2NUM(B_MEDIA_CHANGE_IN_PROGRESS));
  rb_define_const(mBe, "MEDIA_STALE_CHANGE_COUNT", ULONG2NUM(B_MEDIA_STALE_CHANGE_COUNT));
  rb_define_const(mBe, "MEDIA_ADDON_RESTRICTED", ULONG2NUM(B_MEDIA_ADDON_RESTRICTED));
  rb_define_const(mBe, "MEDIA_NO_HANDLER", ULONG2NUM(B_MEDIA_NO_HANDLER));
  rb_define_const(mBe, "MEDIA_DUPLICATE_FORMAT", ULONG2NUM(B_MEDIA_DUPLICATE_FORMAT));
  rb_define_const(mBe, "MEDIA_REALTIME_DISABLED", ULONG2NUM(B_MEDIA_REALTIME_DISABLED));
  rb_define_const(mBe, "MEDIA_REALTIME_UNAVAILABLE", ULONG2NUM(B_MEDIA_REALTIME_UNAVAILABLE));

  rb_define_const(mBe, "MEDIA_WILDCARD", ULONG2NUM(B_MEDIA_WILDCARD));
  rb_define_const(mBe, "MEDIA_NODE_CREATED", ULONG2NUM(B_MEDIA_NODE_CREATED));
  rb_define_const(mBe, "MEDIA_NODE_DELETED", ULONG2NUM(B_MEDIA_NODE_DELETED));
  rb_define_const(mBe, "MEDIA_CONNECTION_MADE", ULONG2NUM(B_MEDIA_CONNECTION_MADE));
  rb_define_const(mBe, "MEDIA_CONNECTION_BROKEN", ULONG2NUM(B_MEDIA_CONNECTION_BROKEN));
  rb_define_const(mBe, "MEDIA_BUFFER_CREATED", ULONG2NUM(B_MEDIA_BUFFER_CREATED));
  rb_define_const(mBe, "MEDIA_BUFFER_DELETED", ULONG2NUM(B_MEDIA_BUFFER_DELETED));
  rb_define_const(mBe, "MEDIA_TRANSPORT_STATE", ULONG2NUM(B_MEDIA_TRANSPORT_STATE));
  rb_define_const(mBe, "MEDIA_PARAMETER_CHANGED", ULONG2NUM(B_MEDIA_PARAMETER_CHANGED));
  rb_define_const(mBe, "MEDIA_FORMAT_CHANGED", ULONG2NUM(B_MEDIA_FORMAT_CHANGED));
  rb_define_const(mBe, "MEDIA_WEB_CHANGED", ULONG2NUM(B_MEDIA_WEB_CHANGED));
  rb_define_const(mBe, "MEDIA_DEFAULT_CHANGED", ULONG2NUM(B_MEDIA_DEFAULT_CHANGED));
  rb_define_const(mBe, "MEDIA_NEW_PARAMETER_VALUE", ULONG2NUM(B_MEDIA_NEW_PARAMETER_VALUE));
  rb_define_const(mBe, "MEDIA_NODE_STOPPED", ULONG2NUM(B_MEDIA_NODE_STOPPED));
  rb_define_const(mBe, "MEDIA_FLAVORS_CHANGED", ULONG2NUM(B_MEDIA_FLAVORS_CHANGED));

  rb_define_const(mBe, "MEDIA_NO_TYPE", ULONG2NUM(B_MEDIA_NO_TYPE));
  rb_define_const(mBe, "MEDIA_UNKNOWN_TYPE", ULONG2NUM(B_MEDIA_UNKNOWN_TYPE));
  rb_define_const(mBe, "MEDIA_RAW_AUDIO", ULONG2NUM(B_MEDIA_RAW_AUDIO));
  rb_define_const(mBe, "MEDIA_RAW_VIDEO", ULONG2NUM(B_MEDIA_RAW_VIDEO));
  rb_define_const(mBe, "MEDIA_VBL", ULONG2NUM(B_MEDIA_VBL));
  rb_define_const(mBe, "MEDIA_TIMECODE", ULONG2NUM(B_MEDIA_TIMECODE));
  rb_define_const(mBe, "MEDIA_MIDI", ULONG2NUM(B_MEDIA_MIDI));
  rb_define_const(mBe, "MEDIA_TEXT", ULONG2NUM(B_MEDIA_TEXT));
  rb_define_const(mBe, "MEDIA_HTML", ULONG2NUM(B_MEDIA_HTML));
  rb_define_const(mBe, "MEDIA_MULTISTREAM", ULONG2NUM(B_MEDIA_MULTISTREAM));
  rb_define_const(mBe, "MEDIA_PARAMETERS", ULONG2NUM(B_MEDIA_PARAMETERS));
  rb_define_const(mBe, "MEDIA_ENCODED_AUDIO", ULONG2NUM(B_MEDIA_ENCODED_AUDIO));
  rb_define_const(mBe, "MEDIA_ENCODED_VIDEO", ULONG2NUM(B_MEDIA_ENCODED_VIDEO));
  rb_define_const(mBe, "MEDIA_PRIVATE", ULONG2NUM(B_MEDIA_PRIVATE));
  rb_define_const(mBe, "MEDIA_FIRST_USER_TYPE", ULONG2NUM(B_MEDIA_FIRST_USER_TYPE));

  rb_define_const(mBe, "BUFFER_PRODUCER", ULONG2NUM(B_BUFFER_PRODUCER));
  rb_define_const(mBe, "BUFFER_CONSUMER", ULONG2NUM(B_BUFFER_CONSUMER));
  rb_define_const(mBe, "TIME_SOURCE", ULONG2NUM(B_TIME_SOURCE));
  rb_define_const(mBe, "CONTROLLABLE", ULONG2NUM(B_CONTROLLABLE));
  rb_define_const(mBe, "FILE_INTERFACE", ULONG2NUM(B_FILE_INTERFACE));
  rb_define_const(mBe, "ENTITY_INTERFACE", ULONG2NUM(B_ENTITY_INTERFACE));
  rb_define_const(mBe, "PHYSICAL_INPUT", ULONG2NUM(B_PHYSICAL_INPUT));
  rb_define_const(mBe, "PHYSICAL_OUTPUT", ULONG2NUM(B_PHYSICAL_OUTPUT));
  rb_define_const(mBe, "SYSTEM_MIXER", ULONG2NUM(B_SYSTEM_MIXER));

  rb_define_const(mBe, "VIDEO_TOP_LEFT_RIGHT", ULONG2NUM(B_VIDEO_TOP_LEFT_RIGHT));
  rb_define_const(mBe, "VIDEO_BOTTOM_LEFT_RIGHT", ULONG2NUM(B_VIDEO_BOTTOM_LEFT_RIGHT));

  rb_define_const(mBe, "MEDIA_FLAGS_VERSION", ULONG2NUM(B_MEDIA_FLAGS_VERSION));
  rb_define_const(mBe, "MEDIA_FLAGS_PRIVATE", ULONG2NUM(B_MEDIA_FLAGS_PRIVATE));

  rb_define_const(mBe, "DATA_NOT_AVAILABLE", ULONG2NUM(B_DATA_NOT_AVAILABLE));
  rb_define_const(mBe, "DATA_AVAILABLE", ULONG2NUM(B_DATA_AVAILABLE));
  rb_define_const(mBe, "PRODUCER_STOPPED", ULONG2NUM(B_PRODUCER_STOPPED));

  rb_define_const(mBe, "MEDIA_REALTIME_ALLOCATOR", ULONG2NUM(B_MEDIA_REALTIME_ALLOCATOR));
  rb_define_const(mBe, "MEDIA_REALTIME_AUDIO", ULONG2NUM(B_MEDIA_REALTIME_AUDIO));
  rb_define_const(mBe, "MEDIA_REALTIME_VIDEO", ULONG2NUM(B_MEDIA_REALTIME_VIDEO));
  rb_define_const(mBe, "MEDIA_REALTIME_ANYKIND", ULONG2NUM(B_MEDIA_REALTIME_ANYKIND));

  rb_define_const(mBe, "MEDIA_KEY_FRAME", ULONG2NUM(B_MEDIA_KEY_FRAME));

  rb_define_const(mBe, "MEDIA_ANY_QUALITY", rb_float_new(B_MEDIA_ANY_QUALITY));
  rb_define_const(mBe, "MEDIA_LOW_QUALITY", rb_float_new(B_MEDIA_LOW_QUALITY));
  rb_define_const(mBe, "MEDIA_MEDIUM_QUALITY", rb_float_new(B_MEDIA_MEDIUM_QUALITY));
  rb_define_const(mBe, "MEDIA_HIGH_QUALITY", rb_float_new(B_MEDIA_HIGH_QUALITY));

  rb_define_const(mBe, "CHANNEL_LEFT", ULONG2NUM(B_CHANNEL_LEFT));
  rb_define_const(mBe, "CHANNEL_RIGHT", ULONG2NUM(B_CHANNEL_RIGHT));
  rb_define_const(mBe, "CHANNEL_CENTER", ULONG2NUM(B_CHANNEL_CENTER));
  rb_define_const(mBe, "CHANNEL_SUB", ULONG2NUM(B_CHANNEL_SUB));
  rb_define_const(mBe, "CHANNEL_REARLEFT", ULONG2NUM(B_CHANNEL_REARLEFT));
  rb_define_const(mBe, "CHANNEL_REARRIGHT", ULONG2NUM(B_CHANNEL_REARRIGHT));
  rb_define_const(mBe, "CHANNEL_FRONT_LEFT_CENTER", ULONG2NUM(B_CHANNEL_FRONT_LEFT_CENTER));
  rb_define_const(mBe, "CHANNEL_FRONT_RIGHT_CENTER", ULONG2NUM(B_CHANNEL_FRONT_RIGHT_CENTER));
  rb_define_const(mBe, "CHANNEL_BACK_CENTER", ULONG2NUM(B_CHANNEL_BACK_CENTER));
  rb_define_const(mBe, "CHANNEL_SIDE_LEFT", ULONG2NUM(B_CHANNEL_SIDE_LEFT));
  rb_define_const(mBe, "CHANNEL_SIDE_RIGHT", ULONG2NUM(B_CHANNEL_SIDE_RIGHT));
  rb_define_const(mBe, "CHANNEL_TOP_CENTER", ULONG2NUM(B_CHANNEL_TOP_CENTER));
  rb_define_const(mBe, "CHANNEL_TOP_FRONT_LEFT", ULONG2NUM(B_CHANNEL_TOP_FRONT_LEFT));
  rb_define_const(mBe, "CHANNEL_TOP_FRONT_CENTER", ULONG2NUM(B_CHANNEL_TOP_FRONT_CENTER));
  rb_define_const(mBe, "CHANNEL_TOP_FRONT_RIGHT", ULONG2NUM(B_CHANNEL_TOP_FRONT_RIGHT));
  rb_define_const(mBe, "CHANNEL_TOP_BACK_LEFT", ULONG2NUM(B_CHANNEL_TOP_BACK_LEFT));
  rb_define_const(mBe, "CHANNEL_TOP_BACK_CENTER", ULONG2NUM(B_CHANNEL_TOP_BACK_CENTER));
  rb_define_const(mBe, "CHANNEL_TOP_BACK_RIGHT", ULONG2NUM(B_CHANNEL_TOP_BACK_RIGHT));

  rb_define_const(mBe, "MATRIX_PROLOGIC_LR", ULONG2NUM(B_MATRIX_PROLOGIC_LR));
  rb_define_const(mBe, "MATRIX_AMBISONIC_WXYZ", ULONG2NUM(B_MATRIX_AMBISONIC_WXYZ));

  rb_define_const(mBe, "MEDIA_BIG_ENDIAN", ULONG2NUM(B_MEDIA_BIG_ENDIAN));
  rb_define_const(mBe, "MEDIA_LITTLE_ENDIAN", ULONG2NUM(B_MEDIA_LITTLE_ENDIAN));
  rb_define_const(mBe, "MEDIA_HOST_ENDIAN", ULONG2NUM(B_MEDIA_HOST_ENDIAN));

  rb_define_const(mBe, "F1_DOMINANT", ULONG2NUM(B_F1_DOMINANT));
  rb_define_const(mBe, "F2_DOMINANT", ULONG2NUM(B_F2_DOMINANT));
  rb_define_const(mBe, "TOP_SCANLINE_F1", ULONG2NUM(B_TOP_SCANLINE_F1));
  rb_define_const(mBe, "TOP_SCANLINE_F2", ULONG2NUM(B_TOP_SCANLINE_F2));

  rb_define_const(mBe, "CODEC_TYPE_INFO", ULONG2NUM(B_CODEC_TYPE_INFO));

  rb_define_const(mBe, "MEDIA_RETAINED_DATA", ULONG2NUM(B_MEDIA_RETAINED_DATA));
  rb_define_const(mBe, "MEDIA_MULTIPLE_BUFFERS", ULONG2NUM(B_MEDIA_MULTIPLE_BUFFERS));
  rb_define_const(mBe, "MEDIA_CONTIGUOUS_BUFFER", ULONG2NUM(B_MEDIA_CONTIGUOUS_BUFFER));
  rb_define_const(mBe, "MEDIA_LINEAR_UPDATES", ULONG2NUM(B_MEDIA_LINEAR_UPDATES));
  rb_define_const(mBe, "MEDIA_MAUI_UNDEFINED_FLAGS", ULONG2NUM(B_MEDIA_MAUI_UNDEFINED_FLAGS));

  rb_define_const(mBe, "ANY_FORMAT_FAMILY", ULONG2NUM(B_ANY_FORMAT_FAMILY));
  rb_define_const(mBe, "BEOS_FORMAT_FAMILY", ULONG2NUM(B_BEOS_FORMAT_FAMILY));
  rb_define_const(mBe, "QUICKTIME_FORMAT_FAMILY", ULONG2NUM(B_QUICKTIME_FORMAT_FAMILY));
  rb_define_const(mBe, "AVI_FORMAT_FAMILY", ULONG2NUM(B_AVI_FORMAT_FAMILY));
  rb_define_const(mBe, "ASF_FORMAT_FAMILY", ULONG2NUM(B_ASF_FORMAT_FAMILY));
  rb_define_const(mBe, "MPEG_FORMAT_FAMILY", ULONG2NUM(B_MPEG_FORMAT_FAMILY));
  rb_define_const(mBe, "WAV_FORMAT_FAMILY", ULONG2NUM(B_WAV_FORMAT_FAMILY));
  rb_define_const(mBe, "AIFF_FORMAT_FAMILY", ULONG2NUM(B_AIFF_FORMAT_FAMILY));
  rb_define_const(mBe, "AVR_FORMAT_FAMILY", ULONG2NUM(B_AVR_FORMAT_FAMILY));
  rb_define_const(mBe, "MISC_FORMAT_FAMILY", ULONG2NUM(B_MISC_FORMAT_FAMILY));

  rb_define_const(mBe, "MEDIA_MESSAGE_SIZE", ULONG2NUM(B_MEDIA_MESSAGE_SIZE));

  rb_define_const(mBe, "MEDIA_SERVER_SIGNATURE", rb_str_new2(B_MEDIA_SERVER_SIGNATURE));

  rb_define_const(mBe, "BIG_ENDIAN", ULONG2NUM(B_BIG_ENDIAN));
  rb_define_const(mBe, "LITTLE_ENDIAN", ULONG2NUM(B_LITTLE_ENDIAN));

  rb_define_const(mBe, "UNDEFINED_SAMPLES", ULONG2NUM(B_UNDEFINED_SAMPLES));
  rb_define_const(mBe, "LINEAR_SAMPLES", ULONG2NUM(B_LINEAR_SAMPLES));
  rb_define_const(mBe, "FLOAT_SAMPLES", ULONG2NUM(B_FLOAT_SAMPLES));
  rb_define_const(mBe, "MULAW_SAMPLES", ULONG2NUM(B_MULAW_SAMPLES));
}
