/*
 *  MenuBar.cc
 */

#include "rbMenuBar.h"
#include "my_be.h"


VALUE cMenuBar;


void
delete_menubar(BMenuBar *arg0)
{
  delete arg0;
}


static VALUE
rb_menubar_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_menubar);
  return vresult;
}


static VALUE
rb_menubar_initialize(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3, varg4, varg5;
  MenuBar *result;

  Data_To_Null(self, BMenuBar);

  if (argc > 1) {
    switch (rb_scan_args(argc, argv, "23", &varg1, &varg2, &varg3, &varg4, &varg5)) {
      case 2:
        {
          BRect *arg1;
          char *arg2;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          result = new MenuBar(*arg1, arg2);
        }
        break;

      case 3:
        {
          BRect *arg1;
          char *arg2;
          uint32 arg3;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          arg3 = NUM2ULONG(varg3);
          result = new MenuBar(*arg1, arg2, arg3);
        }
        break;

      case 4:
        {
          BRect *arg1;
          char *arg2;
          uint32 arg3;
          menu_layout arg4;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          arg3 = NUM2ULONG(varg3);
          arg4 = (menu_layout)NUM2ULONG(varg4);
          result = new MenuBar(*arg1, arg2, arg3, arg4);
        }
        break;

      case 5:
        {
          BRect *arg1;
          char *arg2;
          uint32 arg3;
          menu_layout arg4;
          bool arg5;

          Get_BInstance(Rect, varg1, arg1);
          arg2 = STR2CSTR(varg2);
          arg3 = NUM2ULONG(varg3);
          arg4 = (menu_layout)NUM2ULONG(varg4);
          arg5 = RTEST(varg5);
          result = new MenuBar(*arg1, arg2, arg3, arg4, arg5);
        }
        break;

      default:
        rb_bug("rb_menubar_initialize");
    }
  }
  else {
    BMessage *arg1;
    rb_scan_args(argc, argv, "1", &varg1);
    Get_BInstance(Message, varg1, arg1);
    result = new MenuBar(arg1);
  }
  rb_ivar_set(self, id_relatives, Qnil);
  result->myself = self;
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_menubar_SetBorder(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  menu_bar_border arg1;

  Get_BInstance(MenuBar, self, arg0);
  arg1 = (menu_bar_border)NUM2ULONG(varg1);
  arg0->BMenuBar::SetBorder(arg1);
  return Qnil;
}


static VALUE
rb_menubar_Border(VALUE self)
{
  BMenuBar *arg0;
  menu_bar_border result;
  VALUE vresult;

  Get_BInstance(MenuBar, self, arg0);
  result = arg0->Border();
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_menubar_Draw(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  BRect *arg1;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Rect, varg1, arg1);
  arg0->BMenuBar::Draw(*arg1);
  return Qnil;
}


static VALUE
rb_menubar_AttachedToWindow(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::AttachedToWindow();
  return Qnil;
}


static VALUE
rb_menubar_DetachedFromWindow(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::DetachedFromWindow();
  return Qnil;
}


static VALUE
rb_menubar_MessageReceived(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  BMessage *arg1;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  arg0->BMenuBar::MessageReceived(arg1);
  return Qnil;
}


static VALUE
rb_menubar_MouseDown(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  BPoint *arg1;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->BMenuBar::MouseDown(*arg1);
  return Qnil;
}


static VALUE
rb_menubar_WindowActivated(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  bool arg1;

  Get_BInstance(MenuBar, self, arg0);
  arg1 = RTEST(varg1);
  arg0->BMenuBar::WindowActivated(arg1);
  return Qnil;
}


static VALUE
rb_menubar_MouseUp(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  BPoint *arg1;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->BMenuBar::MouseUp(*arg1);
  return Qnil;
}


static VALUE
rb_menubar_FrameMoved(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  BPoint *arg1;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->BMenuBar::FrameMoved(*arg1);
  return Qnil;
}


static VALUE
rb_menubar_FrameResized(VALUE self, VALUE varg1, VALUE varg2)
{
  BMenuBar *arg0;
  float arg1, arg2;

  Get_BInstance(MenuBar, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg2 = NUM2DBL(varg2);
  arg0->BMenuBar::FrameResized(arg1, arg2);
  return Qnil;
}


static VALUE
rb_menubar_Show(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::Show();
  return Qnil;
}


static VALUE
rb_menubar_Hide(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::Hide();
  return Qnil;
}


static VALUE
rb_menubar_ResolveSpecifier(VALUE self, VALUE varg1, VALUE varg2, VALUE varg3, VALUE varg4, VALUE varg5)
{
  BMenuBar *arg0;
  BMessage *arg1,  *arg3;
  int32 arg2, arg4;
  char *arg5;
  BHandler *result;
  VALUE vresult;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  arg2 = NUM2LONG(varg2);
  Get_BInstance(Message, varg3, arg3);
  arg4 = NUM2LONG(varg4);
  arg5 = STR2CSTR(varg5);

  result = arg0->BMenuBar::ResolveSpecifier(arg1, arg2, arg3, arg4, arg5);
  vresult = ((result) ? Data_Wrap_Struct(cHandler, 0, 0, result):Qnil);
  return vresult;
}


static VALUE
rb_menubar_GetSupportedSuites(VALUE self, VALUE varg1)
{
  BMenuBar *arg0;
  BMessage *arg1;
  status_t result;

  Get_BInstance(MenuBar, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  result = arg0->BMenuBar::GetSupportedSuites(arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_menubar_ResizeToPreferred(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::ResizeToPreferred();
  return Qnil;
}


static VALUE
rb_menubar_GetPreferredSize(int argc, VALUE *argv, VALUE self)
{
  BMenuBar *arg0;
  float arg1 = 0.0, arg2 = 0.0;
  VALUE vresult;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::GetPreferredSize(&arg1, &arg2);
  vresult = rb_ary_new3(2, rb_float_new(arg1), rb_float_new(arg2));
  return vresult;
}


static VALUE
rb_menubar_MakeFocus(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1;
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      arg0->BMenuBar::MakeFocus();
      break;

    case 1:
      {
        bool arg1;

        arg1 = RTEST(varg1);
        arg0->BMenuBar::MakeFocus(arg1);
      }
      break;

    default:
      rb_bug("rb_menubar_MakeFocus");
  }
  return Qnil;
}


static VALUE
rb_menubar_AllAttached(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::AllAttached();
  return Qnil;
}


static VALUE
rb_menubar_AllDetached(VALUE self)
{
  BMenuBar *arg0;

  Get_BInstance(MenuBar, self, arg0);
  arg0->BMenuBar::AllDetached();
  return Qnil;
}


void
Init_MenuBar()
{
  cMenuBar = rb_define_class_under(mBe, "MenuBar", cMenu);
  rb_define_singleton_method(cMenuBar, "new", RUBY_METHOD_FUNC(rb_menubar_s_new), -1);
  rb_define_method(cMenuBar, "initialize", RUBY_METHOD_FUNC(rb_menubar_initialize), -1);

  rb_define_method(cMenuBar, "SetBorder", RUBY_METHOD_FUNC(rb_menubar_SetBorder), 1);
  rb_define_method(cMenuBar, "Border", RUBY_METHOD_FUNC(rb_menubar_Border), 0);
  rb_define_method(cMenuBar, "Draw", RUBY_METHOD_FUNC(rb_menubar_Draw), 1);
  rb_define_method(cMenuBar, "AttachedToWindow", RUBY_METHOD_FUNC(rb_menubar_AttachedToWindow), 0);
  rb_define_method(cMenuBar, "DetachedFromWindow", RUBY_METHOD_FUNC(rb_menubar_DetachedFromWindow), 0);
  rb_define_method(cMenuBar, "MessageReceived", RUBY_METHOD_FUNC(rb_menubar_MessageReceived), 1);
  rb_define_method(cMenuBar, "MouseDown", RUBY_METHOD_FUNC(rb_menubar_MouseDown), 1);
  rb_define_method(cMenuBar, "WindowActivated", RUBY_METHOD_FUNC(rb_menubar_WindowActivated), 1);
  rb_define_method(cMenuBar, "MouseUp", RUBY_METHOD_FUNC(rb_menubar_MouseUp), 1);
  rb_define_method(cMenuBar, "FrameMoved", RUBY_METHOD_FUNC(rb_menubar_FrameMoved), 1);
  rb_define_method(cMenuBar, "FrameResized", RUBY_METHOD_FUNC(rb_menubar_FrameResized), 2);

  rb_define_method(cMenuBar, "Show", RUBY_METHOD_FUNC(rb_menubar_Show), 0);
  rb_define_method(cMenuBar, "Hide", RUBY_METHOD_FUNC(rb_menubar_Hide), 0);

  rb_define_method(cMenuBar, "ResolveSpecifier", RUBY_METHOD_FUNC(rb_menubar_ResolveSpecifier), 5);
  rb_define_method(cMenuBar, "GetSupportedSuites", RUBY_METHOD_FUNC(rb_menubar_GetSupportedSuites), 1);

  rb_define_method(cMenuBar, "ResizeToPreferred", RUBY_METHOD_FUNC(rb_menubar_ResizeToPreferred), 0);
  rb_define_method(cMenuBar, "GetPreferredSize", RUBY_METHOD_FUNC(rb_menubar_GetPreferredSize), -1);
  rb_define_method(cMenuBar, "MakeFocus", RUBY_METHOD_FUNC(rb_menubar_MakeFocus), -1);
  rb_define_method(cMenuBar, "AllAttached", RUBY_METHOD_FUNC(rb_menubar_AllAttached), 0);
  rb_define_method(cMenuBar, "AllDetached", RUBY_METHOD_FUNC(rb_menubar_AllDetached), 0);

  rb_define_const(mBe, "BORDER_FRAME", ULONG2NUM(B_BORDER_FRAME));
  rb_define_const(mBe, "BORDER_CONTENTS", ULONG2NUM(B_BORDER_CONTENTS));
  rb_define_const(mBe, "BORDER_EACH_ITEM", ULONG2NUM(B_BORDER_EACH_ITEM));
}
