/*
 *  MessageFilter.cc
 */

#include "rbMessageFilter.h"
#include "my_be.h"


VALUE cMessageFilter;


void
delete_messagefilter(BMessageFilter *arg0)
{
  delete arg0;
}


static VALUE
rb_messagefilter_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_messagefilter);
  return vresult;
}


static VALUE
rb_messagefilter_initialize(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3, varg4, varg5;
  MessageFilter *result;

  Data_To_Null(self, BMessageFilter);

  switch (rb_scan_args(argc, argv, "13", &varg1, &varg2, &varg3, &varg4, &varg5)) {
    case 1:
      if (rb_obj_is_kind_of(varg1, cMessageFilter)) {
        BMessageFilter *arg1;

        Get_BInstance(MessageFilter, varg1, arg1);
        result = new MessageFilter(arg1);
      }
      else {
        uint32 arg1;

        arg1 = NUM2ULONG(varg1);
        result = new MessageFilter(arg1);
      }
      break;

    case 2:
      {
        uint32 arg1;
        filter_hook arg2=NULL;

        arg1 = NUM2ULONG(varg1);
        result = new MessageFilter(arg1, arg2);
      }
      break;

    case 3:
      {
        message_delivery arg1;
        message_source arg2;
        filter_hook arg3=NULL;

        arg1 = (message_delivery)NUM2ULONG(varg1);
        arg2 = (message_source)NUM2ULONG(varg2);
        result = new MessageFilter(arg1, arg2, arg3);
      }
      break;

    case 4:
      {
        message_delivery arg1;
        message_source arg2;
        uint32 arg3;
        filter_hook arg4=NULL;

        arg1 = (message_delivery)NUM2ULONG(varg1);
        arg2 = (message_source)NUM2ULONG(varg2);
        arg3 = NUM2ULONG(varg3);
        result = new MessageFilter(arg1, arg2, arg3, arg4);
      }
      break;

    default:
      rb_bug("rb_messagefilter_initialize");
  }
  result->myself = self;
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_messagefilter_Filter(VALUE self, VALUE varg1, VALUE varg2)
{
  BMessageFilter *arg0;
  BMessage *arg1;
  BHandler *arg2;
  filter_result result;
  VALUE vresult;

  Get_BInstance(MessageFilter, self, arg0);
  Get_BInstance(Message, varg1, arg1);
  Get_BInstance(Handler, varg2, arg2);

  result = arg0->BMessageFilter::Filter(arg1, &arg2);
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_messagefilter_MessageDelivery(VALUE self)
{
  BMessageFilter *arg0;
  message_delivery result;
  VALUE vresult;

  Get_BInstance(MessageFilter, self, arg0);
  result = arg0->MessageDelivery();
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_messagefilter_MessageSource(VALUE self)
{
  BMessageFilter *arg0;
  message_source result;
  VALUE vresult;

  Get_BInstance(MessageFilter, self, arg0);
  result = arg0->MessageSource();
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_messagefilter_Command(VALUE self)
{
  BMessageFilter *arg0;
  uint32 result;
  VALUE vresult;

  Get_BInstance(MessageFilter, self, arg0);
  result = arg0->Command();
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_messagefilter_FiltersAnyCommand(VALUE self)
{
  BMessageFilter *arg0;
  bool result;
  VALUE vresult;

  Get_BInstance(MessageFilter, self, arg0);
  result = arg0->FiltersAnyCommand();
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_messagefilter_Looper(VALUE self)
{
  BMessageFilter *arg0;
  BLooper *result;
  VALUE vresult;

  Get_BInstance(MessageFilter, self, arg0);
  result = arg0->Looper();
  vresult = ((result) ? Data_Wrap_Struct(cLooper, 0, 0, result):Qnil);
  return vresult;
}


void
Init_MessageFilter()
{
  cMessageFilter = rb_define_class_under(mBe, "MessageFilter", rb_cObject);
  rb_define_singleton_method(cMessageFilter, "new", RUBY_METHOD_FUNC(rb_messagefilter_s_new), -1);
  rb_define_method(cMessageFilter, "initialize", RUBY_METHOD_FUNC(rb_messagefilter_initialize), -1);

  rb_define_method(cMessageFilter, "Filter", RUBY_METHOD_FUNC(rb_messagefilter_Filter), 2);

  rb_define_method(cMessageFilter, "MessageDelivery", RUBY_METHOD_FUNC(rb_messagefilter_MessageDelivery), 0);
  rb_define_method(cMessageFilter, "MessageSource", RUBY_METHOD_FUNC(rb_messagefilter_MessageSource), 0);
  rb_define_method(cMessageFilter, "Command", RUBY_METHOD_FUNC(rb_messagefilter_Command), 0);
  rb_define_method(cMessageFilter, "FiltersAnyCommand", RUBY_METHOD_FUNC(rb_messagefilter_FiltersAnyCommand), 0);
  rb_define_method(cMessageFilter, "Looper", RUBY_METHOD_FUNC(rb_messagefilter_Looper), 0);

  rb_define_const(mBe, "SKIP_MESSAGE", LONG2NUM(B_SKIP_MESSAGE));
  rb_define_const(mBe, "DISPATCH_MESSAGE", LONG2NUM(B_DISPATCH_MESSAGE));

  rb_define_const(mBe, "ANY_DELIVERY", LONG2NUM(B_ANY_DELIVERY));
  rb_define_const(mBe, "DROPPED_DELIVERY", LONG2NUM(B_DROPPED_DELIVERY));
  rb_define_const(mBe, "PROGRAMMED_DELIVERY", LONG2NUM(B_PROGRAMMED_DELIVERY));

  rb_define_const(mBe, "ANY_SOURCE", LONG2NUM(B_ANY_SOURCE));
  rb_define_const(mBe, "REMOTE_SOURCE", LONG2NUM(B_REMOTE_SOURCE));
  rb_define_const(mBe, "LOCAL_SOURCE", LONG2NUM(B_LOCAL_SOURCE));
}
