/*
 *  MessageRunner.cc
 */

#include <MessageRunner.h>
#include "my_be.h"


VALUE cMessageRunner;


void
delete_messagerunner(BMessageRunner *arg0)
{
  delete arg0;
}


static VALUE
rb_messagerunner_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_messagerunner);
  return vresult;
}


static VALUE
rb_messagerunner_initialize(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3, varg4, varg5;
  BMessageRunner *result;

  Data_To_Null(self, BMessageRunner);

  switch (rb_scan_args(argc, argv, "32", &varg1, &varg2, &varg3, &varg4, &varg5)) {
    case 3:
      {
        BMessenger *arg1;
        BMessage *arg2;
        bigtime_t arg3;

        Get_BInstance(Messenger, varg1, arg1);
        Get_BInstance(Message, varg2, arg2);
        arg3 = NUM2LLONG(varg3);

        NEW(result, BMessageRunner(*arg1, arg2, arg3));
      }
      break;

    case 4:
      {
        BMessenger *arg1;
        BMessage *arg2;
        bigtime_t arg3;
        int32 arg4;

        Get_BInstance(Messenger, varg1, arg1);
        Get_BInstance(Message, varg2, arg2);
        arg3 = NUM2LLONG(varg3);
        arg4 = NUM2LONG(varg4);

        NEW(result, BMessageRunner(*arg1, arg2, arg3, arg4));
      }
      break;

    case 5:
      {
        BMessenger *arg1, *arg5;;
        BMessage *arg2;
        bigtime_t arg3;
        int32 arg4;

        Get_BInstance(Messenger, varg1, arg1);
        Get_BInstance(Message, varg2, arg2);
        arg3 = NUM2LLONG(varg3);
        arg4 = NUM2LONG(varg4);
        Get_BInstance(Messenger, varg5, arg5);

        NEW(result, BMessageRunner(*arg1, arg2, arg3, arg4, *arg5));
      }
      break;

    default:
      rb_bug("rb_messagerunner_initialize");
  }
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_messagerunner_InitCheck(VALUE self)
{
  BMessageRunner *arg0;
  status_t result;

  Get_BInstance(MessageRunner, self, arg0);
  result = arg0->InitCheck();
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_messagerunner_SetInterval(VALUE self, VALUE varg1)
{
  BMessageRunner *arg0;
  bigtime_t arg1;
  status_t result;

  Get_BInstance(MessageRunner, self, arg0);
  arg1 = NUM2LLONG(varg1);
  result = arg0->SetInterval(arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_messagerunner_SetCount(VALUE self, VALUE varg1)
{
  BMessageRunner *arg0;
  int32 arg1;
  status_t result;

  Get_BInstance(MessageRunner, self, arg0);
  arg1 = NUM2LONG(varg1);
  result = arg0->SetCount(arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_messagerunner_GetInfo(VALUE self)
{
  BMessageRunner *arg0;
  bigtime_t arg1;
  int32 arg2;
  status_t result;
  VALUE vresult;

  Get_BInstance(MessageRunner, self, arg0);
  result = arg0->GetInfo(&arg1, &arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = rb_ary_new3(2, LLONG2NUM(arg1),
                           LONG2NUM(arg2));
  return vresult;
}


void
Init_MessageRunner()
{
  cMessageRunner = rb_define_class_under(mBe, "MessageRunner", rb_cObject);
  rb_define_singleton_method(cMessageRunner, "new", RUBY_METHOD_FUNC(rb_messagerunner_s_new), -1);
  rb_define_method(cMessageRunner, "initialize", RUBY_METHOD_FUNC(rb_messagerunner_initialize), -1);

  rb_define_method(cMessageRunner, "InitCheck", RUBY_METHOD_FUNC(rb_messagerunner_InitCheck), 0);

  rb_define_method(cMessageRunner, "SetInterval", RUBY_METHOD_FUNC(rb_messagerunner_SetInterval), 1);
  rb_define_method(cMessageRunner, "SetCount", RUBY_METHOD_FUNC(rb_messagerunner_SetCount), 1);
  rb_define_method(cMessageRunner, "GetInfo", RUBY_METHOD_FUNC(rb_messagerunner_GetInfo), 0);
}
