/*
 *  MidiDefs.cc
 */

#include <MidiDefs.h>
#include <FindDirectory.h>
#include "my_be.h"


static VALUE
rb_B_NOW(VALUE self)
{
  return ULONG2NUM(B_NOW);
}


void
Init_MidiDefs()
{
  rb_define_module_function(mBe, "NOW", RUBY_METHOD_FUNC(rb_B_NOW), 0);

  rb_define_const(mBe, "SYNTH_DIRECTORY", ULONG2NUM(B_SYNTH_DIRECTORY));
  rb_define_const(mBe, "BIG_SYNTH_FILE", rb_str_new2(B_BIG_SYNTH_FILE));
  rb_define_const(mBe, "LITTLE_SYNTH_FILE", rb_str_new2(B_LITTLE_SYNTH_FILE));

  rb_define_const(mBe, "NO_SYNTH", ULONG2NUM(B_NO_SYNTH));
  rb_define_const(mBe, "BIG_SYNTH", ULONG2NUM(B_BIG_SYNTH));
  rb_define_const(mBe, "LITTLE_SYNTH", ULONG2NUM(B_LITTLE_SYNTH));
  rb_define_const(mBe, "DEFAULT_SYNTH", ULONG2NUM(B_DEFAULT_SYNTH));
  rb_define_const(mBe, "SAMPLES_ONLY", ULONG2NUM(B_SAMPLES_ONLY));

  rb_define_const(mBe, "BAD_INSTRUMENT", ULONG2NUM(B_BAD_INSTRUMENT));
  rb_define_const(mBe, "BAD_MIDI_DATA", ULONG2NUM(B_BAD_MIDI_DATA));
  rb_define_const(mBe, "ALREADY_PAUSED", ULONG2NUM(B_ALREADY_PAUSED));
  rb_define_const(mBe, "ALREADY_RESUMED", ULONG2NUM(B_ALREADY_RESUMED));
  rb_define_const(mBe, "NO_SONG_PLAYING", ULONG2NUM(B_NO_SONG_PLAYING));
  rb_define_const(mBe, "TOO_MANY_SONGS_PLAYING", ULONG2NUM(B_TOO_MANY_SONGS_PLAYING));

  rb_define_const(mBe, "NOTE_OFF", UCHR2FIX(B_NOTE_OFF));
  rb_define_const(mBe, "NOTE_ON", UCHR2FIX(B_NOTE_ON));
  rb_define_const(mBe, "KEY_PRESSURE", UCHR2FIX(B_KEY_PRESSURE));
  rb_define_const(mBe, "CONTROL_CHANGE", UCHR2FIX(B_CONTROL_CHANGE));
  rb_define_const(mBe, "PROGRAM_CHANGE", UCHR2FIX(B_PROGRAM_CHANGE));
  rb_define_const(mBe, "CHANNEL_PRESSURE", UCHR2FIX(B_CHANNEL_PRESSURE));
  rb_define_const(mBe, "PITCH_BEND", UCHR2FIX(B_PITCH_BEND));

  rb_define_const(mBe, "SYS_EX_START", UCHR2FIX(B_SYS_EX_START));
  rb_define_const(mBe, "MIDI_TIME_CODE", UCHR2FIX(B_MIDI_TIME_CODE));
  rb_define_const(mBe, "SONG_POSITION", UCHR2FIX(B_SONG_POSITION));
  rb_define_const(mBe, "SONG_SELECT", UCHR2FIX(B_SONG_SELECT));
  rb_define_const(mBe, "CABLE_MESSAGE", UCHR2FIX(B_CABLE_MESSAGE));
  rb_define_const(mBe, "TUNE_REQUEST", UCHR2FIX(B_TUNE_REQUEST));
  rb_define_const(mBe, "SYS_EX_END", UCHR2FIX(B_SYS_EX_END));
  rb_define_const(mBe, "TIMING_CLOCK", UCHR2FIX(B_TIMING_CLOCK));
  rb_define_const(mBe, "START", UCHR2FIX(B_START));
  rb_define_const(mBe, "CONTINUE", UCHR2FIX(B_CONTINUE));
  rb_define_const(mBe, "STOP", UCHR2FIX(B_STOP));
  rb_define_const(mBe, "ACTIVE_SENSING", UCHR2FIX(B_ACTIVE_SENSING));
  rb_define_const(mBe, "SYSTEM_RESET", UCHR2FIX(B_SYSTEM_RESET));

  rb_define_const(mBe, "MODULATION", UCHR2FIX(B_MODULATION));
  rb_define_const(mBe, "BREATH_CONTROLLER", UCHR2FIX(B_BREATH_CONTROLLER));
  rb_define_const(mBe, "FOOT_CONTROLLER", UCHR2FIX(B_FOOT_CONTROLLER));
  rb_define_const(mBe, "PORTAMENTO_TIME", UCHR2FIX(B_PORTAMENTO_TIME));
  rb_define_const(mBe, "DATA_ENTRY", UCHR2FIX(B_DATA_ENTRY));
  rb_define_const(mBe, "MAIN_VOLUME", UCHR2FIX(B_MAIN_VOLUME));
  rb_define_const(mBe, "MIDI_BALANCE", UCHR2FIX(B_MIDI_BALANCE));
  rb_define_const(mBe, "PAN", UCHR2FIX(B_PAN));
  rb_define_const(mBe, "EXPRESSION_CTRL", UCHR2FIX(B_EXPRESSION_CTRL));
  rb_define_const(mBe, "GENERAL_CTRL_1", UCHR2FIX(B_GENERAL_CTRL_1));
  rb_define_const(mBe, "GENERAL_CTRL_2", UCHR2FIX(B_GENERAL_CTRL_2));
  rb_define_const(mBe, "GENERAL_CTRL_3", UCHR2FIX(B_GENERAL_CTRL_3));
  rb_define_const(mBe, "GENERAL_CTRL_4", UCHR2FIX(B_GENERAL_CTRL_4));
  rb_define_const(mBe, "SUSTAIN_PEDAL", UCHR2FIX(B_SUSTAIN_PEDAL));
  rb_define_const(mBe, "PORTAMENTO", UCHR2FIX(B_PORTAMENTO));
  rb_define_const(mBe, "SOSTENUTO", UCHR2FIX(B_SOSTENUTO));
  rb_define_const(mBe, "SOFT_PEDAL", UCHR2FIX(B_SOFT_PEDAL));
  rb_define_const(mBe, "HOLD_2", UCHR2FIX(B_HOLD_2));
  rb_define_const(mBe, "GENERAL_CTRL_5", UCHR2FIX(B_GENERAL_CTRL_5));
  rb_define_const(mBe, "GENERAL_CTRL_6", UCHR2FIX(B_GENERAL_CTRL_6));
  rb_define_const(mBe, "GENERAL_CTRL_7", UCHR2FIX(B_GENERAL_CTRL_7));
  rb_define_const(mBe, "GENERAL_CTRL_8", UCHR2FIX(B_GENERAL_CTRL_8));
  rb_define_const(mBe, "EFFECTS_DEPTH", UCHR2FIX(B_EFFECTS_DEPTH));
  rb_define_const(mBe, "TREMOLO_DEPTH", UCHR2FIX(B_TREMOLO_DEPTH));
  rb_define_const(mBe, "CHORUS_DEPTH", UCHR2FIX(B_CHORUS_DEPTH));
  rb_define_const(mBe, "CELESTE_DEPTH", UCHR2FIX(B_CELESTE_DEPTH));
  rb_define_const(mBe, "PHASER_DEPTH", UCHR2FIX(B_PHASER_DEPTH));
  rb_define_const(mBe, "DATA_INCREMENT", UCHR2FIX(B_DATA_INCREMENT));
  rb_define_const(mBe, "DATA_DECREMENT", UCHR2FIX(B_DATA_DECREMENT));
  rb_define_const(mBe, "RESET_ALL_CONTROLLERS", UCHR2FIX(B_RESET_ALL_CONTROLLERS));
  rb_define_const(mBe, "LOCAL_CONTROL", UCHR2FIX(B_LOCAL_CONTROL));
  rb_define_const(mBe, "ALL_NOTES_OFF", UCHR2FIX(B_ALL_NOTES_OFF));
  rb_define_const(mBe, "OMNI_MODE_OFF", UCHR2FIX(B_OMNI_MODE_OFF));
  rb_define_const(mBe, "OMNI_MODE_ON", UCHR2FIX(B_OMNI_MODE_ON));
  rb_define_const(mBe, "MONO_MODE_ON", UCHR2FIX(B_MONO_MODE_ON));
  rb_define_const(mBe, "POLY_MODE_ON", UCHR2FIX(B_POLY_MODE_ON));

  rb_define_const(mBe, "TEMPO_CHANGE", UCHR2FIX(B_TEMPO_CHANGE));

  rb_define_const(mBe, "ACOUSTIC_GRAND", ULONG2NUM(B_ACOUSTIC_GRAND));
  rb_define_const(mBe, "BRIGHT_GRAND", ULONG2NUM(B_BRIGHT_GRAND));
  rb_define_const(mBe, "ELECTRIC_GRAND", ULONG2NUM(B_ELECTRIC_GRAND));
  rb_define_const(mBe, "HONKY_TONK", ULONG2NUM(B_HONKY_TONK));
  rb_define_const(mBe, "ELECTRIC_PIANO_1", ULONG2NUM(B_ELECTRIC_PIANO_1));
  rb_define_const(mBe, "ELECTRIC_PIANO_2", ULONG2NUM(B_ELECTRIC_PIANO_2));
  rb_define_const(mBe, "HARPSICHORD", ULONG2NUM(B_HARPSICHORD));
  rb_define_const(mBe, "CLAVICHORD", ULONG2NUM(B_CLAVICHORD));

  rb_define_const(mBe, "CELESTA", ULONG2NUM(B_CELESTA));
  rb_define_const(mBe, "GLOCKENSPIEL", ULONG2NUM(B_GLOCKENSPIEL));
  rb_define_const(mBe, "MUSIC_BOX", ULONG2NUM(B_MUSIC_BOX));
  rb_define_const(mBe, "VIBRAPHONE", ULONG2NUM(B_VIBRAPHONE));
  rb_define_const(mBe, "MARIMBA", ULONG2NUM(B_MARIMBA));
  rb_define_const(mBe, "XYLOPHONE", ULONG2NUM(B_XYLOPHONE));
  rb_define_const(mBe, "TUBULAR_BELLS", ULONG2NUM(B_TUBULAR_BELLS));
  rb_define_const(mBe, "DULCIMER", ULONG2NUM(B_DULCIMER));

  rb_define_const(mBe, "DRAWBAR_ORGAN", ULONG2NUM(B_DRAWBAR_ORGAN));
  rb_define_const(mBe, "PERCUSSIVE_ORGAN", ULONG2NUM(B_PERCUSSIVE_ORGAN));
  rb_define_const(mBe, "ROCK_ORGAN", ULONG2NUM(B_ROCK_ORGAN));
  rb_define_const(mBe, "CHURCH_ORGAN", ULONG2NUM(B_CHURCH_ORGAN));
  rb_define_const(mBe, "REED_ORGAN", ULONG2NUM(B_REED_ORGAN));
  rb_define_const(mBe, "ACCORDION", ULONG2NUM(B_ACCORDION));
  rb_define_const(mBe, "HARMONICA", ULONG2NUM(B_HARMONICA));
  rb_define_const(mBe, "TANGO_ACCORDION", ULONG2NUM(B_TANGO_ACCORDION));

  rb_define_const(mBe, "ACOUSTIC_GUITAR_NYLON", ULONG2NUM(B_ACOUSTIC_GUITAR_NYLON));
  rb_define_const(mBe, "ACOUSTIC_GUITAR_STEEL", ULONG2NUM(B_ACOUSTIC_GUITAR_STEEL));
  rb_define_const(mBe, "ELECTRIC_GUITAR_JAZZ", ULONG2NUM(B_ELECTRIC_GUITAR_JAZZ));
  rb_define_const(mBe, "ELECTRIC_GUITAR_CLEAN", ULONG2NUM(B_ELECTRIC_GUITAR_CLEAN));
  rb_define_const(mBe, "ELECTRIC_GUITAR_MUTED", ULONG2NUM(B_ELECTRIC_GUITAR_MUTED));
  rb_define_const(mBe, "OVERDRIVEN_GUITAR", ULONG2NUM(B_OVERDRIVEN_GUITAR));
  rb_define_const(mBe, "DISTORTION_GUITAR", ULONG2NUM(B_DISTORTION_GUITAR));
  rb_define_const(mBe, "GUITAR_HARMONICS", ULONG2NUM(B_GUITAR_HARMONICS));

  rb_define_const(mBe, "ACOUSTIC_BASS", ULONG2NUM(B_ACOUSTIC_BASS));
  rb_define_const(mBe, "ELECTRIC_BASS_FINGER", ULONG2NUM(B_ELECTRIC_BASS_FINGER));
  rb_define_const(mBe, "ELECTRIC_BASS_PICK", ULONG2NUM(B_ELECTRIC_BASS_PICK));
  rb_define_const(mBe, "FRETLESS_BASS", ULONG2NUM(B_FRETLESS_BASS));
  rb_define_const(mBe, "SLAP_BASS_1", ULONG2NUM(B_SLAP_BASS_1));
  rb_define_const(mBe, "SLAP_BASS_2", ULONG2NUM(B_SLAP_BASS_2));
  rb_define_const(mBe, "SYNTH_BASS_1", ULONG2NUM(B_SYNTH_BASS_1));
  rb_define_const(mBe, "SYNTH_BASS_2", ULONG2NUM(B_SYNTH_BASS_2));

  rb_define_const(mBe, "VIOLIN", ULONG2NUM(B_VIOLIN));
  rb_define_const(mBe, "VIOLA", ULONG2NUM(B_VIOLA));
  rb_define_const(mBe, "CELLO", ULONG2NUM(B_CELLO));
  rb_define_const(mBe, "CONTRABASS", ULONG2NUM(B_CONTRABASS));
  rb_define_const(mBe, "TREMOLO_STRINGS", ULONG2NUM(B_TREMOLO_STRINGS));
  rb_define_const(mBe, "PIZZICATO_STRINGS", ULONG2NUM(B_PIZZICATO_STRINGS));
  rb_define_const(mBe, "ORCHESTRAL_STRINGS", ULONG2NUM(B_ORCHESTRAL_STRINGS));
  rb_define_const(mBe, "TIMPANI", ULONG2NUM(B_TIMPANI));

  rb_define_const(mBe, "STRING_ENSEMBLE_1", ULONG2NUM(B_STRING_ENSEMBLE_1));
  rb_define_const(mBe, "STRING_ENSEMBLE_2", ULONG2NUM(B_STRING_ENSEMBLE_2));
  rb_define_const(mBe, "SYNTH_STRINGS_1", ULONG2NUM(B_SYNTH_STRINGS_1));
  rb_define_const(mBe, "SYNTH_STRINGS_2", ULONG2NUM(B_SYNTH_STRINGS_2));
  rb_define_const(mBe, "VOICE_AAH", ULONG2NUM(B_VOICE_AAH));
  rb_define_const(mBe, "VOICE_OOH", ULONG2NUM(B_VOICE_OOH));
  rb_define_const(mBe, "SYNTH_VOICE", ULONG2NUM(B_SYNTH_VOICE));
  rb_define_const(mBe, "ORCHESTRA_HIT", ULONG2NUM(B_ORCHESTRA_HIT));

  rb_define_const(mBe, "TRUMPET", ULONG2NUM(B_TRUMPET));
  rb_define_const(mBe, "TROMBONE", ULONG2NUM(B_TROMBONE));
  rb_define_const(mBe, "TUBA", ULONG2NUM(B_TUBA));
  rb_define_const(mBe, "MUTED_TRUMPET", ULONG2NUM(B_MUTED_TRUMPET));
  rb_define_const(mBe, "FRENCH_HORN", ULONG2NUM(B_FRENCH_HORN));
  rb_define_const(mBe, "BRASS_SECTION", ULONG2NUM(B_BRASS_SECTION));
  rb_define_const(mBe, "SYNTH_BRASS_1", ULONG2NUM(B_SYNTH_BRASS_1));
  rb_define_const(mBe, "SYNTH_BRASS_2", ULONG2NUM(B_SYNTH_BRASS_2));

  rb_define_const(mBe, "SOPRANO_SAX", ULONG2NUM(B_SOPRANO_SAX));
  rb_define_const(mBe, "ALTO_SAX", ULONG2NUM(B_ALTO_SAX));
  rb_define_const(mBe, "TENOR_SAX", ULONG2NUM(B_TENOR_SAX));
  rb_define_const(mBe, "BARITONE_SAX", ULONG2NUM(B_BARITONE_SAX));
  rb_define_const(mBe, "OBOE", ULONG2NUM(B_OBOE));
  rb_define_const(mBe, "ENGLISH_HORN", ULONG2NUM(B_ENGLISH_HORN));
  rb_define_const(mBe, "BASSOON", ULONG2NUM(B_BASSOON));
  rb_define_const(mBe, "CLARINET", ULONG2NUM(B_CLARINET));

  rb_define_const(mBe, "PICCOLO", ULONG2NUM(B_PICCOLO));
  rb_define_const(mBe, "FLUTE", ULONG2NUM(B_FLUTE));
  rb_define_const(mBe, "RECORDER", ULONG2NUM(B_RECORDER));
  rb_define_const(mBe, "PAN_FLUTE", ULONG2NUM(B_PAN_FLUTE));
  rb_define_const(mBe, "BLOWN_BOTTLE", ULONG2NUM(B_BLOWN_BOTTLE));
  rb_define_const(mBe, "SHAKUHACHI", ULONG2NUM(B_SHAKUHACHI));
  rb_define_const(mBe, "WHISTLE", ULONG2NUM(B_WHISTLE));
  rb_define_const(mBe, "OCARINA", ULONG2NUM(B_OCARINA));

  rb_define_const(mBe, "LEAD_1", ULONG2NUM(B_LEAD_1));
  rb_define_const(mBe, "SQUARE_WAVE", ULONG2NUM(B_SQUARE_WAVE));
  rb_define_const(mBe, "LEAD_2", ULONG2NUM(B_LEAD_2));
  rb_define_const(mBe, "SAWTOOTH_WAVE", ULONG2NUM(B_SAWTOOTH_WAVE));
  rb_define_const(mBe, "LEAD_3", ULONG2NUM(B_LEAD_3));
  rb_define_const(mBe, "CALLIOPE", ULONG2NUM(B_CALLIOPE));
  rb_define_const(mBe, "LEAD_4", ULONG2NUM(B_LEAD_4));
  rb_define_const(mBe, "CHIFF", ULONG2NUM(B_CHIFF));
  rb_define_const(mBe, "LEAD_5", ULONG2NUM(B_LEAD_5));
  rb_define_const(mBe, "CHARANG", ULONG2NUM(B_CHARANG));
  rb_define_const(mBe, "LEAD_6", ULONG2NUM(B_LEAD_6));
  rb_define_const(mBe, "VOICE", ULONG2NUM(B_VOICE));
  rb_define_const(mBe, "LEAD_7", ULONG2NUM(B_LEAD_7));
  rb_define_const(mBe, "FIFTHS", ULONG2NUM(B_FIFTHS));
  rb_define_const(mBe, "LEAD_8", ULONG2NUM(B_LEAD_8));
  rb_define_const(mBe, "BASS_LEAD", ULONG2NUM(B_BASS_LEAD));

  rb_define_const(mBe, "PAD_1", ULONG2NUM(B_PAD_1));
  rb_define_const(mBe, "NEW_AGE", ULONG2NUM(B_NEW_AGE));
  rb_define_const(mBe, "PAD_2", ULONG2NUM(B_PAD_2));
  rb_define_const(mBe, "WARM", ULONG2NUM(B_WARM));
  rb_define_const(mBe, "PAD_3", ULONG2NUM(B_PAD_3));
  rb_define_const(mBe, "POLYSYNTH", ULONG2NUM(B_POLYSYNTH));
  rb_define_const(mBe, "PAD_4", ULONG2NUM(B_PAD_4));
  rb_define_const(mBe, "CHOIR", ULONG2NUM(B_CHOIR));
  rb_define_const(mBe, "PAD_5", ULONG2NUM(B_PAD_5));
  rb_define_const(mBe, "BOWED", ULONG2NUM(B_BOWED));
  rb_define_const(mBe, "PAD_6", ULONG2NUM(B_PAD_6));
  rb_define_const(mBe, "METALLIC", ULONG2NUM(B_METALLIC));
  rb_define_const(mBe, "PAD_7", ULONG2NUM(B_PAD_7));
  rb_define_const(mBe, "HALO", ULONG2NUM(B_HALO));
  rb_define_const(mBe, "PAD_8", ULONG2NUM(B_PAD_8));
  rb_define_const(mBe, "SWEEP", ULONG2NUM(B_SWEEP));

  rb_define_const(mBe, "FX_1", ULONG2NUM(B_FX_1));
  rb_define_const(mBe, "FX_2", ULONG2NUM(B_FX_2));
  rb_define_const(mBe, "FX_3", ULONG2NUM(B_FX_3));
  rb_define_const(mBe, "FX_4", ULONG2NUM(B_FX_4));
  rb_define_const(mBe, "FX_5", ULONG2NUM(B_FX_5));
  rb_define_const(mBe, "FX_6", ULONG2NUM(B_FX_6));
  rb_define_const(mBe, "FX_7", ULONG2NUM(B_FX_7));
  rb_define_const(mBe, "FX_8", ULONG2NUM(B_FX_8));

  rb_define_const(mBe, "SITAR", ULONG2NUM(B_SITAR));
  rb_define_const(mBe, "BANJO", ULONG2NUM(B_BANJO));
  rb_define_const(mBe, "SHAMISEN", ULONG2NUM(B_SHAMISEN));
  rb_define_const(mBe, "KOTO", ULONG2NUM(B_KOTO));
  rb_define_const(mBe, "KALIMBA", ULONG2NUM(B_KALIMBA));
  rb_define_const(mBe, "BAGPIPE", ULONG2NUM(B_BAGPIPE));
  rb_define_const(mBe, "FIDDLE", ULONG2NUM(B_FIDDLE));
  rb_define_const(mBe, "SHANAI", ULONG2NUM(B_SHANAI));

  rb_define_const(mBe, "TINKLE_BELL", ULONG2NUM(B_TINKLE_BELL));
  rb_define_const(mBe, "AGOGO", ULONG2NUM(B_AGOGO));
  rb_define_const(mBe, "STEEL_DRUMS", ULONG2NUM(B_STEEL_DRUMS));
  rb_define_const(mBe, "WOODBLOCK", ULONG2NUM(B_WOODBLOCK));
  rb_define_const(mBe, "TAIKO_DRUMS", ULONG2NUM(B_TAIKO_DRUMS));
  rb_define_const(mBe, "MELODIC_TOM", ULONG2NUM(B_MELODIC_TOM));
  rb_define_const(mBe, "SYNTH_DRUM", ULONG2NUM(B_SYNTH_DRUM));
  rb_define_const(mBe, "REVERSE_CYMBAL", ULONG2NUM(B_REVERSE_CYMBAL));

  rb_define_const(mBe, "FRET_NOISE", ULONG2NUM(B_FRET_NOISE));
  rb_define_const(mBe, "BREATH_NOISE", ULONG2NUM(B_BREATH_NOISE));
  rb_define_const(mBe, "SEASHORE", ULONG2NUM(B_SEASHORE));
  rb_define_const(mBe, "BIRD_TWEET", ULONG2NUM(B_BIRD_TWEET));
  rb_define_const(mBe, "TELEPHONE", ULONG2NUM(B_TELEPHONE));
  rb_define_const(mBe, "HELICOPTER", ULONG2NUM(B_HELICOPTER));
  rb_define_const(mBe, "APPLAUSE", ULONG2NUM(B_APPLAUSE));
  rb_define_const(mBe, "GUNSHOT", ULONG2NUM(B_GUNSHOT));
}
