/*
 *  Rect.cc
 */

#include "rbPoint.h"
#include "rbRect.h"
#include "my_be.h"


VALUE cRect;


void
delete_rect(BRect *arg0)
{
  delete arg0;
}


static VALUE
rb_rect_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_rect);
  return vresult;
}


static VALUE
rb_rect_initialize(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, varg3, varg4;
  BRect *result;

  Data_To_Null(self, BRect);

  switch(rb_scan_args(argc, argv, "04", &varg1, &varg2, &varg3, &varg4)) {
    case 0:
      result = new Rect();
      break;

    case 1:
      {
        BRect *arg1;
        Get_BInstance(Rect, varg1, arg1);
        result = new Rect(*arg1);
      }
      break;

    case 2:
      {
        BPoint *arg1, *arg2;

        Get_BInstance(Point, varg1, arg1);
        Get_BInstance(Point, varg2, arg2);
        result =  new Rect(*arg1, *arg2);
      }
      break;

    case 3:
      DEBUG_TRACE();
      rb_raise(rb_eArgError, "wrong # of arguments");
      break;

    case 4:
      {
        float arg1, arg2, arg3, arg4;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg3 = NUM2DBL(varg3);
        arg4 = NUM2DBL(varg4);
        result = new Rect(arg1, arg2, arg3, arg4);
      }
      break;

    default:
      rb_bug("rb_rect_initialize");
  }
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_rect_left_set(VALUE self, VALUE varg1)
{
  BRect *arg0;
  float arg1;

  Get_BInstance(Rect, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg0->left = arg1;
  return varg1;
}


static VALUE
rb_rect_left_ref(VALUE self)
{
  BRect *arg0;
  float result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->left;
  vresult = rb_float_new(result);
  return vresult;
}


static VALUE
rb_rect_top_set(VALUE self, VALUE varg1)
{
  BRect *arg0;
  float arg1;

  Get_BInstance(Rect, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg0->top = arg1;
  return varg1;
}


static VALUE
rb_rect_top_ref(VALUE self)
{
  BRect *arg0;
  float result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->top;
  vresult = rb_float_new(result);
  return vresult;
}


static VALUE
rb_rect_right_set(VALUE self, VALUE varg1)
{
  BRect *arg0;
  float arg1;

  Get_BInstance(Rect, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg0->right = arg1;
  return varg1;
}


static VALUE
rb_rect_right_ref(VALUE self)
{
  BRect *arg0;
  float result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->right;
  vresult = rb_float_new(result);
  return vresult;
}


static VALUE
rb_rect_bottom_set(VALUE self, VALUE varg1)
{
  BRect *arg0;
  float arg1;

  Get_BInstance(Rect, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg0->bottom = arg1;
  return varg1;
}


static VALUE
rb_rect_bottom_ref(VALUE self)
{
  BRect *arg0;
  float result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->bottom;
  vresult = rb_float_new(result);
  return vresult;
}


static VALUE
rb_rect_Set(VALUE self, VALUE varg1, VALUE varg2, VALUE varg3, VALUE varg4)
{
  BRect *arg0;
  float arg1, arg2, arg3, arg4;

  Get_BInstance(Rect, self, arg0);
  arg1 = NUM2DBL(varg1);
  arg2 = NUM2DBL(varg2);
  arg3 = NUM2DBL(varg3);
  arg4 = NUM2DBL(varg4);
  arg0->Set(arg1, arg2, arg3, arg4);
  return Qnil;
}


static VALUE
rb_rect_PrintToStream(VALUE self)
{
  BRect *arg0;

  Get_BInstance(Rect, self, arg0);
  arg0->PrintToStream();
  return Qnil;
}


static VALUE
rb_rect_LeftTop(VALUE self)
{
  BRect *arg0;
  BPoint *result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = new Point(arg0->LeftTop());
  vresult = Data_Wrap_Struct(cPoint, 0, delete_point, result);
  return vresult;
}


static VALUE
rb_rect_RightBottom(VALUE self)
{
  BRect *arg0;
  BPoint *result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = new Point(arg0->RightBottom());
  vresult = Data_Wrap_Struct(cPoint, 0, delete_point, result);
  return vresult;
}


static VALUE
rb_rect_LeftBottom(VALUE self)
{
  BRect *arg0;
  BPoint *result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = new Point(arg0->LeftBottom());
  vresult = Data_Wrap_Struct(cPoint, 0, delete_point, result);
  return vresult;
}


static VALUE
rb_rect_RightTop(VALUE self)
{
  BRect *arg0;
  BPoint *result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = new Point(arg0->RightTop());
  vresult = Data_Wrap_Struct(cPoint, 0, delete_point, result);
  return vresult;
}


static VALUE
rb_rect_SetLeftTop(VALUE self, VALUE varg1)
{
  BRect *arg0;
  BPoint *arg1;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->SetLeftTop(*arg1);
  return Qnil;
}


static VALUE
rb_rect_SetRightBottom(VALUE self, VALUE varg1)
{
  BRect *arg0;
  BPoint *arg1;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->SetRightBottom(*arg1);
  return Qnil;
}


static VALUE
rb_rect_SetLeftBottom(VALUE self, VALUE varg1)
{
  BRect *arg0;
  BPoint *arg1;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->SetLeftBottom(*arg1);
  return Qnil;
}


static VALUE
rb_rect_SetRightTop(VALUE self, VALUE varg1)
{
  BRect *arg0;
  BPoint *arg1;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Point, varg1, arg1);
  arg0->SetRightTop(*arg1);
  return Qnil;
}


static VALUE
rb_rect_InsetBy(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0;
  VALUE varg1, varg2;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)){
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        arg0->InsetBy(*arg1);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg0->InsetBy(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_rect_InsetBy");
  }
  return Qnil;
}


static VALUE
rb_rect_OffsetBy(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0;
  VALUE varg1, varg2;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)){
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        arg0->OffsetBy(*arg1);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg0->OffsetBy(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_rect_OffsetBy");
  }
  return Qnil;
}


static VALUE
rb_rect_OffsetTo(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0;
  VALUE varg1, varg2;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        arg0->OffsetTo(*arg1);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg0->OffsetTo(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_rect_OffsetTo");
  }
  return Qnil;
}


static VALUE
rb_rect_InsetBySelf(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0;
  VALUE varg1, varg2;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        arg0->InsetBySelf(*arg1);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg0->InsetBySelf(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_rect_InsetBySelf");
  }
  return self;
}


static VALUE
rb_rect_InsetByCopy(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0, *result;
  VALUE varg1, varg2, vresult;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);

        BRect copy = arg0->InsetByCopy(*arg1);
        result = new Rect(copy);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        result = new Rect(arg0->InsetByCopy(arg1, arg2));
      }
      break;

    default:
      rb_bug("rb_rect_InsetByCopy");
  }
  vresult = Data_Wrap_Struct(cRect, 0, delete_rect, result);
  return vresult;
}


static VALUE
rb_rect_OffsetBySelf(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0;
  VALUE varg1, varg2;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        arg0->OffsetBySelf(*arg1);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg0->OffsetBySelf(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_rect_OffsetBySelf");
  }
  return self;
}


static VALUE
rb_rect_OffsetByCopy(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0, *result;
  VALUE varg1, varg2, vresult;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        result = new Rect(arg0->OffsetByCopy(*arg1));
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        result = new Rect(arg0->OffsetByCopy(arg1, arg2));
      }
      break;

    default:
      rb_bug("rb_rect_OffsetByCopy");
  }
  vresult = Data_Wrap_Struct(cRect, 0, delete_rect, result);
  return vresult;
}


static VALUE
rb_rect_OffsetToSelf(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0;
  VALUE varg1, varg2;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        arg0->OffsetToSelf(*arg1);
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        arg0->OffsetToSelf(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_rect_OffsetToSelf");
  }
  return self;
}


static VALUE
rb_rect_OffsetToCopy(int argc, VALUE *argv, VALUE self)
{
  BRect *arg0, *result;
  VALUE varg1, varg2, vresult;

  Get_BInstance(Rect, self, arg0);
  switch(rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BPoint *arg1;

        Get_BInstance(Point, varg1, arg1);
        result = new Rect(arg0->OffsetToCopy(*arg1));
      }
      break;

    case 2:
      {
        float arg1, arg2;

        arg1 = NUM2DBL(varg1);
        arg2 = NUM2DBL(varg2);
        result = new Rect(arg0->OffsetToCopy(arg1, arg2));
      }
      break;

    default:
      rb_bug("rb_rect_OffsetToCopy");
  }
  vresult = Data_Wrap_Struct(cRect, 0, delete_rect, result);
  return vresult;
}


static VALUE
rb_rect_equal(VALUE self, VALUE varg1)
{
  BRect *arg0, *arg1;

  if (!rb_obj_is_kind_of(varg1, cRect)) {
    return Qfalse;
  }

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Rect, varg1, arg1);

  if (*arg0 == *arg1) {
    return Qtrue;
  }
  return Qfalse;
}


static VALUE
rb_rect_not_equal(VALUE self, VALUE varg1)
{
  BRect *arg0, *arg1;

  if (!rb_obj_is_kind_of(varg1, cRect)) {
    return Qtrue;
  }

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Rect, varg1, arg1);

  if (*arg0 != *arg1) {
    return Qtrue;
  }
  return Qfalse;
}


static VALUE
rb_rect_and(VALUE self, VALUE varg1)
{
  BRect *arg0, *arg1, *result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Rect, varg1, arg1);

  result = new Rect((*arg0 & *arg1));
  vresult = Data_Wrap_Struct(cRect, 0, delete_rect, result);
  return vresult;
}


static VALUE
rb_rect_or(VALUE self, VALUE varg1)
{
  BRect *arg0, *arg1, *result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Rect, varg1, arg1);

  result = new Rect((*arg0 | *arg1));
  vresult = Data_Wrap_Struct(cRect, 0, delete_rect, result);
  return vresult;
}


static VALUE
rb_rect_Intersects(VALUE self, VALUE varg1)
{
  BRect *arg0, *arg1;
  bool result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  Get_BInstance(Rect, varg1, arg1);
  result = arg0->Intersects(*arg1);
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_rect_IsValid(VALUE self)
{
  BRect *arg0;
  bool result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->IsValid();
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_rect_Width(VALUE self)
{
  BRect *arg0;
  float result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->Width();
  vresult = rb_float_new(result);
  return vresult;
}


static VALUE
rb_rect_IntegerWidth(VALUE self)
{
  BRect *arg0;
  int32 result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->IntegerWidth();
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
rb_rect_Height(VALUE self)
{
  BRect *arg0;
  float result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->Height();
  vresult = rb_float_new(result);
  return vresult;
}


static VALUE
rb_rect_IntegerHeight(VALUE self)
{
  BRect *arg0;
  int32 result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);
  result = arg0->IntegerHeight();
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
rb_rect_Contains(VALUE self, VALUE varg1)
{
  BRect *arg0;
  bool result;
  VALUE vresult;

  Get_BInstance(Rect, self, arg0);

  if (rb_obj_is_kind_of(varg1, cRect)) {
    BRect *arg1;

    Get_BInstance(Rect, varg1, arg1);
    result = arg0->Contains(*arg1);
  }
  else {
    BPoint *arg1;

    Get_BInstance(Point, varg1, arg1);
    result = arg0->Contains(*arg1);
  }
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_rect_inspect(VALUE self)
{
  BRect *arg0;
  VALUE str;
  char *c;

  Get_BInstance(Rect, self, arg0);

  c = rb_class2name(CLASS_OF(self));
  str = rb_str_new2("#<");
  str = rb_str_cat2(str, c);

  str = rb_str_cat2(str, " left=");
  str = rb_str_concat(str, rb_obj_as_string(rb_float_new(arg0->left)));
  str = rb_str_cat2(str, " top=");
  str = rb_str_concat(str, rb_obj_as_string(rb_float_new(arg0->top)));
  str = rb_str_cat2(str, " right=");
  str = rb_str_concat(str, rb_obj_as_string(rb_float_new(arg0->right)));
  str = rb_str_cat2(str, " bottom=");
  str = rb_str_concat(str, rb_obj_as_string(rb_float_new(arg0->bottom)));

  str = rb_str_cat2(str, ">");
  return str;
}


void
Init_Rect()
{
  cRect = rb_define_class_under(mBe, "Rect", rb_cObject);
  rb_define_singleton_method(cRect, "new", RUBY_METHOD_FUNC(rb_rect_s_new), -1);
  rb_define_method(cRect, "initialize", RUBY_METHOD_FUNC(rb_rect_initialize), -1);

  rb_define_method(cRect, "left=", RUBY_METHOD_FUNC(rb_rect_left_set), 1);
  rb_define_method(cRect, "left", RUBY_METHOD_FUNC(rb_rect_left_ref), 0);
  rb_define_method(cRect, "top=", RUBY_METHOD_FUNC(rb_rect_top_set), 1);
  rb_define_method(cRect, "top", RUBY_METHOD_FUNC(rb_rect_top_ref), 0);
  rb_define_method(cRect, "right=", RUBY_METHOD_FUNC(rb_rect_right_set), 1);
  rb_define_method(cRect, "right", RUBY_METHOD_FUNC(rb_rect_right_ref), 0);
  rb_define_method(cRect, "bottom=", RUBY_METHOD_FUNC(rb_rect_bottom_set), 1);
  rb_define_method(cRect, "bottom", RUBY_METHOD_FUNC(rb_rect_bottom_ref), 0);

  rb_define_method(cRect, "Set", RUBY_METHOD_FUNC(rb_rect_Set), 4);

  rb_define_method(cRect, "PrintToStream", RUBY_METHOD_FUNC(rb_rect_PrintToStream), 0);

  rb_define_method(cRect, "LeftTop", RUBY_METHOD_FUNC(rb_rect_LeftTop), 0);
  rb_define_method(cRect, "RightBottom", RUBY_METHOD_FUNC(rb_rect_RightBottom), 0);
  rb_define_method(cRect, "LeftBottom", RUBY_METHOD_FUNC(rb_rect_LeftBottom), 0);
  rb_define_method(cRect, "RightTop", RUBY_METHOD_FUNC(rb_rect_RightTop), 0);

  rb_define_method(cRect, "SetLeftTop", RUBY_METHOD_FUNC(rb_rect_SetLeftTop), 1);
  rb_define_method(cRect, "SetRightBottom", RUBY_METHOD_FUNC(rb_rect_SetRightBottom), 1);
  rb_define_method(cRect, "SetLeftBottom", RUBY_METHOD_FUNC(rb_rect_SetLeftBottom), 1);
  rb_define_method(cRect, "SetRightTop", RUBY_METHOD_FUNC(rb_rect_SetRightTop), 1);

  rb_define_method(cRect, "InsetBy", RUBY_METHOD_FUNC(rb_rect_InsetBy), -1);
  rb_define_method(cRect, "OffsetBy", RUBY_METHOD_FUNC(rb_rect_OffsetBy), -1);
  rb_define_method(cRect, "OffsetTo", RUBY_METHOD_FUNC(rb_rect_OffsetTo), -1);

  rb_define_method(cRect, "InsetBySelf", RUBY_METHOD_FUNC(rb_rect_InsetBySelf), -1);
  rb_define_method(cRect, "InsetByCopy", RUBY_METHOD_FUNC(rb_rect_InsetByCopy), -1);
  rb_define_method(cRect, "OffsetBySelf", RUBY_METHOD_FUNC(rb_rect_OffsetBySelf), -1);
  rb_define_method(cRect, "OffsetByCopy", RUBY_METHOD_FUNC(rb_rect_OffsetByCopy), -1);
  rb_define_method(cRect, "OffsetToSelf", RUBY_METHOD_FUNC(rb_rect_OffsetToSelf), -1);
  rb_define_method(cRect, "OffsetToCopy", RUBY_METHOD_FUNC(rb_rect_OffsetToCopy), -1);

  rb_define_method(cRect, "==", RUBY_METHOD_FUNC(rb_rect_equal), 1);
  rb_define_method(cRect, "!=", RUBY_METHOD_FUNC(rb_rect_not_equal), 1);

  rb_define_method(cRect, "&", RUBY_METHOD_FUNC(rb_rect_and), 1);
  rb_define_method(cRect, "|", RUBY_METHOD_FUNC(rb_rect_or), 1);

  rb_define_method(cRect, "Intersects", RUBY_METHOD_FUNC(rb_rect_Intersects), 1);
  rb_define_method(cRect, "IsValid", RUBY_METHOD_FUNC(rb_rect_IsValid), 0);
  rb_define_method(cRect, "Width", RUBY_METHOD_FUNC(rb_rect_Width), 0);
  rb_define_method(cRect, "IntegerWidth", RUBY_METHOD_FUNC(rb_rect_IntegerWidth), 0);
  rb_define_method(cRect, "Height", RUBY_METHOD_FUNC(rb_rect_Height), 0);
  rb_define_method(cRect, "IntegerHeight", RUBY_METHOD_FUNC(rb_rect_IntegerHeight), 0);
  rb_define_method(cRect, "Contains", RUBY_METHOD_FUNC(rb_rect_Contains), 1);

  rb_define_method(cRect, "inspect", RUBY_METHOD_FUNC(rb_rect_inspect), 0);
}
