/*
 *  Roster.cc
 */

#include <List.h>
#include <Roster.h>
#include "rbMessage.h"
#include "my_be.h"


VALUE cRoster;
VALUE cApp_info;
VALUE my_roster; // $be_roster


void
delete_app_info(app_info *arg0)
{
  delete arg0;
}


static VALUE
rb_app_info_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_app_info);
  return vresult;
}


static VALUE
rb_app_info_initialize(VALUE self)
{
  app_info *result;

  Data_To_Null(self, app_info);
  result = my_create_be_obj<app_info>();
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_app_info_thread_set(VALUE self, VALUE varg1)
{
  app_info *arg0;
  thread_id arg1;

  Get_BInstance2(App_info, app_info, self, arg0);
  arg1 = NUM2LONG(varg1);
  arg0->thread = arg1;
  return varg1;
}


static VALUE
rb_app_info_thread_ref(VALUE self)
{
  app_info *arg0;
  thread_id result;
  VALUE vresult;

  Get_BInstance2(App_info, app_info, self, arg0);
  result = arg0->thread;
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
rb_app_info_team_set(VALUE self, VALUE varg1)
{
  app_info *arg0;
  team_id arg1;

  Get_BInstance2(App_info, app_info, self, arg0);
  arg1 = NUM2LONG(varg1);
  arg0->team = arg1;
  return varg1;
}


static VALUE
rb_app_info_team_ref(VALUE self)
{
  app_info *arg0;
  team_id result;
  VALUE vresult;

  Get_BInstance2(App_info, app_info, self, arg0);
  result = arg0->team;
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
rb_app_info_port_set(VALUE self, VALUE varg1)
{
  app_info *arg0;
  port_id arg1;

  Get_BInstance2(App_info, app_info, self, arg0);
  arg1 = NUM2LONG(varg1);
  arg0->port = arg1;
  return varg1;
}


static VALUE
rb_app_info_port_ref(VALUE self)
{
  app_info *arg0;
  port_id result;
  VALUE vresult;

  Get_BInstance2(App_info, app_info, self, arg0);
  result = arg0->port;
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
rb_app_info_flags_set(VALUE self, VALUE varg1)
{
  app_info *arg0;
  uint32 arg1;

  Get_BInstance2(App_info, app_info, self, arg0);
  arg1 = NUM2ULONG(varg1);
  arg0->flags = arg1;
  return varg1;
}


static VALUE
rb_app_info_flags_ref(VALUE self)
{
  app_info *arg0;
  uint32 result;
  VALUE vresult;

  Get_BInstance2(App_info, app_info, self, arg0);
  result = arg0->flags;
  vresult = ULONG2NUM(result);
  return vresult;
}


static VALUE
rb_app_info_ref_set(VALUE self, VALUE varg1)
{
  app_info *arg0;
  entry_ref *arg1;

  Get_BInstance2(App_info, app_info, self, arg0);
  Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
  arg0->ref = *arg1;
  return varg1;
}


static VALUE
rb_app_info_ref_ref(VALUE self)
{
  app_info *arg0;
  entry_ref *result;
  VALUE vresult;

  Get_BInstance2(App_info, app_info, self, arg0);
  NEW(result, entry_ref(arg0->ref));
  vresult = Data_Wrap_Struct(cEntry_ref, 0, delete_entry_ref, result);
  return vresult;
}


static VALUE
rb_app_info_signature_set(VALUE self, VALUE varg1)
{
  app_info *arg0;
  char *arg1;
  int len=0;

  Get_BInstance2(App_info, app_info, self, arg0);
  arg1 = rb_str2cstr(varg1, &len);

  if (len >= B_MIME_TYPE_LENGTH) {
    len = B_MIME_TYPE_LENGTH - 1;
  }
  memcpy(arg0->signature, arg1, len);
  arg0->signature[len] = '\0';

  return varg1;
}


static VALUE
rb_app_info_signature_ref(VALUE self)
{
  app_info *arg0;
  VALUE vresult;

  Get_BInstance2(App_info, app_info, self, arg0);
  vresult = rb_str_new2(arg0->signature);
  return vresult;
}


static VALUE
rb_app_info_inspect(VALUE self)
{
  app_info *arg0;
  VALUE str;
  char *c;

  Get_BInstance2(App_info, app_info, self, arg0);

  c = rb_class2name(CLASS_OF(self));
  str = rb_str_new2("#<");
  str = rb_str_cat2(str, c);

  str = rb_str_cat2(str, " thread=");
  str = rb_str_concat(str, rb_obj_as_string(LONG2NUM(arg0->thread)));
  str = rb_str_cat2(str, " team=");
  str = rb_str_concat(str, rb_obj_as_string(LONG2NUM(arg0->team)));
  str = rb_str_cat2(str, " port=");
  str = rb_str_concat(str, rb_obj_as_string(LONG2NUM(arg0->port)));
  str = rb_str_cat2(str, " flags=");
  str = rb_str_concat(str, rb_obj_as_string(ULONG2NUM(arg0->flags)));
  str = rb_str_cat2(str, " ref=");
  str = rb_str_concat(str, rb_inspect(Data_Wrap_Struct(cEntry_ref, 0, 0, &(arg0->ref))));
  str = rb_str_cat2(str, " signature=");
  str = rb_str_cat2(str, arg0->signature);

  str = rb_str_cat2(str, ">");
  return str;
}


void
delete_roster(BRoster *arg0)
{
  delete arg0;
}


static VALUE
rb_roster_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_roster);
  return vresult;
}


static VALUE
rb_roster_initialize(VALUE self)
{
  BRoster *result;

  Data_To_Null(self, BRoster);
  result = my_create_be_obj<BRoster>();
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_roster_IsRunning(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  bool result;
  VALUE vresult;

  Get_BInstance(Roster, self, arg0);
  if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
    entry_ref *arg1;

    Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
    result = arg0->IsRunning(arg1);
  }
  else {
    char *arg1;

    arg1 = STR2CSTR(varg1);
    result = arg0->IsRunning(arg1);
  }
  vresult = (result ? Qtrue:Qfalse);
  return vresult;
}


static VALUE
rb_roster_TeamFor(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  team_id result;
  VALUE vresult;

  Get_BInstance(Roster, self, arg0);
  if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
    entry_ref *arg1;

    Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
    result = arg0->TeamFor(arg1);
  }
  else {
    char *arg1;

    arg1 = STR2CSTR(varg1);
    result = arg0->TeamFor(arg1);
  }
  if (result == B_ERROR) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = LONG2NUM(result);
  return vresult;
}


static VALUE
my_team_id_list2rarry(BList &list)
{
  VALUE vresult;
  int32 n;
  team_id id;

  vresult = rb_ary_new();

  n = list.CountItems();
  for (int32 i=0; i < n; i++) {
    id = reinterpret_cast<team_id>(list.ItemAt(i));
    rb_ary_push(vresult, LONG2NUM(id));
  }
  return vresult;
}


static VALUE
rb_roster_GetAppList(int argc, VALUE *argv, VALUE self)
{
  BRoster *arg0;
  BList team_id_list;
  VALUE varg1;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      arg0->GetAppList(&team_id_list);
      break;

    case 1:
      {
        char *arg1;

        arg1 = STR2CSTR(varg1);
        arg0->GetAppList(arg1, &team_id_list);
      }
      break;

    default:
      rb_bug("rb_roster_GetAppList");
  }

  VALUE vresult;
  vresult = my_team_id_list2rarry(team_id_list);
  return vresult;
}


static VALUE
rb_roster_GetAppInfo(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  app_info *arg2;
  status_t result;
  VALUE vresult;

  Get_BInstance(Roster, self, arg0);
  arg2 = my_create_be_obj<app_info>();
  if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
    entry_ref *arg1;

    Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
    result = arg0->GetAppInfo(arg1, arg2);
  }
  else {
    char *arg1;

    arg1 = STR2CSTR(varg1);
    result = arg0->GetAppInfo(arg1, arg2);
  }
  vresult = Data_Wrap_Struct(cApp_info, 0, delete_app_info, arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return vresult;
}


static VALUE
rb_roster_GetRunningAppInfo(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  team_id arg1;
  app_info *arg2;
  status_t result;
  VALUE vresult;

  Get_BInstance(Roster, self, arg0);
  arg2 = my_create_be_obj<app_info>();
  arg1 = NUM2LONG(varg1);
  result = arg0->GetRunningAppInfo(arg1, arg2);
  vresult = Data_Wrap_Struct(cApp_info, 0, delete_app_info, arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return vresult;
}


static VALUE
rb_roster_GetActiveAppInfo(VALUE self)
{
  BRoster *arg0;
  app_info *arg1;
  status_t result;
  VALUE vresult;

  Get_BInstance(Roster, self, arg0);
  arg1 = my_create_be_obj<app_info>();
  result = arg0->GetActiveAppInfo(arg1);
  vresult = Data_Wrap_Struct(cApp_info, 0, delete_app_info, arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return vresult;
}


static VALUE
rb_roster_FindApp(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  entry_ref arg2, *copy;
  status_t result;
  VALUE vresult;

  Get_BInstance(Roster, self, arg0);
  if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
    entry_ref *arg1;

    Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
    result = arg0->FindApp(arg1, &arg2);
  }
  else {
    char *arg1;

    arg1 = STR2CSTR(varg1);
    result = arg0->FindApp(arg1, &arg2);
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  NEW(copy, entry_ref(arg2));
  vresult = Data_Wrap_Struct(cEntry_ref, 0, delete_entry_ref, copy);
  return vresult;
}


static VALUE
rb_roster_Broadcast(int argc, VALUE *argv, VALUE self)
{
  BRoster *arg0;
  status_t result;
  VALUE varg1, varg2;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BMessage *arg1;

        Get_BInstance(Message, varg1, arg1);
        result = arg0->Broadcast(arg1);
      }
      break;

    case 2:
      {
        BMessage *arg1;
        BMessenger *arg2;

        Get_BInstance(Message, varg1, arg1);
        Get_BInstance(Messenger, varg2, arg2);
        result = arg0->Broadcast(arg1, *arg2);
      }
      break;

    default:
      rb_bug("rb_roster_Broadcast");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_roster_StartWatching(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  BRoster *arg0;
  status_t result;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        BMessenger *arg1;

        Get_BInstance(Messenger, varg1, arg1);
        result = arg0->StartWatching(*arg1);
      }
      break;

    case 2:
      {
        BMessenger *arg1;
        uint32 arg2;

        Get_BInstance(Messenger, varg1, arg1);
        arg2 = NUM2ULONG(varg2);
        result = arg0->StartWatching(*arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_roster_StartWatching");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_roster_StopWatching(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  BMessenger *arg1;
  status_t result;

  Get_BInstance(Roster, self, arg0);
  Get_BInstance(Messenger, varg1, arg1);
  result = arg0->StopWatching(*arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_roster_ActivateApp(VALUE self, VALUE varg1)
{
  BRoster *arg0;
  team_id arg1;
  status_t result;

  Get_BInstance(Roster, self, arg0);
  arg1 = NUM2LONG(varg1);
  result = arg0->ActivateApp(arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static BList
my_rarray2msg_list(VALUE ary)
{
  BMessage *msg;
  int32 len;

  Check_Type(ary, T_ARRAY);

  len = RARRAY(ary)->len;
  BList ls(len);

  for (int32 i=0; i < len; i++) {
    Get_BInstance(Message, RARRAY(ary)->ptr[i], msg);
    ls.AddItem(msg);
  }
  return ls;
}


static VALUE
rb_roster_Launch(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2, vresult;
  BRoster *arg0;
  team_id app_team;
  status_t result;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
        entry_ref *arg1;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        result = arg0->Launch(arg1, (BMessage *)NULL, &app_team);
      }
      else {
        char *arg1;

        arg1 = STR2CSTR(varg1);
        result = arg0->Launch(arg1, (BList *)NULL, &app_team);
      }
      break;

    case 2:
      if (rb_obj_is_kind_of(varg1, cEntry_ref)) {
        entry_ref *arg1;
        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);

        if (rb_obj_is_kind_of(varg2, cMessage)) {
          BMessage *arg2;

          Get_BInstance(Message, varg2, arg2);
          result = arg0->Launch(arg1, arg2, &app_team);
        }
        else {
          if (rb_obj_is_kind_of(varg2, cList)) {
            BList *arg2;

            Get_BInstance(List, varg2, arg2);
            result = arg0->Launch(arg1, arg2, &app_team);
          }
          else {
            Check_Type(varg2, T_ARRAY);

            if (rb_obj_is_kind_of(RARRAY(varg2)->ptr[0], cMessage)) {
              BList arg2;

              arg2 = my_rarray2msg_list(varg2);
              result = arg0->Launch(arg1, &arg2, &app_team);
            }
            else {
              int arg2;
              char **arg3;

              arg2 = RARRAY(varg2)->len;
              arg3 = my_rarray2argv(varg2);
              result = arg0->Launch(arg1, arg2, arg3, &app_team);
              free(arg3);
            }
          }

        }
      }
      else {
        char *arg1;
        arg1 = STR2CSTR(varg1);

        if (rb_obj_is_kind_of(varg2, cMessage)) {
          BMessage *arg2;

          Get_BInstance(Message, varg2, arg2);
          result = arg0->Launch(arg1, arg2, &app_team);
        }
        else {
          if (rb_obj_is_kind_of(varg2, cList)) {
            BList *arg2;

            Get_BInstance(List, varg2, arg2);
            result = arg0->Launch(arg1, arg2, &app_team);
          }
          else {
            Check_Type(varg2, T_ARRAY);

            if (rb_obj_is_kind_of(RARRAY(varg2)->ptr[0], cMessage)) {
              BList arg2;

              arg2 = my_rarray2msg_list(varg2);
              result = arg0->Launch(arg1, &arg2, &app_team);
            }
            else {
              int arg2;
              char **arg3;

              arg2 = RARRAY(varg2)->len;
              arg3 = my_rarray2argv(varg2);
              result = arg0->Launch(arg1, arg2, arg3, &app_team);
              free(arg3);
            }
          }
        }
      }
      break;

    default:
      rb_bug("rb_roster_Launch");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = LONG2NUM(app_team);
  return vresult;
}


static VALUE
rb_roster_GetRecentDocuments(int argc, VALUE *argv, VALUE self)
{
  VALUE varg2, varg3, varg4, vresult;
  BRoster *arg0;
  BMessage arg1, *result;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "12", &varg2, &varg3, &varg4)) {
    case 1:
      {
        int32 arg2;

        arg2 = NUM2LONG(varg2);
        arg0->GetRecentDocuments(&arg1, arg2);
      }
      break;

    case 2:
      {
        int32 arg2;
        arg2 = NUM2LONG(varg2);

        if (TYPE(varg3) == T_ARRAY) {
          char **arg3 = NULL;
          int32 arg4;

          arg3 = my_rarray2argv(varg3);
          arg4 = RARRAY(varg3)->len;
          arg0->GetRecentDocuments(&arg1, arg2, (const char **)arg3, arg4);
          free(arg3);
        }
        else {
          char *arg3;

          arg3 = STR2CSTR(varg3);
          arg0->GetRecentDocuments(&arg1, arg2, arg3);
        }
      }
      break;

    case 3:
      {
        int32 arg2;
        arg2 = NUM2LONG(varg2);

        if (TYPE(varg3) == T_ARRAY) {
          char **arg3 = NULL, *arg5;
          int32 arg4;

          arg3 = my_rarray2argv(varg3);
          arg4 = RARRAY(varg3)->len;
          arg5 = STR2CSTR(varg4);
          arg0->GetRecentDocuments(&arg1, arg2, (const char **)arg3, arg4, arg5);
          free(arg3);
        }
        else {
          char *arg3, *arg4;

          arg3 = STR2CSTR(varg3);
          arg4 = STR2CSTR(varg4);
          arg0->GetRecentDocuments(&arg1, arg2, arg3, arg4);
        }
      }
      break;

    default:
      rb_bug("rb_roster_GetRecentDocuments");
  }

  result = new Message(arg1);
  vresult = Data_Wrap_Struct(cMessage, 0, delete_message, result);
  return vresult;
}


static VALUE
rb_roster_GetRecentFolders(int argc, VALUE *argv, VALUE self)
{
  VALUE varg2, varg3, vresult;
  BRoster *arg0;
  BMessage arg1, *result;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "11", &varg2, &varg3)) {
    case 1:
      {
        int32 arg2;

        arg2 = NUM2LONG(varg2);
        arg0->GetRecentFolders(&arg1, arg2);
      }
      break;

    case 2:
      {
        int32 arg2;
        char *arg3;

        arg2 = NUM2LONG(varg2);
        arg3 = STR2CSTR(varg3);
        arg0->GetRecentFolders(&arg1, arg2, arg3);
      }
      break;

    default:
      rb_bug("rb_roster_GetRecentFolders");
  }

  result = new Message(arg1);
  vresult = Data_Wrap_Struct(cMessage, 0, delete_message, result);
  return vresult;
}


static VALUE
rb_roster_GetRecentApps(VALUE self, VALUE varg2)
{
  VALUE vresult;
  BRoster *arg0;
  BMessage arg1, *result;
  int32 arg2;

  Get_BInstance(Roster, self, arg0);
  arg2 = NUM2LONG(varg2);

  arg0->GetRecentApps(&arg1, arg2);

  result = new Message(arg1);
  vresult = Data_Wrap_Struct(cMessage, 0, delete_message, result);
  return vresult;
}


static VALUE
rb_roster_AddToRecentDocuments(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  BRoster *arg0;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        entry_ref *arg1;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg0->AddToRecentDocuments(arg1);
      }
      break;

    case 2:
      {
        entry_ref *arg1;
        char *arg2;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg2 = STR2CSTR(varg2);

        arg0->AddToRecentDocuments(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_roster_AddToRecentDocuments");
  }
  return Qnil;
}


static VALUE
rb_roster_AddToRecentFolders(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  BRoster *arg0;

  Get_BInstance(Roster, self, arg0);
  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        entry_ref *arg1;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg0->AddToRecentFolders(arg1);
      }
      break;

    case 2:
      {
        entry_ref *arg1;
        char *arg2;

        Get_BInstance2(Entry_ref, entry_ref, varg1, arg1);
        arg2 = STR2CSTR(varg2);

        arg0->AddToRecentFolders(arg1, arg2);
      }
      break;

    default:
      rb_bug("rb_roster_AddToRecentFolders");
  }
  return Qnil;
}


void
Init_Roster()
{
  rb_global_variable(&my_roster);
  rb_define_readonly_variable("$be_roster", &my_roster);
  my_roster = Qnil;

  cApp_info = rb_define_class_under(mBe, "App_info", rb_cObject);
  rb_define_singleton_method(cApp_info, "new", RUBY_METHOD_FUNC(rb_app_info_s_new), -1);
  rb_define_method(cApp_info, "initialize", RUBY_METHOD_FUNC(rb_app_info_initialize), 0);
  rb_define_method(cApp_info, "thread=", RUBY_METHOD_FUNC(rb_app_info_thread_set), 1);
  rb_define_method(cApp_info, "thread", RUBY_METHOD_FUNC(rb_app_info_thread_ref), 0);
  rb_define_method(cApp_info, "team=", RUBY_METHOD_FUNC(rb_app_info_team_set), 1);
  rb_define_method(cApp_info, "team", RUBY_METHOD_FUNC(rb_app_info_team_ref), 0);
  rb_define_method(cApp_info, "port=", RUBY_METHOD_FUNC(rb_app_info_port_set), 1);
  rb_define_method(cApp_info, "port", RUBY_METHOD_FUNC(rb_app_info_port_ref), 0);
  rb_define_method(cApp_info, "flags=", RUBY_METHOD_FUNC(rb_app_info_flags_set), 1);
  rb_define_method(cApp_info, "flags", RUBY_METHOD_FUNC(rb_app_info_flags_ref), 0);
  rb_define_method(cApp_info, "ref=", RUBY_METHOD_FUNC(rb_app_info_ref_set), 1);
  rb_define_method(cApp_info, "ref", RUBY_METHOD_FUNC(rb_app_info_ref_ref), 0);
  rb_define_method(cApp_info, "signature=", RUBY_METHOD_FUNC(rb_app_info_signature_set), 1);
  rb_define_method(cApp_info, "signature", RUBY_METHOD_FUNC(rb_app_info_signature_ref), 0);
  rb_define_method(cApp_info, "inspect", RUBY_METHOD_FUNC(rb_app_info_inspect), 0);

  cRoster = rb_define_class_under(mBe, "Roster", rb_cObject);
  rb_define_singleton_method(cRoster, "new", RUBY_METHOD_FUNC(rb_roster_s_new), -1);
  rb_define_method(cRoster, "initialize", RUBY_METHOD_FUNC(rb_roster_initialize), 0);

  rb_define_method(cRoster, "IsRunning", RUBY_METHOD_FUNC(rb_roster_IsRunning), 1);
  rb_define_method(cRoster, "TeamFor", RUBY_METHOD_FUNC(rb_roster_TeamFor), 1);
  rb_define_method(cRoster, "GetAppList", RUBY_METHOD_FUNC(rb_roster_GetAppList), -1);
  rb_define_method(cRoster, "GetAppInfo", RUBY_METHOD_FUNC(rb_roster_GetAppInfo), 1);
  rb_define_method(cRoster, "GetRunningAppInfo", RUBY_METHOD_FUNC(rb_roster_GetRunningAppInfo), 1);
  rb_define_method(cRoster, "GetActiveAppInfo", RUBY_METHOD_FUNC(rb_roster_GetActiveAppInfo), 0);
  rb_define_method(cRoster, "FindApp", RUBY_METHOD_FUNC(rb_roster_FindApp), 1);

  rb_define_method(cRoster, "Broadcast", RUBY_METHOD_FUNC(rb_roster_Broadcast), -1);
  rb_define_method(cRoster, "StartWatching", RUBY_METHOD_FUNC(rb_roster_StartWatching), -1);
  rb_define_method(cRoster, "StopWatching", RUBY_METHOD_FUNC(rb_roster_StopWatching), 1);
  rb_define_method(cRoster, "ActivateApp", RUBY_METHOD_FUNC(rb_roster_ActivateApp), 1);
  rb_define_method(cRoster, "Launch", RUBY_METHOD_FUNC(rb_roster_Launch), -1);

  rb_define_method(cRoster, "GetRecentDocuments", RUBY_METHOD_FUNC(rb_roster_GetRecentDocuments), -1);
  rb_define_method(cRoster, "GetRecentFolders", RUBY_METHOD_FUNC(rb_roster_GetRecentFolders), -1);
  rb_define_method(cRoster, "GetRecentApps", RUBY_METHOD_FUNC(rb_roster_GetRecentApps), 1);

  rb_define_method(cRoster, "AddToRecentDocuments", RUBY_METHOD_FUNC(rb_roster_AddToRecentDocuments), -1);
  rb_define_method(cRoster, "AddToRecentFolders", RUBY_METHOD_FUNC(rb_roster_AddToRecentFolders), -1);

  rb_define_const(mBe, "LAUNCH_MASK", ULONG2NUM(B_LAUNCH_MASK));
  rb_define_const(mBe, "SINGLE_LAUNCH", ULONG2NUM(B_SINGLE_LAUNCH));
  rb_define_const(mBe, "MULTIPLE_LAUNCH", ULONG2NUM(B_MULTIPLE_LAUNCH));
  rb_define_const(mBe, "EXCLUSIVE_LAUNCH", ULONG2NUM(B_EXCLUSIVE_LAUNCH));
  rb_define_const(mBe, "BACKGROUND_APP", ULONG2NUM(B_BACKGROUND_APP));
  rb_define_const(mBe, "ARGV_ONLY", ULONG2NUM(B_ARGV_ONLY));
  rb_define_const(mBe, "REQUEST_LAUNCHED", ULONG2NUM(B_REQUEST_LAUNCHED));
  rb_define_const(mBe, "REQUEST_QUIT", ULONG2NUM(B_REQUEST_QUIT));
  rb_define_const(mBe, "REQUEST_ACTIVATED", ULONG2NUM(B_REQUEST_ACTIVATED));
  rb_define_const(mBe, "SOME_APP_LAUNCHED", ULONG2NUM(B_SOME_APP_LAUNCHED));
  rb_define_const(mBe, "SOME_APP_QUIT", ULONG2NUM(B_SOME_APP_QUIT));
  rb_define_const(mBe, "SOME_APP_ACTIVATED", ULONG2NUM(B_SOME_APP_ACTIVATED));
}
