/*
 *  StopWatch.cc
 */

#include <StopWatch.h>
#include "my_be.h"


VALUE cStopWatch;


void
delete_stopwatch(BStopWatch *arg0)
{
  delete arg0;
}


static VALUE
rb_stopwatch_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_stopwatch);
  return vresult;
}


static VALUE
rb_stopwatch_initialize(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, varg2;
  BStopWatch *result;

  Data_To_Null(self, BStopWatch);

  switch (rb_scan_args(argc, argv, "11", &varg1, &varg2)) {
    case 1:
      {
        char *arg1;

        arg1 = STR2CSTR(varg1);
        NEW(result, BStopWatch(arg1));
      }
      break;

    case 2:
      {
        char *arg1;
        bool arg2;

        arg1 = STR2CSTR(varg1);
        arg2 = RTEST(varg2);
        NEW(result, BStopWatch(arg1, arg2));
      }
      break;

    default:
      rb_bug("rb_stopwatch_initialize");
  }
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_stopwatch_Suspend(VALUE self)
{
  BStopWatch *arg0;

  Get_BInstance(StopWatch, self, arg0);
  arg0->Suspend();
  return Qnil;
}


static VALUE
rb_stopwatch_Resume(VALUE self)
{
  BStopWatch *arg0;

  Get_BInstance(StopWatch, self, arg0);
  arg0->Resume();
  return Qnil;
}


static VALUE
rb_stopwatch_Lap(VALUE self)
{
  BStopWatch *arg0;
  bigtime_t result;
  VALUE vresult;

  Get_BInstance(StopWatch, self, arg0);
  result = arg0->Lap();
  vresult = LLONG2NUM(result);
  return vresult;
}


static VALUE
rb_stopwatch_ElapsedTime(VALUE self)
{
  BStopWatch *arg0;
  bigtime_t result;
  VALUE vresult;

  Get_BInstance(StopWatch, self, arg0);
  result = arg0->ElapsedTime();
  vresult = LLONG2NUM(result);
  return vresult;
}


static VALUE
rb_stopwatch_Reset(VALUE self)
{
  BStopWatch *arg0;

  Get_BInstance(StopWatch, self, arg0);
  arg0->Reset();
  return Qnil;
}


static VALUE
rb_stopwatch_Name(VALUE self)
{
  BStopWatch *arg0;
  char *result;
  VALUE vresult;

  Get_BInstance(StopWatch, self, arg0);
  result = (char *)arg0->Name();
  vresult = rb_str_new2(result);
  return vresult;
}


void
Init_StopWatch()
{
  cStopWatch = rb_define_class_under(mBe, "StopWatch", rb_cObject);
  rb_define_singleton_method(cStopWatch, "new", RUBY_METHOD_FUNC(rb_stopwatch_s_new), -1);
  rb_define_method(cStopWatch, "initialize", RUBY_METHOD_FUNC(rb_stopwatch_initialize), -1);

  rb_define_method(cStopWatch, "Suspend", RUBY_METHOD_FUNC(rb_stopwatch_Suspend), 0);
  rb_define_method(cStopWatch, "Resume", RUBY_METHOD_FUNC(rb_stopwatch_Resume), 0);
  rb_define_method(cStopWatch, "Lap", RUBY_METHOD_FUNC(rb_stopwatch_Lap), 0);
  rb_define_method(cStopWatch, "ElapsedTime", RUBY_METHOD_FUNC(rb_stopwatch_ElapsedTime), 0);
  rb_define_method(cStopWatch, "Reset", RUBY_METHOD_FUNC(rb_stopwatch_Reset), 0);
  rb_define_method(cStopWatch, "Name", RUBY_METHOD_FUNC(rb_stopwatch_Name), 0);
}
