/*
 *  TranslatorRoster.cc
 */

#include <Entry.h>
#include <TranslatorRoster.h>
#include "my_be.h"
#include "rbMessage.h"


VALUE cTranslatorRoster;


void
delete_translatorroster(BTranslatorRoster *arg0)
{
  delete arg0;
}


static VALUE
rb_translatorroster_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_translatorroster);
  return vresult;
}


static VALUE
rb_translatorroster_initialize(int argc, VALUE *argv, VALUE self)
{
  BTranslatorRoster *result;
  VALUE varg1;

  Data_To_Null(self, BTranslatorRoster);

  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      result = my_create_be_obj<BTranslatorRoster>();
      break;

    case 1:
      {
        BMessage *arg1;

        Get_BInstance(Message, varg1, arg1);
        NEW(result, BTranslatorRoster(arg1));
      }
      break;

    default:
      rb_bug("rb_translatorroster_initialize");
  }
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_translatorroster_Version(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1, vresult;
  int32 arg1 = 0, arg2 = 0;
  const char *result;

  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      result = BTranslatorRoster::Version(&arg1, &arg2);
      break;

    case 1:
      {
        int32 arg3;

        arg3 = NUM2LONG(varg1);
        result = BTranslatorRoster::Version(&arg1, &arg2, arg3);
      }
      break;

    default:
      rb_bug("rb_translatorroster_Version");
  }
  vresult = rb_ary_new3(3, rb_str_new2(result),
                           LONG2NUM(arg1),
                           LONG2NUM(arg2));
  return vresult;
}


static VALUE
rb_translatorroster_Default(VALUE klass)
{
  BTranslatorRoster *result;
  VALUE vresult;

  result = BTranslatorRoster::Default();
  vresult = ((result) ? Data_Wrap_Struct(klass, 0, 0, result):Qnil);
  return vresult;
}


static VALUE
rb_translatorroster_AddTranslators(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1;
  BTranslatorRoster *arg0;
  status_t result;

  Get_BInstance(TranslatorRoster, self, arg0);
  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      result = arg0->AddTranslators();
      break;

    case 1:
      {
        char *arg1 = NULL;

        if (!NIL_P(varg1)) {
          arg1 = STR2CSTR(varg1);
        }
        result = arg0->AddTranslators(arg1);
      }
      break;

    default:
      rb_bug("rb_translatorroster_AddTranslators");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_translatorroster_AddTranslator(VALUE self, VALUE varg1)
{
  BTranslatorRoster *arg0;
  BTranslator *arg1;
  status_t result;

  Get_BInstance(TranslatorRoster, self, arg0);
  Get_BInstance(Translator, varg1, arg1);
  result = arg0->AddTranslator(arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_translatorroster_GetAllTranslators(VALUE self)
{
  BTranslatorRoster *arg0;
  translator_id *arg1 = NULL;
  int32 arg2 = 0;
  status_t result;
  VALUE vresult;

  Get_BInstance(TranslatorRoster, self, arg0);
  result = arg0->GetAllTranslators(&arg1, &arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = rb_ary_new();
  for (int32 i=0; i < arg2; i++) {
    rb_ary_push(vresult, ULONG2NUM(arg1[i]));
  }
  delete[] arg1;
  return vresult;
}


static VALUE
rb_translatorroster_GetTranslatorInfo(VALUE self, VALUE varg1)
{
  BTranslatorRoster *arg0;
  translator_id arg1;
  const char *arg2;
  const char *arg3;
  int32 arg4;
  status_t result;
  VALUE vresult;

  Get_BInstance(TranslatorRoster, self, arg0);
  arg1 = NUM2ULONG(varg1);
  result = arg0->GetTranslatorInfo(arg1, &arg2, &arg3, &arg4);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = rb_ary_new3(3, rb_str_new2(arg2), rb_str_new2(arg3), LONG2NUM(arg4));
  return vresult;
}


static VALUE
my_translation_format2array(const translation_format *&tfmt, int32 num)
{
  VALUE hash, vresult = rb_ary_new();
  for (int32 i=0; i < num; i++) {
    hash = rb_hash_new();
    rb_hash_aset(hash, rb_str_new2("type"),       ULONG2NUM(tfmt[i].type));
    rb_hash_aset(hash, rb_str_new2("group"),      ULONG2NUM(tfmt[i].group));
    rb_hash_aset(hash, rb_str_new2("quality"),    rb_float_new(tfmt[i].quality));
    rb_hash_aset(hash, rb_str_new2("capability"), rb_float_new(tfmt[i].capability));
    rb_hash_aset(hash, rb_str_new2("MIME"),       rb_str_new2(tfmt[i].MIME));
    rb_hash_aset(hash, rb_str_new2("name"),       rb_str_new2(tfmt[i].name));

    rb_ary_push(vresult, hash);
  }
  return vresult;
}


static VALUE
rb_translatorroster_GetInputFormats(VALUE self, VALUE varg1)
{
  BTranslatorRoster *arg0;
  translator_id arg1;
  const translation_format *arg2 = NULL;
  int32 arg3 = 0;
  status_t result;
  VALUE vresult;

  Get_BInstance(TranslatorRoster, self, arg0);
  arg1 = NUM2ULONG(varg1);
  result = arg0->GetInputFormats(arg1, &arg2, &arg3);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = my_translation_format2array(arg2, arg3);
  return vresult;
}


static VALUE
rb_translatorroster_GetOutputFormats(VALUE self, VALUE varg1)
{
  BTranslatorRoster *arg0;
  translator_id arg1;
  const translation_format *arg2 = NULL;
  int32 arg3 = 0;
  status_t result;
  VALUE vresult;

  Get_BInstance(TranslatorRoster, self, arg0);
  arg1 = NUM2ULONG(varg1);
  result = arg0->GetOutputFormats(arg1, &arg2, &arg3);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  vresult = my_translation_format2array(arg2, arg3);
  return vresult;
}


static VALUE
rb_translatorroster_GetConfigurationMessage(VALUE self, VALUE varg1)
{
  BTranslatorRoster *arg0;
  translator_id arg1;
  BMessage arg2, *copy;
  status_t result;
  VALUE vresult;

  Get_BInstance(TranslatorRoster, self, arg0);
  arg1 = NUM2ULONG(varg1);
  result = arg0->GetConfigurationMessage(arg1, &arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  copy = new Message(arg2);
  vresult = Data_Wrap_Struct(cMessage, 0, delete_message, copy);
  return vresult;
}


static VALUE
rb_translatorroster_GetRefFor(VALUE self, VALUE varg1)
{
  BTranslatorRoster *arg0;
  translator_id arg1;
  entry_ref arg2, *copy;
  status_t result;
  VALUE vresult;

  Get_BInstance(TranslatorRoster, self, arg0);
  arg1 = NUM2ULONG(varg1);
  result = arg0->GetRefFor(arg1, &arg2);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  NEW(copy, entry_ref(arg2));
  vresult = Data_Wrap_Struct(cEntry_ref, 0, delete_entry_ref, copy);
  return vresult;
}


void
Init_TranslatorRoster()
{
  cTranslatorRoster = rb_define_class_under(mBe, "TranslatorRoster", cArchivable);
  rb_define_singleton_method(cTranslatorRoster, "new", RUBY_METHOD_FUNC(rb_translatorroster_s_new), -1);
  rb_define_singleton_method(cTranslatorRoster, "Version", RUBY_METHOD_FUNC(rb_translatorroster_Version), -1);
  rb_define_singleton_method(cTranslatorRoster, "Default", RUBY_METHOD_FUNC(rb_translatorroster_Default), 0);
  rb_define_method(cTranslatorRoster, "initialize", RUBY_METHOD_FUNC(rb_translatorroster_initialize), -1);

  rb_define_method(cTranslatorRoster, "AddTranslators", RUBY_METHOD_FUNC(rb_translatorroster_AddTranslators), -1);
  rb_define_method(cTranslatorRoster, "AddTranslator", RUBY_METHOD_FUNC(rb_translatorroster_AddTranslator), 1);

  rb_define_method(cTranslatorRoster, "GetAllTranslators", RUBY_METHOD_FUNC(rb_translatorroster_GetAllTranslators), 0);
  rb_define_method(cTranslatorRoster, "GetTranslatorInfo", RUBY_METHOD_FUNC(rb_translatorroster_GetTranslatorInfo), 1);
  rb_define_method(cTranslatorRoster, "GetInputFormats", RUBY_METHOD_FUNC(rb_translatorroster_GetInputFormats), 1);
  rb_define_method(cTranslatorRoster, "GetOutputFormats", RUBY_METHOD_FUNC(rb_translatorroster_GetOutputFormats), 1);

  rb_define_method(cTranslatorRoster, "GetConfigurationMessage", RUBY_METHOD_FUNC(rb_translatorroster_GetConfigurationMessage), 1);
  rb_define_method(cTranslatorRoster, "GetRefFor", RUBY_METHOD_FUNC(rb_translatorroster_GetRefFor), 1);
}
