/*
 *  VolumeRoster.cc
 */

#include <VolumeRoster.h>
#include "rbMessenger.h"
#include "my_be.h"


VALUE cVolumeRoster;


void
delete_volumeroster(BVolumeRoster *arg0)
{
  delete arg0;
}


static VALUE
rb_volumeroster_s_new(int argc, VALUE *argv, VALUE klass)
{
  VALUE vresult = my_class_s_new(argc, argv, klass, delete_volumeroster);
  return vresult;
}


static VALUE
rb_volumeroster_initialize(VALUE self)
{
  BVolumeRoster *result;

  Data_To_Null(self, BVolumeRoster);
  result = my_create_be_obj<BVolumeRoster>();
  DATA_PTR(self) = result;
  return self;
}


static VALUE
rb_volumeroster_GetNextVolume(VALUE self)
{
  BVolumeRoster *arg0;
  BVolume arg1, *copy;
  status_t result;
  VALUE vresult = Qnil;

  Get_BInstance(VolumeRoster, self, arg0);
  if (rb_block_given_p()) {
    for (int32 i=0; arg0->GetNextVolume(&arg1) == B_OK; i++) {
      NEW(copy, BVolume(arg1));
      vresult = Data_Wrap_Struct(cVolume, 0, delete_volume, copy);
      vresult = rb_yield(vresult);
    }
  }
  else {
    result = arg0->GetNextVolume(&arg1);
    if (result != B_OK) {
      DEBUG_TRACE();
      my_raise(result);
    }
    NEW(copy, BVolume(arg1));
    vresult = Data_Wrap_Struct(cVolume, 0, delete_volume, copy);
  }
  return vresult;
}


static VALUE
rb_volumeroster_Rewind(VALUE self)
{
  BVolumeRoster *arg0;

  Get_BInstance(VolumeRoster, self, arg0);
  arg0->Rewind();
  return Qnil;
}


static VALUE
rb_volumeroster_GetBootVolume(VALUE self)
{
  BVolumeRoster *arg0;
  BVolume arg1, *copy;
  status_t result;
  VALUE vresult;

  Get_BInstance(VolumeRoster, self, arg0);
  result = arg0->GetBootVolume(&arg1);
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  NEW(copy, BVolume(arg1));
  vresult = Data_Wrap_Struct(cVolume, 0, delete_volume, copy);
  return vresult;
}


static VALUE
rb_volumeroster_StartWatching(int argc, VALUE *argv, VALUE self)
{
  VALUE varg1;
  BVolumeRoster *arg0;
  status_t result;

  Get_BInstance(VolumeRoster, self, arg0);
  switch (rb_scan_args(argc, argv, "01", &varg1)) {
    case 0:
      result = arg0->StartWatching();
      break;

    case 1:
      {
        BMessenger *arg1;

        Get_BInstance(Messenger, varg1, arg1);
        result = arg0->StartWatching(*arg1);
      }
      break;

    default:
      rb_bug("rb_volumeroster_StartWatching");
  }
  if (result != B_OK) {
    DEBUG_TRACE();
    my_raise(result);
  }
  return Qnil;
}


static VALUE
rb_volumeroster_StopWatching(VALUE self)
{
  BVolumeRoster *arg0;

  Get_BInstance(VolumeRoster, self, arg0);
  arg0->StopWatching();
  return Qnil;
}


static VALUE
rb_volumeroster_Messenger(VALUE self)
{
  BVolumeRoster *arg0;
  BMessenger *result;
  VALUE vresult;

  Get_BInstance(VolumeRoster, self, arg0);
  result = new Messenger(arg0->Messenger());
  vresult = Data_Wrap_Struct(cMessenger, 0, delete_messenger, result);
  return vresult;
}


void
Init_VolumeRoster()
{
  cVolumeRoster = rb_define_class_under(mBe, "VolumeRoster", rb_cObject);
  rb_define_singleton_method(cVolumeRoster, "new", RUBY_METHOD_FUNC(rb_volumeroster_s_new), -1);
  rb_define_method(cVolumeRoster, "initialize", RUBY_METHOD_FUNC(rb_volumeroster_initialize), 0);

  rb_define_method(cVolumeRoster, "GetNextVolume", RUBY_METHOD_FUNC(rb_volumeroster_GetNextVolume), 0);
  rb_define_method(cVolumeRoster, "Rewind", RUBY_METHOD_FUNC(rb_volumeroster_Rewind), 0);
  rb_define_method(cVolumeRoster, "GetBootVolume", RUBY_METHOD_FUNC(rb_volumeroster_GetBootVolume), 0);
  rb_define_method(cVolumeRoster, "StartWatching", RUBY_METHOD_FUNC(rb_volumeroster_StartWatching), -1);
  rb_define_method(cVolumeRoster, "StopWatching", RUBY_METHOD_FUNC(rb_volumeroster_StopWatching), 0);
  rb_define_method(cVolumeRoster, "Messenger", RUBY_METHOD_FUNC(rb_volumeroster_Messenger), 0);
}
