/*
 *  my_be.h
 */

#ifndef _MY_BE_H
#define _MY_BE_H


#include <Cursor.h>
#include <EntryList.h>
#include <ClassInfo.h>
#include <ruby.h>
#include "my_debug.h"


extern VALUE mBe;
extern VALUE be_object_list;
extern ID id_relatives;
extern ID id_DispatchMessage;
extern ID id_MessageReceived;

extern void my_add_relative(VALUE obj, VALUE relative);
extern void my_clear_relative(VALUE obj, VALUE relative);
extern VALUE my_data_wrap_object(VALUE klass, void *obj);
extern VALUE my_class_s_new(int argc, VALUE *argv, VALUE klass, void func(void*));


extern VALUE my_app;           /* $be_app           */
extern VALUE my_app_messenger; /* $be_app_messenger */
extern VALUE my_clipboard;     /* $be_clipboard     */
extern VALUE my_roster;        /* $be_roster        */
extern VALUE my_plain_font;    /* $be_plain_font    */
extern VALUE my_bold_font;     /* $be_bold_font     */
extern VALUE my_fixed_font;    /* $be_fixed_font    */


/* app */
extern VALUE cApplication;
extern VALUE cApp_info;
extern VALUE cClipboard;
extern VALUE cCursor;
extern VALUE cHandler;
extern VALUE cInvoker;
extern VALUE cLooper;
extern VALUE cMessage;
extern VALUE cMessageFilter;
extern VALUE cMessageQueue;
extern VALUE cMessageRunner;
extern VALUE cMessenger;
extern VALUE cRoster;
extern void Init_AppDefs();
extern void Init_Application();
extern void Init_Clipboard();
extern void Init_Cursor();
extern void Init_Handler();
extern void Init_Invoker();
extern void Init_Looper();
extern void Init_Message();
extern void Init_MessageFilter();
extern void Init_MessageQueue();
extern void Init_MessageRunner();
extern void Init_Messenger();
extern void Init_Roster();
extern void delete_application(BApplication *arg0);
extern void delete_app_info(app_info *arg0);
extern void delete_clipboard(BClipboard *arg0);
extern void delete_cursor(BCursor *arg0);
extern void delete_handler(BHandler *arg0);
extern void delete_invoker(BInvoker *arg0);
extern void delete_looper(BLooper *arg0);
extern void delete_message(BMessage *arg0);
extern void delete_messagefilter(BMessageFilter *arg0);
extern void delete_messagequeue(BMessageQueue *arg0);
extern void delete_messagerunner(BMessageRunner *arg0);
extern void delete_messenger(BMessenger *arg0);
extern void delete_roster(BRoster *arg0);
/* be_apps */
extern void Init_NetPositive();
extern void Init_Background();
/* interface */
extern VALUE cAlert;
extern VALUE cBitmap;
extern VALUE cButton;
extern VALUE cControl;
extern VALUE cFont;
extern VALUE cMenu;
extern VALUE cMenuBar;
extern VALUE cMenuItem;
extern VALUE cPicture;
extern VALUE cPoint;
extern VALUE cPolygon;
extern VALUE cRect;
extern VALUE cRegion;
extern VALUE cScrollView;
extern VALUE cSeparatorItem;
extern VALUE cStringView;
extern VALUE cTextView;
extern VALUE cView;
extern VALUE cWindow;
extern void Init_Alert();
extern void Init_Bitmap();
extern void Init_Button();
extern void Init_Control();
extern void Init_Font();
extern void Init_GraphicsDefs();
extern void Init_InterfaceDefs();
extern void Init_Menu();
extern void Init_MenuBar();
extern void Init_MenuItem();
extern void Init_Picture();
extern void Init_Point();
extern void Init_Polygon();
extern void Init_Rect();
extern void Init_Region();
extern void Init_ScrollView();
extern void Init_SeparatorItem();
extern void Init_StringView();
extern void Init_TextView();
extern void Init_View();
extern void Init_Window();
extern void delete_bitmap(BBitmap *arg0);
extern void delete_button(BButton *arg0);
extern void delete_control(BControl *arg0);
extern void delete_font(BFont *arg0);
extern void delete_menu(BMenu *arg0);
extern void delete_menubar(BMenuBar *arg0);
extern void delete_menuitem(BMenuItem *arg0);
extern void delete_picture(BPicture *arg0);
extern void delete_point(BPoint *arg0);
extern void delete_polygon(BPolygon *arg0);
extern void delete_rect(BRect *arg0);
extern void delete_region(BRegion *arg0);
extern void delete_scrollview(BScrollView *arg0);
extern void delete_separatoritem(BSeparatorItem *arg0);
extern void delete_stringview(BStringView *arg0);
extern void delete_textview(BTextView *arg0);
extern void delete_view(BView *arg0);
extern void delete_window(BWindow *arg0);
/* kernel */
extern void Init_OS();
extern void Init_fs_attr();
extern void Init_fs_index();
extern void Init_fs_info();
extern void Init_scheduler();
/* mail */
extern VALUE cMailMessage;
extern void Init_E_mail();
extern void delete_mailmessage(BMailMessage *arg0);
/* media */
extern void Init_MediaDefs();
/* midi */
extern void Init_MidiDefs();
/* storage */
extern VALUE cDirectory;
extern VALUE cEntry;
extern VALUE cEntry_ref;
extern VALUE cEntryList;
extern VALUE cNode;
extern VALUE cNode_ref;
extern VALUE cPath;
extern VALUE cQuery;
extern VALUE cResources;
extern VALUE cStatable;
extern VALUE cVolume;
extern VALUE cVolumeRoster;
extern void Init_Directory();
extern void Init_Entry();
extern void Init_EntryList();
extern void Init_Mime();
extern void Init_Node();
extern void Init_NodeMonitor();
extern void Init_Path();
extern void Init_Query();
extern void Init_Resources();
extern void Init_Statable();
extern void Init_Volume();
extern void Init_VolumeRoster();
extern void delete_directory(BDirectory *arg0);
extern void delete_entry(BEntry *arg0);
extern void delete_entry_ref(entry_ref *arg0);
extern void delete_entrylist(BEntryList *arg0);
extern void delete_node(BNode *arg0);
extern void delete_node_ref(node_ref *arg0);
extern void delete_path(BPath *arg0);
extern void delete_query(BQuery *arg0);
extern void delete_resources(BResources *arg0);
extern void delete_statable(BStatable *arg0);
extern void delete_volume(BVolume *arg0);
extern void delete_volumeroster(BVolumeRoster *arg0);
/* support */
extern VALUE cArchivable;
extern VALUE cDataIO;
extern VALUE cFlattenable;
extern VALUE cList;
extern VALUE cStopWatch;
extern VALUE cString;
extern void Init_Archivable();
extern void Init_Beep();
extern void Init_DataIO();
extern void Init_Errors();
extern void Init_Flattenable();
extern void Init_List();
extern void Init_StopWatch();
extern void Init_String();
extern void Init_TypeConstants();
extern void Init_UTF8();
extern void delete_archivable(BArchivable *arg0);
extern void delete_dataio(BDataIO *arg0);
extern void delete_flattenable(BFlattenable *arg0);
extern void delete_list(BList *arg0);
extern void delete_stopwatch(BStopWatch *arg0);
extern void delete_string(BString *arg0);
/* translation */
extern VALUE cTranslator;
extern VALUE cTranslatorRoster;
extern void Init_TranslationDefs();
extern void Init_TranslationErrors();
extern void Init_Translator();
extern void Init_TranslatorFormats();
extern void Init_TranslatorRoster();
extern void delete_translatorroster(BTranslatorRoster *arg0);


/* Error baselines */
extern VALUE eGeneralError;
extern VALUE eOsError;
extern VALUE eAppError;
extern VALUE eInterfaceError;
extern VALUE eMediaError;
extern VALUE eTranslationError;
extern VALUE eMidiError;
extern VALUE eStrageError;
extern VALUE eMailError;
extern VALUE ePrintError;
extern VALUE eDeviceError;
/* General Errors */
extern VALUE eNoMemory;
extern VALUE eIoError;
extern VALUE ePermissionDenied;
extern VALUE eBadIndex;
extern VALUE eBadType;
extern VALUE eBadValue;
extern VALUE eMismatchedValue;
extern VALUE eNameNotFound;
extern VALUE eNameInUse;
extern VALUE eTimedOut;
extern VALUE eInterrupted;
extern VALUE eWouldBlock;
extern VALUE eCanceled;
extern VALUE eNoInit;
extern VALUE eBusy;
extern VALUE eNotAllowed;
extern VALUE eError;
extern VALUE eOk;
extern VALUE eNoError;
/* Kernel Kit Errors */
extern VALUE eBadSemId;
extern VALUE eNoMoreSems;
extern VALUE eBadThreadId;
extern VALUE eNoMoreThreads;
extern VALUE eBadThreadState;
extern VALUE eBadTeamId;
extern VALUE eNoMoreTeams;
extern VALUE eBadPortId;
extern VALUE eNoMorePorts;
extern VALUE eBadImageId;
extern VALUE eBadAddress;
extern VALUE eNotAnExecutable;
extern VALUE eMissingLibrary;
extern VALUE eMissingSymbol;
extern VALUE eDebuggerAlreadyInstalled;
/* Application Kit Errors */
extern VALUE eBadReply;
extern VALUE eDuplicatReply;
extern VALUE eMessageToSelf;
extern VALUE eBadHandler;
extern VALUE eAlreadyRunning;
extern VALUE eLaunchFailed;
extern VALUE eAmbiguousAppLaunch;
extern VALUE eUnknownMimeType;
extern VALUE eBadScriptSyntax;
extern VALUE eLaunchFailedNoResolveLink;
extern VALUE eLaunchFailedExecutable;
extern VALUE eLaunchFailedAppNotFound;
extern VALUE eLaunchFailedAppInTrash;
extern VALUE eLaunchFailedNoPreferredApp;
extern VALUE eLaunchFailedFilesAppNotFound;
extern VALUE eBadMimeSnifferRule;
/* Media Kit Errors */
extern VALUE eStreamNotFound;
extern VALUE eServerNotFound;
extern VALUE eResouceNotFound;
extern VALUE eResouceUnavailable;
extern VALUE eBadSubscriber;
extern VALUE eSubscriberNotEntered;
extern VALUE eBufferNotAvailable;
extern VALUE eLastBufferError;
/* Error codes for the Translation Kit */
extern VALUE eNoTranslator;
extern VALUE eIllegalData;
extern VALUE eNotInitialized;
/* Midi Kit Errors */
extern VALUE eBadInstrument;
extern VALUE eBadMidiData;
extern VALUE eAlreadyPaused;
extern VALUE eAlreadyResumed;
extern VALUE eNoSongPlaying;
extern VALUE eTooManySongsPlaying;
/* Storage Kit/File System Errors */
extern VALUE eFileError;
extern VALUE eFileExists;
extern VALUE eEntryNotFound;
extern VALUE eNameTooLong;
extern VALUE eNotADirectory;
extern VALUE eDirectoryNotEmpty;
extern VALUE eDeviceFull;
extern VALUE eReadOnlyDevice;
extern VALUE eIsADirectory;
extern VALUE eNoMoreFds;
extern VALUE eCrossDeviceLink;
extern VALUE eLinkLimit;
extern VALUE eBustedPipe;
extern VALUE eUnsupported;
extern VALUE ePartitionTooSmall;
/* Mail Kit Errors */
extern VALUE eMailNoDaemon;
extern VALUE eMailUnknownUser;
extern VALUE eMailWrongPassword;
extern VALUE eMailUnknownHost;
extern VALUE eMailAccessError;
extern VALUE eMailUnknownField;
extern VALUE eMailNoRecipient;
extern VALUE eMailInvalidMail;
/* Printing Errors */
extern VALUE eNoPrintServer;
/* Device Kit Errors */
extern VALUE eDevInvalidIoctl;
extern VALUE eDevNoMemory;
extern VALUE eDevBadDriveNum;
extern VALUE eDevNoMedia;
extern VALUE eDevUnreadable;
extern VALUE eDevFormatError;
extern VALUE eDevTimeout;
extern VALUE eDevRecalibrateError;
extern VALUE eDevSeekError;
extern VALUE eDevIdError;
extern VALUE eDevReadError;
extern VALUE eDevWriteError;
extern VALUE eDevNotReady;
extern VALUE eDevMediaChanged;
extern VALUE eDevMediaChangeRequested;
extern VALUE eDevResouceConflict;
extern VALUE eDevConfigurationError;
extern VALUE eDevDisabledByUser;
extern VALUE eDevDoorOpen;

extern void my_raise(int err);


// ruby <- c++
extern VALUE my_llong2big(long long n);
extern VALUE my_ullong2big(unsigned long long n);
#define LLONG2BIG(n)  my_llong2big(n)
#define ULLONG2BIG(n) my_ullong2big(n)

#undef CHR2FIX
#define CHR2FIX(x)    INT2FIX((char)((x)&0xff))
#define UCHR2FIX(x)   INT2FIX((long)((x)&0xff))

#define LONG2NUM(n)   (FIXABLE((long)(n)) ? INT2FIX(n):rb_int2big(n))
#define ULONG2NUM(n)  (POSFIXABLE(n) ? INT2FIX(n):rb_uint2big(n))

#define LLONG2NUM(n)  (FIXABLE((long long)(n)) ? INT2FIX(n):LLONG2BIG(n))
#define ULLONG2NUM(n) (POSFIXABLE(n) ? INT2FIX(n):ULLONG2BIG(n))


extern bool my_check_range_long(VALUE x);
extern bool my_check_range_ulong(VALUE x);
extern bool my_check_range_llong(VALUE x);
extern bool my_check_range_ullong(VALUE x);

#define Check_Range_Long(x) (   \
  (!my_check_range_long(x))     \
    ? (DEBUG_TRACE(),           \
       rb_raise(rb_eRangeError, \
         "integer %s out of range of `long'",   \
         STR2CSTR(rb_obj_as_string(x))), false) \
    : true                      \
)

#define Check_Range_Ulong(x) (  \
  (!my_check_range_ulong(x))    \
    ? (DEBUG_TRACE(),           \
       rb_raise(rb_eRangeError, \
         "integer %s out of range of `unsigned long'", \
         STR2CSTR(rb_obj_as_string(x))), false)        \
    : true                      \
)

#define Check_Range_Llong(x) (  \
  (!my_check_range_llong(x))    \
    ? (DEBUG_TRACE(),           \
       rb_raise(rb_eRangeError, \
         "integer %s out of range of `long long'", \
         STR2CSTR(rb_obj_as_string(x))), false)    \
    : true                      \
)

#define Check_Range_Ullong(x) ( \
  (!my_check_range_ullong(x))   \
    ? (DEBUG_TRACE(),           \
       rb_raise(rb_eRangeError, \
         "integer %s out of range of `unsigned long long'", \
         STR2CSTR(rb_obj_as_string(x))), false)             \
    : true                      \
)


// c++ <- ruby
extern long long my_big2llong(VALUE x);
extern unsigned long long my_big2ullong(VALUE x);
#define BIG2LLONG(x)  my_big2llong(x)
#define BIG2ULLONG(x) my_big2ullong(x)

#define BIGNUM_P(x) (TYPE(x) == T_BIGNUM)
#define STRING_P(x) (TYPE(x) == T_STRING)
#define HASH_P(x)   (TYPE(x) == T_HASH)


#undef NUM2LONG
#define NUM2LONG(x)  ((Check_Range_Long(x) && BIGNUM_P(x)) ? (long)BIG2LLONG(x):rb_num2long(x))

#undef NUM2ULONG
#define NUM2ULONG(x) (                  \
  (Check_Range_Ulong(x) && FIXNUM_P(x)) \
     ? FIX2ULONG(x)                     \
     : (BIGNUM_P(x) ? rb_big2ulong(x):(unsigned long)rb_num2long(x)) \
)

#define NUM2LLONG(x) (BIGNUM_P(x) ? BIG2LLONG(x):(long long)rb_num2long(x))

#define NUM2ULLONG(x) (                  \
  (Check_Range_Ullong(x) && FIXNUM_P(x)) \
     ? (unsigned long long)FIX2ULONG(x)  \
     : (BIGNUM_P(x) ? BIG2ULLONG(x):(unsigned long long)rb_num2long(x)) \
)


#define Check_Range_Char(x) (    \
  (NUM2LLONG(x) < SCHAR_MIN      \
   || NUM2LLONG(x) > SCHAR_MAX)  \
     ? (DEBUG_TRACE(),           \
        rb_raise(rb_eRangeError, \
          "integer %s out of range of `char'",   \
          STR2CSTR(rb_obj_as_string(x))), false) \
     : true                      \
)

#define Check_Range_Uchar(x) (    \
  (NUM2ULLONG(x) < 0              \
   || NUM2ULLONG(x) > UCHAR_MAX)  \
     ? (DEBUG_TRACE(),            \
        rb_raise(rb_eRangeError,  \
          "integer %s out of range of `unsigned char'", \
          STR2CSTR(rb_obj_as_string(x))), false)        \
     : true                       \
)

#define Check_Range_Short(x) (   \
  (NUM2LLONG(x) < SHRT_MIN       \
   || NUM2LLONG(x) > SHRT_MAX)   \
     ? (DEBUG_TRACE(),           \
        rb_raise(rb_eRangeError, \
          "integer %s out of range of `short'",  \
          STR2CSTR(rb_obj_as_string(x))), false) \
     : true                      \
)

#define Check_Range_Ushort(x) (   \
  (NUM2ULLONG(x) < 0              \
   || NUM2ULLONG(x) > USHRT_MAX)  \
     ? (DEBUG_TRACE(),            \
        rb_raise(rb_eRangeError,  \
          "integer %s out of range of `unsigned short'", \
            STR2CSTR(rb_obj_as_string(x))), false)       \
     : true                       \
)


#define NUM2SHRT(x) ( \
  Check_Range_Short(x) ? (short)NUM2LONG(x):(short)0 \
)

#define NUM2USHRT(x) ( \
  Check_Range_Ushort(x) ? (unsigned short)NUM2ULONG(x):(unsigned short)0 \
)

#undef NUM2CHR
#define NUM2CHR(x) ( \
  Check_Range_Char(x) ? (char)(NUM2LONG(x)&0xff):(char)0 \
)

#define NUM2UCHR(x) ( \
  Check_Range_Uchar(x) ? (unsigned char)(NUM2ULONG(x)&0xff):(unsigned char)0 \
)


extern char** my_rarray2argv(VALUE ary);
extern VALUE my_dirent_t2hash(dirent_t &dir);
extern VALUE my_filter_list2rarry(BList &list);
extern VALUE my_rgb_color2hash(rgb_color &rgba);
extern rgb_color my_hash2rgb_color(VALUE hash);


template <class T>
T*
my_create_be_obj()
{
  T *mem;
  mem = new T;
  if (!mem) {
    rb_gc();
    mem = new T;
    if (!mem) {
      rb_raise(rb_eNoMemError, "failed to allocate memory");
    }
  }
  return mem;
}


#define NEW(mem, cnst) { \
  mem = new cnst;   \
  if (!mem) {       \
    rb_gc();        \
    mem = new cnst; \
    if (!mem) {     \
      rb_raise(rb_eNoMemError, "failed to allocate memory"); \
    }               \
  }                 \
}

template <class T>
void
my_delete_be_obj(T *obj)
{
  delete obj;
}

#define Data_To_Null(x, bclass) { \
  if (DATA_PTR(x)) {              \
    my_delete_be_obj(reinterpret_cast<bclass *>(DATA_PTR(x))); \
  }                               \
  DATA_PTR(x) = NULL;             \
}


#define Check_Is_Kind_Of(val, klass) ( \
  (!rb_obj_is_kind_of(val, klass))     \
     ? (DEBUG_TRACE(),                 \
        rb_raise(rb_eTypeError,        \
          "wrong argument type %s (expected %s)",                       \
            rb_class2name(CLASS_OF(val)), rb_class2name(klass)), false) \
     : true                            \
)

#define Check_Already_Released(ptr, name) ( \
  (!ptr)                                    \
     ? (DEBUG_TRACE(),                      \
        rb_raise(rb_eRuntimeError,          \
          "This %s already released", (name)), false) \
     : true                                 \
)


#define Get_BInstance(klass, val, ptr) { \
  Check_Is_Kind_Of(val, c##klass);       \
  Data_Get_Struct(val, B##klass, ptr);   \
  Check_Already_Released(ptr, rb_class2name(c##klass)); \
}

#define Get_BInstance2(klass, bklass, val, ptr) { \
  Check_Is_Kind_Of(val, c##klass);       \
  Data_Get_Struct(val, bklass, ptr);     \
  Check_Already_Released(ptr, rb_class2name(c##klass)); \
}


#endif /* _MY_BE_H */
