/*
 *  my_debug.h
 */

#ifndef _MY_DEBUG_H
#define _MY_DEBUG_H


#include <Debug.h>
#include <ruby.h>


#if defined(DEBUG)


  #define DEBUG_TRACE() ( \
    (ruby_debug == Qtrue) \
       ? (PRINT(("Debug: ")), TRACE()):(int)0 \
  )

  #define DEBUG_TRACE_WITH_MESSAGE(MSG) ( \
    (ruby_debug == Qtrue)                 \
       ? PRINT(("Debug: File: %s, Line: %d, Thread: %ld, Msg: %s\n", \
                __FILE__, __LINE__, find_thread(NULL), MSG)):(int)0  \
  )

  #define DEBUG_FUNC_TRACE() DEBUG_TRACE_WITH_MESSAGE(__PRETTY_FUNCTION__)

  #define DEBUG_TRACE_WITH_MESSAGE2(MSG1, MSG2) ( \
    (ruby_debug == Qtrue)                         \
       ? (PRINT(("Debug: File: %s, Line: %d, Thread: %ld, Msg: ", \
                 __FILE__, __LINE__, find_thread(NULL))), \
          PRINT(((MSG1), (MSG2))),                \
          PRINT(("\n"))):(int)0                   \
  )

  #define DEBUG_P(OBJ) (  \
    (ruby_debug == Qtrue) \
       ? (PRINT(("Debug: %s: ", #OBJ)), rb_p(OBJ)):(void)0 \
  )                       \

  #define DEBUG_PRINT(ARG) ( \
    (ruby_debug == Qtrue) ? PRINT(("Debug: %s\n", (ARG))):(int)0 \
  )

  #define DEBUG_PRINT2(ARG1, ARG2) ( \
    (ruby_debug == Qtrue)            \
       ? (PRINT(("Debug: ")), PRINT(((ARG1), (ARG2))), PRINT(("\n"))):(int)0 \
  )

#else

  #define DEBUG_TRACE()                         (void)0
  #define DEBUG_TRACE_WITH_MESSAGE(MSG)         (void)0
  #define DEBUG_FUNC_TRACE()                    (void)0
  #define DEBUG_TRACE_WITH_MESSAGE2(MSG1, MSG2) (void)0
  #define DEBUG_P(OBJ)                          (void)0
  #define DEBUG_PRINT(ARG)                      (void)0
  #define DEBUG_PRINT2(ARG1, ARG2)              (void)0

#endif /* DEBUG */


#endif /* _MY_DEBUG_H */
