/*
 *  rbApplication.h
 */

#ifndef _RBAPPLICATION_H
#define _RBAPPLICATION_H


#include <Application.h>
#include <Message.h>


class Application : public BApplication {
public:
                  Application(const char *signature);
                  Application(const char *signature,
                              status_t *error);
                  Application(BMessage *data);

virtual thread_id Run();
virtual void      Quit();
virtual bool      QuitRequested();
virtual void      Pulse();
virtual void      ReadyToRun();
virtual void      MessageReceived(BMessage *msg);
virtual void      ArgvReceived(int32 argc,
                               char **argv);
virtual void      AppActivated(bool active);
virtual void      RefsReceived(BMessage *a_message);
virtual void      AboutRequested();

virtual BHandler  *ResolveSpecifier(BMessage *msg,
                                    int32 index,
                                    BMessage *specifier,
                                    int32 form,
                                    const char *property);

virtual void      DispatchMessage(BMessage *an_event,
                                  BHandler *handler);

virtual status_t  GetSupportedSuites(BMessage *data);

        void      *operator new(size_t size);
        void      operator delete(void *ptr);
};


#endif /* _RBAPPLICATION_H */
