/*
 *  rbButton.h
 */

#ifndef _RBBUTTON_H
#define _RBBUTTON_H


#include <Button.h>
#include "my_be.h"


class Button : public BButton {
public:
VALUE myself;

                 Button(BRect frame,
                        const char *name,
                        const char *label,
                        BMessage *message,
                        uint32 resizeMask = B_FOLLOW_LEFT | B_FOLLOW_TOP,
                        uint32 flags = B_WILL_DRAW | B_NAVIGABLE);

                 Button(BMessage *data);

virtual void     Draw(BRect updateRect);
virtual void     MouseDown(BPoint where);
virtual void     AttachedToWindow();
virtual void     KeyDown(const char *bytes,
                         int32 numBytes);
virtual void     MakeDefault(bool state);
virtual void     SetLabel(const char *text);

virtual void     MessageReceived(BMessage *msg);
virtual void     WindowActivated(bool state);
virtual void     MouseUp(BPoint pt);
virtual void     MouseMoved(BPoint pt,
                            uint32 code,
                            const BMessage *msg);
virtual void     DetachedFromWindow();
virtual void     SetValue(int32 value);
virtual void     GetPreferredSize(float *width,
                                  float *height);
virtual void     ResizeToPreferred();
virtual status_t Invoke(BMessage *msg = NULL);
virtual void     FrameMoved(BPoint new_position);
virtual void     FrameResized(float new_width,
                              float new_height);

virtual void     MakeFocus(bool state = true);
virtual void     AllAttached();
virtual void     AllDetached();

virtual BHandler *ResolveSpecifier(BMessage *msg,
                                   int32 index,
                                   BMessage *specifier,
                                   int32 form,
                                   const char *property);
virtual status_t GetSupportedSuites(BMessage *data);

        void     *operator new(size_t size);
        void     operator delete(void *ptr);
};


#endif /* _RBBUTTON_H */
