/*
 *  rbMenu.cc
 */

#include "rbMenu.h"


Menu::Menu(const char *title,
              menu_layout layout=B_ITEMS_IN_COLUMN)
  : BMenu(title, layout)
{
//  DEBUG_TRACE_WITH_MESSAGE("Menu::Menu(const char *, menu_layout)");
  myself = Qnil;
}


Menu::Menu(const char *title, float width, float height)
  : BMenu(title, width, height)
{
//  DEBUG_TRACE_WITH_MESSAGE("Menu::Menu(const char *, float)");
  myself = Qnil;
}


Menu::Menu(BMessage *data)
  : BMenu(data)
{
//  DEBUG_TRACE_WITH_MESSAGE("Menu::Menu(BMessage *)");
  myself = Qnil;
}


Menu::Menu(BRect frame,
         const char *viewName,
         uint32 resizeMask,
         uint32 flags,
         menu_layout layout,
         bool resizeToFit)
  : BMenu(frame, viewName, resizeMask, flags, layout, resizeToFit)
{
//  DEBUG_TRACE_WITH_MESSAGE("Menu::Menu(BRect)");
  myself = Qnil;
}


void*
Menu::operator new(size_t size)
{
  return xmalloc(size);
}


void
Menu::operator delete(void *ptr)
{
  free(ptr);
}
