/*
 *  rbMenuBar.h
 */

#ifndef _RBMENUBAR_H
#define _RBMENUBAR_H


#include <MenuBar.h>
#include "my_be.h"


class MenuBar : public BMenuBar {
public:
VALUE myself;

                 MenuBar(BRect frame,
                         const char *title,
                         uint32 resizeMask = B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP,
                         menu_layout layout = B_ITEMS_IN_ROW,
                         bool resizeToFit = true);

                 MenuBar(BMessage *data);

virtual void     SetBorder(menu_bar_border border);
virtual void     Draw(BRect updateRect);
virtual void     AttachedToWindow();
virtual void     DetachedFromWindow();
virtual void     MessageReceived(BMessage *msg);
virtual void     MouseDown(BPoint where);
virtual void     WindowActivated(bool state);
virtual void     MouseUp(BPoint where);
virtual void     FrameMoved(BPoint new_position);
virtual void     FrameResized(float new_width,
                              float new_height);

virtual void     Show();
virtual void     Hide();

virtual BHandler *ResolveSpecifier(BMessage *msg,
                                   int32 index,
                                   BMessage *specifier,
                                   int32 form,
                                   const char *property);
virtual status_t GetSupportedSuites(BMessage *data);

virtual void     ResizeToPreferred();
virtual void     GetPreferredSize(float *width,
                                  float *height);
virtual void     MakeFocus(bool state = true);
virtual void     AllAttached();
virtual void     AllDetached();

        void     *operator new(size_t size);
        void     operator delete(void *ptr);
};


#endif /* _RBMENUBAR_H */
