/*
 *  rbMenuItem.cc
 */

#include "rbMenuItem.h"


MenuItem::MenuItem(const char *label,
                   BMessage *message,
                   char shortcut=0,
                   uint32 modifiers=0)
  : BMenuItem(label, message, shortcut, modifiers)
{
//  DEBUG_TRACE_WITH_MESSAGE("MenuItem::MenuItem(const char *)");
  myself = Qnil;
}


MenuItem::MenuItem(BMenu *menu, BMessage *message=NULL)
  : BMenuItem(menu, message)
{
//  DEBUG_TRACE_WITH_MESSAGE("MenuItem::MenuItem(BMenu *)");
  myself = Qnil;
}


MenuItem::MenuItem(BMessage *data)
  : BMenuItem(data)
{
//  DEBUG_TRACE_WITH_MESSAGE("MenuItem::MenuItem(BMessage *)");
  myself = Qnil;
}


void*
MenuItem::operator new(size_t size)
{
  return xmalloc(size);
}


void
MenuItem::operator delete(void *ptr)
{
  free(ptr);
}


SeparatorItem::SeparatorItem()
{
}


SeparatorItem::SeparatorItem(BMessage *data)
  : BSeparatorItem(data)
{
}


void*
SeparatorItem::operator new(size_t size)
{
  return xmalloc(size);
}


void
SeparatorItem::operator delete(void *ptr)
{
  free(ptr);
}
