/*
 *  rbMessageFilter.cc
 */

#include "rbMessageFilter.h"
#include "my_be.h"


MessageFilter::MessageFilter(uint32 what,
                             filter_hook func = NULL)
  : BMessageFilter(what, func)
{
  myself = Qnil;
}


MessageFilter::MessageFilter(message_delivery delivery,
                             message_source source,
                             filter_hook func = NULL)
  : BMessageFilter(delivery, source, func)
{
  myself = Qnil;
}


MessageFilter::MessageFilter(message_delivery delivery,
                             message_source source,
                             uint32 what,
                             filter_hook func = NULL)
  : BMessageFilter(delivery, source, what, func)
{
  myself = Qnil;
}


MessageFilter::MessageFilter(const BMessageFilter &filter)
  : BMessageFilter(filter)
{
  myself = Qnil;
}


MessageFilter::MessageFilter(const BMessageFilter *filter)
  : BMessageFilter(filter)
{
  myself = Qnil;
}


filter_result
MessageFilter::Filter(BMessage *message, BHandler **target)
{
  VALUE varg1, varg2, vresult;
  filter_result result;

  varg1 = Data_Wrap_Struct(cMessage, 0, 0, message);
  varg2 = Data_Wrap_Struct(cHandler, 0, 0, target);
  vresult = rb_funcall(myself, rb_intern("Filter"), 2, varg1, varg2);
  result = (filter_result)NUM2ULONG(vresult);
  return result;
}


void*
MessageFilter::operator new(size_t size)
{
  return xmalloc(size);
}


void
MessageFilter::operator delete(void *ptr)
{
  free(ptr);
}
