/*
 *  rbStringView.h
 */

#ifndef _RBSTRING_VIEW_H
#define _RBSTRING_VIEW_H


#include <StringView.h>
#include "my_be.h"


class StringView : public BStringView {
public:
VALUE myself;

                 StringView(BRect bounds,
                            const char *name,
                            const char *text,
                            uint32 resizeFlags=B_FOLLOW_LEFT | B_FOLLOW_TOP,
                            uint32 flags=B_WILL_DRAW);

                 StringView(BMessage *data);

virtual void     AttachedToWindow();
virtual void     Draw(BRect bounds);

virtual void     MessageReceived(BMessage *msg);
virtual void     MouseDown(BPoint pt);
virtual void     MouseUp(BPoint pt);
virtual void     MouseMoved(BPoint pt,
                            uint32 code,
                            const BMessage *msg);
virtual void     DetachedFromWindow();
virtual void     FrameMoved(BPoint new_position);
virtual void     FrameResized(float new_width,
                              float new_height);

virtual BHandler *ResolveSpecifier(BMessage *msg,
                                   int32 index,
                                   BMessage *specifier,
                                   int32 form,
                                   const char *property);

virtual void     ResizeToPreferred();
virtual void     GetPreferredSize(float *width,
                                  float *height);
virtual void     MakeFocus(bool state=true);
virtual void     AllAttached();
virtual void     AllDetached();
virtual status_t GetSupportedSuites(BMessage *data);

        void      *operator new(size_t size);
        void      operator delete(void *ptr);
};


#endif /* _RBSTRING_VIEW_H */
