/*
 *  rbView.h
 */

#ifndef _RBVIEW_H
#define _RBVIEW_H


#include <View.h>
#include "my_be.h"


class View : public BView {
public:
VALUE myself;

                 View(BRect frame,
                      const char *name,
                      uint32 resizeMask,
                      uint32 flags);

                 View(BMessage *data);

virtual void     AttachedToWindow();
virtual void     AllAttached();
virtual void     DetachedFromWindow();
virtual void     AllDetached();

virtual void     MessageReceived(BMessage *msg);

virtual void     Draw(BRect updateRect);
virtual void     MouseDown(BPoint where);
virtual void     MouseUp(BPoint where);
virtual void     MouseMoved(BPoint where,
                            uint32 code,
                            const BMessage *a_message);
virtual void     WindowActivated(bool state);
virtual void     KeyDown(const char *bytes,
                         int32 numBytes);
virtual void     KeyUp(const char *bytes,
                       int32 numBytes);
virtual void     Pulse();
virtual void     FrameMoved(BPoint new_position);
virtual void     FrameResized(float new_width,
                              float new_height);

virtual void     TargetedByScrollView(BScrollView *scroll_view);
virtual void     ConstrainClippingRegion(BRegion *region);
virtual void     SetDrawingMode(drawing_mode mode);
virtual void     SetPenSize(float size);
virtual void     SetViewColor(rgb_color c);
virtual void     SetHighColor(rgb_color a_color);
virtual void     SetLowColor(rgb_color a_color);
virtual void     SetFont(const BFont *font,
                         uint32 mask=B_FONT_ALL);

virtual void     SetFlags(uint32 flags);
virtual void     SetResizingMode(uint32 mode);
virtual void     ScrollTo(BPoint where);
virtual void     MakeFocus(bool focusState=true);

virtual void     Show();
virtual void     Hide();

virtual void     GetPreferredSize(float *width,
                                  float *height);
virtual void     ResizeToPreferred();

virtual BHandler *ResolveSpecifier(BMessage *msg,
                                   int32 index,
                                   BMessage *specifier,
                                   int32 form,
                                   const char *property);
virtual status_t GetSupportedSuites(BMessage *data);

        void      *operator new(size_t size);
        void      operator delete(void *ptr);
};


#endif /* _RBVIEW_H */
