/*
 *  rbWindow.h
 */

#ifndef _RBWINDOW_H
#define _RBWINDOW_H


#include <Window.h>
#include <Message.h>
#include "my_be.h"


class Window : public BWindow {
public:
VALUE myself;
bool quit;

                  Window(BRect frame,
                         const char *title,
                         window_type type,
                         uint32 flags,
                         uint32 workspace=B_CURRENT_WORKSPACE);

                  Window(BRect frame,
                         const char *title,
                         window_look look,
                         window_feel feel,
                         uint32 flags,
                         uint32 workspace=B_CURRENT_WORKSPACE);

                  Window(BMessage *data);

virtual void      Quit();
virtual void      DispatchMessage(BMessage *message,
                                  BHandler *handler);
virtual void      MessageReceived(BMessage *message);
virtual void      FrameMoved(BPoint new_position);
virtual void      WorkspacesChanged(uint32 old_ws,
                                    uint32 new_ws);
virtual void      WorkspaceActivated(int32 ws,
                                     bool state);
virtual void      FrameResized(float new_width,
                               float new_height);
virtual void      Minimize(bool minimize);
virtual void      Zoom(BPoint rec_position,
                       float rec_width,
                       float rec_height);
virtual void      ScreenChanged(BRect screen_size,
                                color_space depth);
virtual void      MenusBeginning();
virtual void      MenusEnded();
virtual void      WindowActivated(bool state);

virtual void      Show();

virtual void      Hide();

virtual BHandler  *ResolveSpecifier(BMessage *msg,
                                    int32 index,
                                    BMessage *specifier,
                                    int32 form,
                                    const char *property);
virtual status_t  GetSupportedSuites(BMessage *data);

virtual bool      QuitRequested();
virtual thread_id Run();

        void      *operator new(size_t size);
        void      operator delete(void *ptr);
};


#endif /* _RBWINDOW_H */
