#! /boot/home/config/bin/ruby -d

#
# BasicButton.rb
#

require "to_integer.rb"
require "be.so"
include Be


BUTTON_APP_SIG = "application/x-vnd.Be-BasicButton"
BUTTON_PRESS = "PRES".to_integer


class ButtonWindow < Window
  def initialize
    super(Rect.new(100, 100, 300, 300), "ButtonWindow",
          TITLED_WINDOW, WILL_DRAW)

    @press = 0
    button = Button.new(Rect.new(80, 90, 120, 110),
                        "Press", "Press",
                        Message.new(BUTTON_PRESS))
    AddChild(button)
  end

  def QuitRequested
    $be_app.PostMessage(QUIT_REQUESTED)
    return true
  end

  def MessageReceived(message)
    case (message.what)
      when BUTTON_PRESS
        @press += 1
        SetTitle("Presses: #{@press.to_s}")
      else
        super(message)
    end
  end
end

class ButtonApp < Application
  def initialize
    super(BUTTON_APP_SIG)
  end

  def ReadyToRun
    win = ButtonWindow.new
    win.Show
  end
end


ButtonApp.new
$be_app.Run
