#! /boot/home/config/bin/ruby -d

#
# HelloWorld.rb
#

require "be.so"
include Be


class HelloView < StringView
  def initialize(rect, name, text)
    super(rect, name, text, FOLLOW_ALL, WILL_DRAW)

    SetFont($be_bold_font)
    SetFontSize(24)
  end
end

class HelloWindow < Window
  def initialize(frame)
    super(frame, "Hello", TITLED_WINDOW, NOT_RESIZABLE | NOT_ZOOMABLE)

    rect = Bounds()
    view = HelloView.new(rect, "HelloView", "Hello World!")
    AddChild(view)
  end

  def QuitRequested
    $be_app.PostMessage(QUIT_REQUESTED)
    return true
  end
end

class HelloApp < Application
  def initialize
    signature = "application/x-vnd.Be-HelloWorldSample"
    super(signature)

    rect = Rect.new(100, 80, 260, 120)
    win = HelloWindow.new(rect)
    win.Show
  end
end


HelloApp.new
$be_app.Run
