#! /boot/home/config/bin/ruby -d

#
# test01.rb
#

require "be.so"


class MyApp < Be::Application
  def initialize(arg)
    p "-- MyApp#initialize(#{arg})"
    super(arg)

    if arg.kind_of?(Be::Message)
      @str = arg.FindString("MyApp::Property1")
    else
      @str = "hello!"
    end
  end
  attr(:str, true)

  def Archive(archive, deep=true)
    p "-- MyApp#Archive(#{archive}, #{deep})"

    super(archive, deep)
    archive.AddString("MyApp::Property1", @str)
  end
end


dump = true
# dump = false

if dump

  p "MyApp Dumping..."

  signature = "application/x-vnd.s_nojo-be.so-test01.rb"
  MyApp.new(signature)

  p $be_app.str
  $be_app.str = "bye!"
  p $be_app.str

  File.open("app-dump.data", "w") {| f |
#    Marshal.dump($be_app, f, 1) #=> deep = false
    Marshal.dump($be_app, f)    #=> deep = true
  }

else

  p "MyApp Loading..."

  File.open("app-dump.data", "r") {| f |
    Marshal.load(f)
  }
  p $be_app
  p $be_app.str

end
