#! /boot/home/config/bin/ruby -d

#
# TestPoint.rb
#

require "English.rb"
require "runit/testcase"
require "be.so"

class PointTest < RUNIT::TestCase

  def setup
#    GC.disable
#    GC.enable
#    GC.start
  end

  def teardown
#    GC.start
  end

  def test_01_new
    pt = Be::Point.new
    assert(pt.kind_of?(Be::Point))
  end

  def test_02_new
    pt = Be::Point.new
    pt = Be::Point.new(pt)
    assert(pt.kind_of?(Be::Point))
  end

  def test_03_new
    pt = Be::Point.new(10.0, 15.0)
    assert(pt.kind_of?(Be::Point))
  end

  def test_11_x
    pt = Be::Point.new(10.0, 15.0)
    assert_equal(pt.x, 10.0)
  end

  def test_12_y
    pt = Be::Point.new(10.0, 15.0)
    assert_equal(pt.y, 15.0)
  end

  def test_21_x=
    pt = Be::Point.new(10.0, 15.0)
    ret = (pt.x = 5)
    assert_equal(ret, 5)
    assert_equal(pt.x, 5)
    assert_equal(pt.y, 15.0)
  end

  def test_22_y=
    pt = Be::Point.new(10.0, 15.0)
    ret = (pt.y = 5)
    assert_equal(ret, 5)
    assert_equal(pt.x, 10.0)
    assert_equal(pt.y, 5)
  end

  def test_31_Set
    pt = Be::Point.new(10.0, 15.0)
    ret = pt.Set(30, 5)
    assert_equal(ret, nil)
    assert_equal(pt.x, 30)
    assert_equal(pt.y, 5)
  end

  def test_41_ConstrainTo
    rt = Be::Rect.new(100.0, 120.0, 115.0, 115.0)
    pt = Be::Point.new(10.0, 15.0)
    ret = pt.ConstrainTo(rt)
    assert_equal(ret, nil)
    assert_equal(pt.x, 100)
    assert_equal(pt.y, 120)
  end

  def test_51_equal
    pt = Be::Point.new(3.0, 2.0)
    pt1 = Be::Point.new(3.0, 2.0)
    pt2 = Be::Point.new(5.0, 5.0)
    assert(pt == pt)
    assert(pt == pt1)
    assert(!(pt == pt2))
    assert(!(pt == 0))
  end

  def test_51_not_equal
    pt = Be::Point.new(3.0, 2.0)
    pt1 = Be::Point.new(3.0, 2.0)
    pt2 = Be::Point.new(5.0, 5.0)
    assert(!(pt != pt))
    assert(!(pt != pt1))
    assert(pt != pt2)
    assert(pt != 0)
  end

  def test_61_plus
    pt = Be::Point.new(3.0, 2.0)
    pt1 = Be::Point.new(10.0, 20.0)
    pt2 = Be::Point.new(13.0, 22.0)
    ret = pt + pt1
    assert(ret == pt2)
  end

  def test_62_minus
    pt = Be::Point.new(3.0, 2.0)
    pt1 = Be::Point.new(10.0, 20.0)
    pt2 = Be::Point.new(-7.0, -18.0)
    ret = pt - pt1
    assert(ret == pt2)
  end

  def test_71_ORIGIN
    assert(Be::ORIGIN.kind_of?(Be::Point))
  end

end

if $PROGRAM_NAME == __FILE__
  require "runit/cui/testrunner"
  RUNIT::CUI::TestRunner.run(PointTest.suite)
end
