#! /boot/home/config/bin/ruby -d

#
# TestRect.rb
#

require "English.rb"
require "runit/testcase"
require "be.so"

class RectTest < RUNIT::TestCase

  def setup
#    GC.disable
#    GC.enable
#    GC.start
  end

  def teardown
#    GC.start
  end

  def test_01_new
    rt = Be::Rect.new
    assert(rt.kind_of?(Be::Rect))
  end

  def test_02_new
    rt = Be::Rect.new
    rt = Be::Rect.new(rt)
    assert(rt.kind_of?(Be::Rect))
  end

  def test_03_new
    pt1 = Be::Point.new
    pt2 = Be::Point.new
    rt = Be::Rect.new(pt1, pt2)
    assert(rt.kind_of?(Be::Rect))
  end

  def test_04_new
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    assert(rt.kind_of?(Be::Rect))
  end

  def test_11_left
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    assert_equal(rt.left, 100.0)
  end

  def test_12_top
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    assert_equal(rt.top, 80.0)
  end

  def test_13_right
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    assert_equal(rt.right, 260.0)
  end

  def test_14_bottom
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    assert_equal(rt.bottom, 120.0)
  end

  def test_21_left=
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = (rt.left = 5)
    assert_equal(ret, 5)
    assert_equal(rt.left, 5)
    assert_equal(rt.top, 80.0)
    assert_equal(rt.right, 260.0)
    assert_equal(rt.bottom, 120.0)
  end

  def test_22_top=
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = (rt.top = 5)
    assert_equal(ret, 5)
    assert_equal(rt.left, 100.0)
    assert_equal(rt.top, 5)
    assert_equal(rt.right, 260.0)
    assert_equal(rt.bottom, 120.0)
  end

  def test_23_right=
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = (rt.right = 5)
    assert_equal(ret, 5)
    assert_equal(rt.left, 100.0)
    assert_equal(rt.top, 80.0)
    assert_equal(rt.right, 5)
    assert_equal(rt.bottom, 120.0)
  end

  def test_24_bottom=
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = (rt.bottom = 5)
    assert_equal(ret, 5)
    assert_equal(rt.left, 100.0)
    assert_equal(rt.top, 80.0)
    assert_equal(rt.right, 260.0)
    assert_equal(rt.bottom, 5)
  end

  def test_31_Set
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = rt.Set(5, 5, 10, 10)
    assert_equal(ret, nil)
    assert_equal(rt.left, 5)
    assert_equal(rt.top, 5)
    assert_equal(rt.right, 10)
    assert_equal(rt.bottom, 10)
  end

  def test_41_LeftTop
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = rt.LeftTop
    assert(pt.kind_of?(Be::Point))
    assert_equal(pt.x, 100.0)
    assert_equal(pt.y, 80.0)
  end

  def test_42_RightBottom
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = rt.RightBottom
    assert(pt.kind_of?(Be::Point))
    assert_equal(pt.x, 260.0)
    assert_equal(pt.y, 120.0)
  end

  def test_43_LeftBottom
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = rt.LeftBottom
    assert(pt.kind_of?(Be::Point))
    assert_equal(pt.x, 100.0)
    assert_equal(pt.y, 120.0)
  end

  def test_44_RightTop
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = rt.RightTop
    assert(pt.kind_of?(Be::Point))
    assert_equal(pt.x, 260.0)
    assert_equal(pt.y, 80.0)
  end

  def test_51_SetLeftTop
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = Be::Point.new(5, 5)
    ret = rt.SetLeftTop(pt)
    assert_equal(ret, nil)
    assert_equal(rt.left, 5)
    assert_equal(rt.top, 5)
    assert_equal(rt.right, 260.0)
    assert_equal(rt.bottom, 120.0)
  end

  def test_52_SetRightBottom
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = Be::Point.new(5, 5)
    ret = rt.SetRightBottom(pt)
    assert_equal(ret, nil)
    assert_equal(rt.left, 100.0)
    assert_equal(rt.top, 80.0)
    assert_equal(rt.right, 5)
    assert_equal(rt.bottom, 5)
  end

  def test_53_SetLeftBottom
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = Be::Point.new(5, 5)
    ret = rt.SetLeftBottom(pt)
    assert_equal(ret, nil)
    assert_equal(rt.left, 5)
    assert_equal(rt.top, 80.0)
    assert_equal(rt.right, 260.0)
    assert_equal(rt.bottom, 5)
  end

  def test_54_SetRightTop
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = Be::Point.new(5, 5)
    ret = rt.SetRightTop(pt)
    assert_equal(ret, nil)
    assert_equal(rt.left, 100.0)
    assert_equal(rt.top, 5)
    assert_equal(rt.right, 5)
    assert_equal(rt.bottom, 120.0)
  end

  def test_61_equal
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(200.0, 50.0, 250.0, 100.0)
    assert(rt == rt)
    assert(rt == rt1)
    assert(!(rt == rt2))
    assert(!(rt == 0))
  end

  def test_62_not_equal
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(200.0, 50.0, 250.0, 100.0)
    assert(!(rt != rt))
    assert(!(rt != rt1))
    assert(rt != rt2)
    assert(rt != 0)
  end

  def test_71_InsetBy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(120.0, 90.0, 240.0, 110.0)
    ret = rt.InsetBy(20, 10)
    assert_equal(ret, nil)
    assert(rt == rt1)
  end

  def test_72_InsetBy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(120.0, 90.0, 240.0, 110.0)
    pt = Be::Point.new(20, 10)
    ret = rt.InsetBy(pt)
    assert_equal(ret, nil)
    assert(rt == rt1)
  end

  def test_81_InsetBySelf
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 240.0, 110.0)
    ret = rt.InsetBySelf(20, 10)
    assert(rt == ret)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_82_InsetBySelf
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 240.0, 110.0)
    pt = Be::Point.new(20, 10)
    ret = rt.InsetBySelf(pt)
    assert(rt == ret)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_91_InsetByCopy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 240.0, 110.0)
    ret = rt.InsetByCopy(20, 10)
    assert(rt != ret)
    assert(rt == rt1)
    assert(rt != rt2)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_92_InsetByCopy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 240.0, 110.0)
    pt = Be::Point.new(20, 10)
    ret = rt.InsetByCopy(pt)
    assert(rt != ret)
    assert(rt == rt1)
    assert(rt != rt2)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_a1_OffsetBy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(120.0, 90.0, 280.0, 130.0)
    ret = rt.OffsetBy(20, 10)
    assert_equal(ret, nil)
    assert(rt == rt1)
  end

  def test_a2_OffsetBy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(120.0, 90.0, 280.0, 130.0)
    pt = Be::Point.new(20, 10)
    ret = rt.OffsetBy(pt)
    assert_equal(ret, nil)
    assert(rt == rt1)
  end

  def test_b1_OffsetBySelf
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 280.0, 130.0)
    ret = rt.OffsetBySelf(20, 10)
    assert(rt == ret)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_b2_OffsetBySelf
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 280.0, 130.0)
    pt = Be::Point.new(20, 10)
    ret = rt.OffsetBySelf(pt)
    assert(rt == ret)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_c1_OffsetByCopy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 280.0, 130.0)
    ret = rt.OffsetByCopy(20, 10)
    assert(rt != ret)
    assert(rt == rt1)
    assert(rt != rt2)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_c2_OffsetByCopy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(120.0, 90.0, 280.0, 130.0)
    pt = Be::Point.new(20, 10)
    ret = rt.OffsetByCopy(pt)
    assert(rt != ret)
    assert(rt == rt1)
    assert(rt != rt2)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_d1_OffsetTo
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(20.0, 10.0, 180.0, 50.0)
    ret = rt.OffsetTo(20, 10)
    assert_equal(ret, nil)
    assert(rt == rt1)
  end

  def test_d2_OffsetTo
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(20.0, 10.0, 180.0, 50.0)
    pt = Be::Point.new(20, 10)
    ret = rt.OffsetTo(pt)
    assert_equal(ret, nil)
    assert(rt == rt1)
  end

  def test_e1_OffsetToSelf
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(20.0, 10.0, 180.0,  50.0)
    ret = rt.OffsetToSelf(20, 10)
    assert(rt == ret)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_e2_OffsetToSelf
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(20.0, 10.0, 180.0, 50.0)
    pt = Be::Point.new(20, 10)
    ret = rt.OffsetToSelf(pt)
    assert(rt == ret)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_f1_OffsetToCopy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(20.0, 10.0, 180.0, 50.0)
    ret = rt.OffsetToCopy(20, 10)
    assert(rt != ret)
    assert(rt == rt1)
    assert(rt != rt2)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_f2_OffsetToCopy
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt2 = Be::Rect.new(20.0, 10.0, 180.0, 50.0)
    pt = Be::Point.new(20, 10)
    ret = rt.OffsetToCopy(pt)
    assert(rt != ret)
    assert(rt == rt1)
    assert(rt != rt2)
    assert(ret != rt1)
    assert(ret == rt2)
  end

  def test_g1_and
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(200.0, 100.0, 360.0, 140.0)
    rt2 = Be::Rect.new(200.0, 100.0, 260.0, 120.0)
    ret = (rt & rt1)
    assert(ret == rt2)
  end

  def test_g2_or
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(200.0, 100.0, 360.0, 140.0)
    rt2 = Be::Rect.new(100.0, 80.0, 360.0, 140.0)
    ret = (rt | rt1)
    assert(ret == rt2)
  end

  def test_h1_Intersects
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(200.0, 100.0, 360.0, 140.0)
    ret = rt.Intersects(rt1)
    assert(ret)
  end

  def test_h2_Intersects
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(200.0, 220.0, 360.0, 260.0)
    ret = rt.Intersects(rt1)
    assert(!ret)
  end

  def test_i1_IsValid
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = rt.IsValid
    assert(ret)
  end

  def test_i2_IsValid
    rt = Be::Rect.new(100.0, 80.0, -260.0, -120.0)
    ret = rt.IsValid
    assert(!ret)
  end

  def test_j1_Width
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = rt.Width
    assert(ret.kind_of?(Float))
    assert_equal(ret, 160.0)
  end

  def test_j2_IntegerWidth
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = rt.IntegerWidth
    assert(ret.kind_of?(Integer))
    assert_equal(ret, 160)
  end

  def test_k1_Height
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = rt.Height
    assert(ret.kind_of?(Float))
    assert_equal(ret, 40.0)
  end

  def test_k2_IntegerHeight
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    ret = rt.IntegerHeight
    assert(ret.kind_of?(Integer))
    assert_equal(ret, 40)
  end

  def test_l1_Contains
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(115.0, 90.0, 250.0, 105.0)
    ret = rt.Contains(rt1)
    assert(ret)
  end

  def test_l2_Contains
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    rt1 = Be::Rect.new(200.0, 100.0, 360.0, 140.0)
    ret = rt.Contains(rt1)
    assert(!ret)
  end

  def test_l3_Contains
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = Be::Point.new(130, 100)
    ret = rt.Contains(pt)
    assert(ret)
  end

  def test_l4_Contains
    rt = Be::Rect.new(100.0, 80.0, 260.0, 120.0)
    pt = Be::Point.new(10, 15)
    ret = rt.Contains(pt)
    assert(!ret)
  end

end

if $PROGRAM_NAME == __FILE__
  require "runit/cui/testrunner"
  RUNIT::CUI::TestRunner.run(RectTest.suite)
end
