#! /boot/home/config/bin/ruby -d

#
# Errors.rb
#

# require "gc_start.rb"
require "be.so"


=begin

module Be
  class GeneralError < StandardError; end
  class NoMemory         < GeneralError; end
  class IoError          < GeneralError; end
  class PermissionDenied < GeneralError; end
  class BadIndex         < GeneralError; end
  class BadType          < GeneralError; end
  class BadValue         < GeneralError; end
  class MismatchedValue  < GeneralError; end
  class NameNotFound     < GeneralError; end
  class NameInUse        < GeneralError; end
  class TimedOut         < GeneralError; end
  class Interrupted      < GeneralError; end
  class WouldBlock       < GeneralError; end
  class Canceled         < GeneralError; end
  class NoInit           < GeneralError; end
  class Busy             < GeneralError; end
  class NotAllowed       < GeneralError; end
  class Error            < GeneralError; end
  class Ok               < GeneralError; end
  class NoError          < GeneralError; end

  class OsError      < StandardError; end
  class BadSemId                 < OsError; end
  class NoMoreSems               < OsError; end
  class BadThreadId              < OsError; end
  class NoMoreThreads            < OsError; end
  class BadThreadState           < OsError; end
  class BadTeamId                < OsError; end
  class NoMoreTeams              < OsError; end
  class BadPortId                < OsError; end
  class NoMorePorts              < OsError; end
  class BadImageId               < OsError; end
  class BadAddress               < OsError; end
  class NotAnExecutable          < OsError; end
  class MissingLibrary           < OsError; end
  class MissingSymbol            < OsError; end
  class DebuggerAlreadyInstalled < OsError; end

  class AppError     < StandardError; end
  class BadReply                     < AppError; end
  class DuplicatReply                < AppError; end
  class MessageToSelf                < AppError; end
  class BadHandler                   < AppError; end
  class AlreadyRunning               < AppError; end
  class LaunchFailed                 < AppError; end
  class AmbiguousAppLaunch           < AppError; end
  class UnknownMimeType              < AppError; end
  class BadScriptSyntax              < AppError; end
  class LaunchFailedNoResolveLink    < AppError; end
  class LaunchFailedExecutable       < AppError; end
  class LaunchFailedAppNotFound      < AppError; end
  class LaunchFailedAppInTrash       < AppError; end
  class LaunchFailedNoPreferredApp   < AppError; end
  class LaunchFailedFilesAppNotFound < AppError; end
  class BadMimeSnifferRule           < AppError; end

  class MediaError   < StandardError; end
  class StreamNotFound       < MediaError; end
  class ServerNotFound       < MediaError; end
  class ResouceNotFound      < MediaError; end
  class ResouceUnavailable   < MediaError; end
  class BadSubscriber        < MediaError; end
  class SubscriberNotEntered < MediaError; end
  class BufferNotAvailable   < MediaError; end
  class LastBufferError      < MediaError; end

  class StrageError  < StandardError; end
  class FileError         < StrageError; end
  class FileExists        < StrageError; end
  class EntryNotFound     < StrageError; end
  class NameTooLong       < StrageError; end
  class NotADirectory     < StrageError; end
  class DirectoryNotEmpty < StrageError; end
  class DeviceFull        < StrageError; end
  class ReadOnlyDevice    < StrageError; end
  class IsADirectory      < StrageError; end
  class NoMoreFds         < StrageError; end
  class CrossDeviceLink   < StrageError; end
  class LinkLimit         < StrageError; end
  class BustedPipe        < StrageError; end
  class Unsupported       < StrageError; end
  class PartitionTooSmall < StrageError; end

  class MailError    < StandardError; end
  class MailNoDaemon      < MailError; end
  class MailUnknownUser   < MailError; end
  class MailWrongPassword < MailError; end
  class MailUnknownHost   < MailError; end
  class MailAccessError   < MailError; end
  class MailUnknownField  < MailError; end
  class MailNoRecipient   < MailError; end
  class MailInvalidMail   < MailError; end

  class PrintError   < StandardError; end
  class NoPrintServer < PrintError; end

  class DeviceError  < StandardError; end
  class DevInvalidIoctl         < DeviceError; end
  class DevNoMemory             < DeviceError; end
  class DevBadDriveNum          < DeviceError; end
  class DevNoMedia              < DeviceError; end
  class DevUnreadable           < DeviceError; end
  class DevFormatError          < DeviceError; end
  class DevTimeout              < DeviceError; end
  class DevRecalibrateError     < DeviceError; end
  class DevSeekError            < DeviceError; end
  class DevIdError              < DeviceError; end
  class DevReadError            < DeviceError; end
  class DevWriteError           < DeviceError; end
  class DevNotReady             < DeviceError; end
  class DevMediaChanged         < DeviceError; end
  class DevMediaChangeRequested < DeviceError; end
  class DevResouceConflict      < DeviceError; end
  class DevConfigurationError   < DeviceError; end
  class DevDisabledByUser       < DeviceError; end
  class DevDoorOpen             < DeviceError; end
end

=end


# p Be.strerror(Be::GENERAL_ERROR_BASE)
# p Be.strerror(Be::OS_ERROR_BASE)
# p Be.strerror(Be::APP_ERROR_BASE)
# p Be.strerror(Be::INTERFACE_ERROR_BASE)
# p Be.strerror(Be::MEDIA_ERROR_BASE)
# p Be.strerror(Be::TRANSLATION_ERROR_BASE)
# p Be.strerror(Be::MIDI_ERROR_BASE)
# p Be.strerror(Be::STORAGE_ERROR_BASE)
# p Be.strerror(Be::POSIX_ERROR_BASE)
# p Be.strerror(Be::MAIL_ERROR_BASE)
# p Be.strerror(Be::PRINT_ERROR_BASE)
# p Be.strerror(Be::DEVICE_ERROR_BASE)

# p Be.strerror(Be::ERRORS_END)


p Be.strerror(Be::NO_MEMORY)
p Be.strerror(Be::IO_ERROR)
p Be.strerror(Be::PERMISSION_DENIED)
p Be.strerror(Be::BAD_INDEX)
p Be.strerror(Be::BAD_TYPE)
p Be.strerror(Be::BAD_VALUE)
p Be.strerror(Be::MISMATCHED_VALUES)
p Be.strerror(Be::NAME_NOT_FOUND)
p Be.strerror(Be::NAME_IN_USE)
p Be.strerror(Be::TIMED_OUT)
p Be.strerror(Be::INTERRUPTED)
p Be.strerror(Be::WOULD_BLOCK)
p Be.strerror(Be::CANCELED)
p Be.strerror(Be::NO_INIT)
p Be.strerror(Be::BUSY)
p Be.strerror(Be::NOT_ALLOWED)
p Be.strerror(Be::ERROR)
p Be.strerror(Be::OK)
p Be.strerror(Be::NO_ERROR)

p Be.strerror(Be::BAD_SEM_ID)
p Be.strerror(Be::NO_MORE_SEMS)
p Be.strerror(Be::BAD_THREAD_ID)
p Be.strerror(Be::NO_MORE_THREADS)
p Be.strerror(Be::BAD_THREAD_STATE)
p Be.strerror(Be::BAD_TEAM_ID)
p Be.strerror(Be::NO_MORE_TEAMS)
p Be.strerror(Be::BAD_PORT_ID)
p Be.strerror(Be::NO_MORE_PORTS)
p Be.strerror(Be::BAD_IMAGE_ID)
p Be.strerror(Be::BAD_ADDRESS)
p Be.strerror(Be::NOT_AN_EXECUTABLE)
p Be.strerror(Be::MISSING_LIBRARY)
p Be.strerror(Be::MISSING_SYMBOL)
p Be.strerror(Be::DEBUGGER_ALREADY_INSTALLED)

p Be.strerror(Be::BAD_REPLY)
p Be.strerror(Be::DUPLICATE_REPLY)
p Be.strerror(Be::MESSAGE_TO_SELF)
p Be.strerror(Be::BAD_HANDLER)
p Be.strerror(Be::ALREADY_RUNNING)
p Be.strerror(Be::LAUNCH_FAILED)
p Be.strerror(Be::AMBIGUOUS_APP_LAUNCH)
p Be.strerror(Be::UNKNOWN_MIME_TYPE)
p Be.strerror(Be::BAD_SCRIPT_SYNTAX)
p Be.strerror(Be::LAUNCH_FAILED_NO_RESOLVE_LINK)
p Be.strerror(Be::LAUNCH_FAILED_EXECUTABLE)
p Be.strerror(Be::LAUNCH_FAILED_APP_NOT_FOUND)
p Be.strerror(Be::LAUNCH_FAILED_APP_IN_TRASH)
p Be.strerror(Be::LAUNCH_FAILED_NO_PREFERRED_APP)
p Be.strerror(Be::LAUNCH_FAILED_FILES_APP_NOT_FOUND)
p Be.strerror(Be::BAD_MIME_SNIFFER_RULE)

p Be.strerror(Be::FILE_ERROR)
p Be.strerror(Be::FILE_EXISTS)
p Be.strerror(Be::ENTRY_NOT_FOUND)
p Be.strerror(Be::NAME_TOO_LONG)
p Be.strerror(Be::NOT_A_DIRECTORY)
p Be.strerror(Be::DIRECTORY_NOT_EMPTY)
p Be.strerror(Be::DEVICE_FULL)
p Be.strerror(Be::READ_ONLY_DEVICE)
p Be.strerror(Be::IS_A_DIRECTORY)
p Be.strerror(Be::NO_MORE_FDS)
p Be.strerror(Be::CROSS_DEVICE_LINK)
p Be.strerror(Be::LINK_LIMIT)
p Be.strerror(Be::BUSTED_PIPE)
p Be.strerror(Be::UNSUPPORTED)
p Be.strerror(Be::PARTITION_TOO_SMALL)

p Be.strerror(Be::E2BIG)
p Be.strerror(Be::ECHILD)
p Be.strerror(Be::EDEADLK)
p Be.strerror(Be::EFBIG)
p Be.strerror(Be::EMLINK)
p Be.strerror(Be::ENFILE)
p Be.strerror(Be::ENODEV)
p Be.strerror(Be::ENOLCK)
p Be.strerror(Be::ENOSYS)
p Be.strerror(Be::ENOTTY)
p Be.strerror(Be::ENXIO)
p Be.strerror(Be::ESPIPE)
p Be.strerror(Be::ESRCH)
p Be.strerror(Be::EFPOS)
p Be.strerror(Be::ESIGPARM)
p Be.strerror(Be::EDOM)
p Be.strerror(Be::ERANGE)
p Be.strerror(Be::EPROTOTYPE)
p Be.strerror(Be::EPROTONOSUPPORT)
p Be.strerror(Be::EPFNOSUPPORT)
p Be.strerror(Be::EAFNOSUPPORT)
p Be.strerror(Be::EADDRINUSE)
p Be.strerror(Be::EADDRNOTAVAIL)
p Be.strerror(Be::ENETDOWN)
p Be.strerror(Be::ENETUNREACH)
p Be.strerror(Be::ENETRESET)
p Be.strerror(Be::ECONNABORTED)
p Be.strerror(Be::ECONNRESET)
p Be.strerror(Be::EISCONN)
p Be.strerror(Be::ENOTCONN)
p Be.strerror(Be::ESHUTDOWN)
p Be.strerror(Be::ECONNREFUSED)
p Be.strerror(Be::EHOSTUNREACH)
p Be.strerror(Be::ENOPROTOOPT)
p Be.strerror(Be::ENOBUFS)
p Be.strerror(Be::EINPROGRESS)
p Be.strerror(Be::EALREADY)
p Be.strerror(Be::EILSEQ)
p Be.strerror(Be::ENOMSG)
p Be.strerror(Be::ESTALE)
p Be.strerror(Be::EOVERFLOW)
p Be.strerror(Be::EMSGSIZE)
p Be.strerror(Be::EOPNOTSUPP)
p Be.strerror(Be::ENOTSOCK)

p Be.strerror(Be::ENOMEM)
p Be.strerror(Be::EACCES)
p Be.strerror(Be::EINTR)
p Be.strerror(Be::EIO)
p Be.strerror(Be::EBUSY)
p Be.strerror(Be::EFAULT)
p Be.strerror(Be::ETIMEDOUT)
p Be.strerror(Be::EAGAIN)
p Be.strerror(Be::EWOULDBLOCK)
p Be.strerror(Be::EBADF)
p Be.strerror(Be::EEXIST)
p Be.strerror(Be::EINVAL)
p Be.strerror(Be::ENAMETOOLONG)
p Be.strerror(Be::ENOENT)
p Be.strerror(Be::EPERM)
p Be.strerror(Be::ENOTDIR)
p Be.strerror(Be::EISDIR)
p Be.strerror(Be::ENOTEMPTY)
p Be.strerror(Be::ENOSPC)
p Be.strerror(Be::EROFS)
p Be.strerror(Be::EMFILE)
p Be.strerror(Be::EXDEV)
p Be.strerror(Be::ELOOP)
p Be.strerror(Be::ENOEXEC)
p Be.strerror(Be::EPIPE)

p Be.strerror(Be::STREAM_NOT_FOUND)
p Be.strerror(Be::SERVER_NOT_FOUND)
p Be.strerror(Be::RESOURCE_NOT_FOUND)
p Be.strerror(Be::RESOURCE_UNAVAILABLE)
p Be.strerror(Be::BAD_SUBSCRIBER)
p Be.strerror(Be::SUBSCRIBER_NOT_ENTERED)
p Be.strerror(Be::BUFFER_NOT_AVAILABLE)
p Be.strerror(Be::LAST_BUFFER_ERROR)

p Be.strerror(Be::MAIL_NO_DAEMON)
p Be.strerror(Be::MAIL_UNKNOWN_USER)
p Be.strerror(Be::MAIL_WRONG_PASSWORD)
p Be.strerror(Be::MAIL_UNKNOWN_HOST)
p Be.strerror(Be::MAIL_ACCESS_ERROR)
p Be.strerror(Be::MAIL_UNKNOWN_FIELD)
p Be.strerror(Be::MAIL_NO_RECIPIENT)
p Be.strerror(Be::MAIL_INVALID_MAIL)

p Be.strerror(Be::NO_PRINT_SERVER)

p Be.strerror(Be::DEV_INVALID_IOCTL)
p Be.strerror(Be::DEV_NO_MEMORY)
p Be.strerror(Be::DEV_BAD_DRIVE_NUM)
p Be.strerror(Be::DEV_NO_MEDIA)
p Be.strerror(Be::DEV_UNREADABLE)
p Be.strerror(Be::DEV_FORMAT_ERROR)
p Be.strerror(Be::DEV_TIMEOUT)
p Be.strerror(Be::DEV_RECALIBRATE_ERROR)
p Be.strerror(Be::DEV_SEEK_ERROR)
p Be.strerror(Be::DEV_ID_ERROR)
p Be.strerror(Be::DEV_READ_ERROR)
p Be.strerror(Be::DEV_WRITE_ERROR)
p Be.strerror(Be::DEV_NOT_READY)
p Be.strerror(Be::DEV_MEDIA_CHANGED)
p Be.strerror(Be::DEV_MEDIA_CHANGE_REQUESTED)
p Be.strerror(Be::DEV_RESOURCE_CONFLICT)
p Be.strerror(Be::DEV_CONFIGURATION_ERROR)
p Be.strerror(Be::DEV_DISABLED_BY_USER)
p Be.strerror(Be::DEV_DOOR_OPEN)
