#! /boot/home/config/bin/ruby -d -Ku

#
# DropHere.rb
#
# ex.)
#   env LANG='ja_JP.UTF-8' ruby DropHere.rb
#   env LANG='C' ruby DropHere.rb
#

require "to_string.rb"
require "be.so"
include Be


signature = "application/x-vnd.s_nojo-DropHere"


def _(str)
  lang = ENV["LANG"]
  return str if lang.nil?

  h = {
#       English      => Japanese(UTF-8)
        "Drop Here!" => "ここにドロップ!",
        "Drop"       => "ドロップ"
      }
  (lang.downcase == "ja_jp.utf-8") ? h[str] : str
end

class DropView < StringView
  def initialize(rect)
    super(rect, "DropView", _("Drop Here!"), FOLLOW_ALL, WILL_DRAW)

    SetFont($be_bold_font)
    SetFontSize(24)
  end

  def MessageReceived(message)
    case message.what
      when SIMPLE_DATA
        if message.WasDropped
          begin
            text, ref = nil
            path = Path.new
            message.FindRef("refs") {| ref |
              path.SetTo(ref)
              puts "path: `#{path.Path}'"
            }

          rescue NameNotFound
            message.FindData("text/plain", MIME_TYPE) {| text |
              p text
            }

          rescue NameNotFound
            message.PrintToStream
          end
        end

      when MIME_DATA
        if message.WasDropped
          text = nil
          message.FindData("text/plain", MIME_TYPE) {| text |
            p text
          }
        end

      else
        super(message)
    end
  end
end

class DropWin < Window
  def initialize
    super(Rect.new(50, 50, 250, 100), _("Drop"), TITLED_WINDOW,
          NOT_ZOOMABLE | NOT_MINIMIZABLE |
          NOT_RESIZABLE | ASYNCHRONOUS_CONTROLS)

    view = DropView.new(Bounds())
    AddChild(view)
  end

  def QuitRequested
    $be_app.PostMessage(QUIT_REQUESTED)
    return true
  end
end


Application.new(signature)

def $be_app.ReadyToRun()
  win = DropWin.new
  win.Show
end

$be_app.Run
