#! /boot/home/config/bin/ruby

#
# get_supported_suites.rb
#
# ex.)
#   ruby get_supported_suites.rb 'application/x-vnd.Be-NPOS' ...
#

require "be.so"
include Be


timeout = 2*(10**6)
ros   = Roster.new
msg   = Message.new(GET_SUPPORTED_SUITES)
reply = Message.new

ARGV.each {| signature |
  begin
    id = ros.TeamFor(signature)

  rescue Be::Error
    puts "not running (signature: `#{signature}')."
    next

  else
    reply.MakeEmpty

    msgr = Messenger.new(signature, id)
    msgr.SendMessage(msg, reply, timeout, timeout)

    puts "-- #{signature}"
    reply.FindString("suites") {| suites |
      puts " + #{suites}"
    }
    print "\n"
  end
}
