#! /boot/home/config/bin/ruby

#
# list_all_view_name.rb
#
# ex.)
#   ruby list_all_view_name.rb
#
# see --> ScriptView::FillList()
#   /boot/optional/sample-code/application_kit/Scripter
#            /ScriptWorld/ScriptView.cpp
#

require "be.so"
include Be


HUGE_TIMEOUT = 1_000_000

reply = Message.new
msg   = Message.new

ids   = Roster.new.GetAppList
ids.each {| id |
  msgr = Messenger.new(nil, id)

  # ask for App Name
  msg.MakeEmpty
  msg.what = GET_PROPERTY
  msg.AddSpecifier("Name")
  msgr.SendMessage(msg, reply, HUGE_TIMEOUT,
                               HUGE_TIMEOUT)
  begin
    name = reply.FindString("result", 0)
    puts "+ #{name}"
  rescue NameNotFound
#    puts "+ ????"
  end

  # ask for Window Count
  msg.MakeEmpty
  msg.what = COUNT_PROPERTIES
  msg.AddSpecifier("Window")
  msgr.SendMessage(msg, reply, HUGE_TIMEOUT,
                               HUGE_TIMEOUT)
  begin
    wincount = reply.FindInt32("result", 0)
  rescue NameNotFound
    next
  end

  wincount.times {| i |
    # ask for Window Title
    msg.MakeEmpty
    msg.what = GET_PROPERTY
    msg.AddSpecifier("Title")
    msg.AddSpecifier("Window", i)
    msgr.SendMessage(msg, reply, HUGE_TIMEOUT,
                                 HUGE_TIMEOUT)
    begin
      name = reply.FindString("result", 0)
      puts "  + #{name}"
    rescue NameNotFound
#      puts "  + ????"
    end

    # ask for View Count
    msg.MakeEmpty
    msg.what = COUNT_PROPERTIES
    msg.AddSpecifier("View")
    msg.AddSpecifier("Window", i)
    msgr.SendMessage(msg, reply, HUGE_TIMEOUT,
                                 HUGE_TIMEOUT)
    begin
      viewcount = reply.FindInt32("result", 0)
    rescue NameNotFound
      next
    end

    viewcount.times {| j |
      # ask for View InternalName
      msg.MakeEmpty
      msg.what = GET_PROPERTY
      msg.AddSpecifier("InternalName")
      msg.AddSpecifier("View", j)
      msg.AddSpecifier("Window", i)
      msgr.SendMessage(msg, reply, HUGE_TIMEOUT,
                                   HUGE_TIMEOUT)
      begin
        name = reply.FindString("result", 0)
        puts "    + #{name}"
      rescue NameNotFound
      end
    }
  }
}
