#! /boot/home/config/bin/ruby -d

#
# list_translate.rb
#
# similar `translate --list'
#

require "to_string.rb"
require "be.so"
include Be


def print_fmts(fmts)
  fmts.each {| fmt |
    printf("`%s' (%s) %1.1f %1.0f %s ; %s\n",
           fmt["type"].to_string,
           fmt["group"].to_string,
           fmt["quality"],
           fmt["capability"],
           fmt["MIME"],
           fmt["name"])
  }
end


tr = TranslatorRoster.Default
ids = tr.GetAllTranslators

ids.each {| id |
  name, info, ver = tr.GetTranslatorInfo(id)
  puts "Translator #{name} version #{ver.to_f/100.0}"
  puts "#{info}"

  fmts = tr.GetInputFormats(id)
  puts "inputs: #{fmts.length}"
  print_fmts(fmts)

  fmts = tr.GetOutputFormats(id)
  puts "outputs: #{fmts.length}"
  print_fmts(fmts)

  print "\n"
}

