#! /boot/home/config/bin/ruby -d

#
# listattr.rb
#
# similar `listattr'
#
# ex.)
#   ruby listattr.rb '/boot/beos/documentation/Welcome_To_BeOS.html' ...
#

require "to_string.rb"
require "be.so"
include Be


ARGV.each {| path |
  puts "file `#{path}'"

  File.open(path) {| f |
    fd = f.fileno

    attrNames = []
    fs_fopen_attr_dir(fd) {| dir |
      dir.read {| dirent |
        attrNames << dirent["d_name"]
      }
    }

    print <<-INFO
       Type             Size                 Name
-------------------  ---------   -------------------------------
    INFO

    attrNames.each {| name |
      attr_info = fs_stat_attr(fd, name)

      type = attr_info["type"]
      printf("%#x (`%s')  %9d   %31s\n",
             type,
             type.to_string,
             attr_info["size"],
             name)
    }
  }
}
