#! /boot/home/config/bin/ruby -d -Ku

#
# watcher_clipboard.rb
#
# ex.)
#   ruby watcher_clipboard.rb
#

require "be.so"
include Be


Application.new("application/x-vnd.s_nojo-watcher_clipboard")

def $be_app.MessageReceived(message)
  case message.what
    when CLIPBOARD_CHANGED
      $be_clipboard.Lock {
        clip = $be_clipboard.Data
        clip.PrintToStream if not clip.nil?
      }

    else
      super(message)
  end
end

win = Window.new(Rect.new(100, 80, 260, 120),
                 "clipboard_watcher.rb",
                 TITLED_WINDOW,
                 NOT_RESIZABLE | NOT_ZOOMABLE)

def win.QuitRequested
  $be_app.PostMessage(QUIT_REQUESTED)
  return true
end

win.Show()

begin
  $be_clipboard.StartWatching($be_app_messenger)
  $be_app.Run

ensure
  $be_clipboard.StopWatching($be_app_messenger)
end
